#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;

#define ll long long
#define pr pair<ll,ll>

bool cmp(pr a, pr b){
    if(a.second != b.second) return a.second > b.second;
    return a.first > b.first;
}

void solve(){
    ll n, m, q;
    cin >> n >> m >> q;

    vector<pr> works(n);
    vector<ll> eps(m);
    vector<ll> ts(q);
    for(int i = 0; i < n; i++) cin >> works[i].first;
    for(int i = 0; i < n; i++) cin >> works[i].second;
    for(int i = 0; i < m; i++) cin >> eps[i];
    for(int i = 0; i < q; i++) cin >> ts[i];

    sort(works.begin(), works.end(), cmp);

    ll curTime = LLONG_MAX;
    for(int i = 0; i < n; i++){
        if(works[i].second <= curTime){
            curTime = works[i].second-works[i].first;
        }else{
            works[i].second = curTime;
            curTime = works[i].second-works[i].first;
        }
        works[i].second-=works[i].first;
    }

    reverse(works.begin(),works.end());

    curTime = 0;
    int workInd = 0;
    vector<ll> epTimes(m);
    for(int i = 0; i < m; i++){
        while(workInd < n && works[workInd].second-curTime < eps[i]){
            curTime += works[workInd].first;
            workInd++;
        }
        curTime+=eps[i];
        epTimes[i]=curTime;
    }

    for(int i = 0; i < q; i++){
        int s = 0;
        int e = m-1;
        int md;
        int res = -1;
        while(s<=e){
            md = (s+e)/2;
            if(epTimes[md] <= ts[i]){
                res = md;
                s=md+1;
            }else{
                e=md-1;
            }
        }
        cout << (res+1) << " ";
    }
    cout << endl;
}

int main(){
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    while(T--) solve();

    return 0;
}