#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>

using namespace std;
using ll = long long;

typedef vector<int> VI;
typedef vector<VI> VVI;

int n;
VI op, indeg;
VVI gp;

void solve() {
	cin >> n;
	op = VI(n);
	for (int i = 0; i < n; i++) {
		string s, t;
		cin >> s >> t;
		if (s + t == "settrue") op[i] = 2;
		else if (s + t == "setfalse") op[i] = 0;
		else if (s + t == "unsettrue") op[i] = 3;
		else op[i] = 1;
	}
	indeg = VI(n);
	gp = VVI(n);
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		indeg[v]++;
		gp[u].push_back(v);
	}
	queue<int> qset;
	queue<int> qunset;
	queue<int> qsettrue;
	queue<int> qunsettrue;
	for (int i = 0; i < n; i++) {
		if (indeg[i] == 0) {
			if (op[i] == 0) qset.push(i);
			else if (op[i] == 1) qunset.push(i);
			else if (op[i] == 2) qsettrue.push(i);
			else if (op[i] == 3) qunsettrue.push(i);
		}
	}

	VI ans;

	auto pop = [&](int u) {
		ans.push_back(u);
		for (int i : gp[u]) {
			indeg[i]--;
			if (indeg[i] == 0) {
				if (op[i] == 0) qset.push(i);
				else if (op[i] == 1) qunset.push(i);
				else if (op[i] == 2) qsettrue.push(i);
				else if (op[i] == 3) qunsettrue.push(i);
			}
		}
	};

	while (qunset.size()) {
		int u = qunset.front();
		qunset.pop();
		pop(u);
	}
	
	if (ans.size() == n) goto answer;
	if (qsettrue.size() == 0) {
		cout << -1 << endl;
		return;
	}
	else {
		pop(qsettrue.front());
	}

	while (qset.size()) {
		int u = qset.front();
		qset.pop();
		pop(u);
	}

	if (ans.size() == n) goto answer;
	if (qunsettrue.size() == 0) {
		cout << -1 << endl;
		return;
	}
	else {
		pop(qunsettrue.front());
	}

	while (qunset.size()) {
		int u = qunset.front();
		qunset.pop();
		pop(u);
	}

answer:
	if (ans.size() == n) {
		for (int x : ans) cout << x + 1 << " "; cout << endl;
	}
	else cout << -1 << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	//cin >> t;
	while (t--) solve();

}
