#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> graph;
vector<int> order;
vector<int> visited;

void dfs(int u) {
    visited[u] = true;
    for (int v : graph[u]) {
        if (!visited[v]) {
            dfs(v);
        }
    }
    order.push_back(u);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> plus(n);
    bool has_plus = false;
    int plus_star = -1, minus_star = -1;
    for (int i = 0; i < n; ++i) {
        string s, t;
        cin >> s >> t;
        if (s == "set") {
            has_plus = true;
            plus[i] = 1;
        } else {
            assert(s == "unset");
            plus[i] = 0;
        }
        if (t == "true") {
            if (plus[i]) {
                assert(plus_star == -1);
                plus_star = i;
            } else {
                assert(minus_star == -1);
                minus_star = i;
            }
        }
    }
    int m;
    cin >> m;
    graph.resize(n);
    visited.resize(n);

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
    }

    if (has_plus && plus_star == -1) {
        cout << "-1\n";
        return 0;
    }
    if (minus_star != -1 && !has_plus) {
        cout << "-1\n";
        return 0;
    }

    if (plus_star != -1) {
        for (int i = 0; i < n; ++i) {
            if (i == plus_star) continue;
            if (plus[i]) {
                graph[plus_star].push_back(i);
            }
        }
    }
    if (minus_star != -1) {
        for (int i = 0; i < n; ++i) {
            if (i == minus_star) continue;
            if (plus[i]) {
                graph[i].push_back(minus_star);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!visited[i]) {
            dfs(i);
        }
    }
    reverse(order.begin(), order.end());


    vector<int> position(n);
    for (int i = 0; i < n; ++i) {
        position[order[i]] = i;
    }

    for (int i = 0; i < n; ++i) {
        for (int u : graph[i]) {
            if (position[u] < position[i]) {
                cout << "-1\n";
                return 0;
            }
        }
    }


    vector<int> minus;
    vector<int> removed(n);

    for (int i = 0; i < n; ++i) {
        int v = order[i];
        if (minus_star != -1 && v == minus_star) {
            break;
        }
        if (plus[v] == false) {
            minus.push_back(v);
            removed[i] = true;
        }
    }

    vector<int> new_order = minus;
    for (int i = 0; i < n; ++i) {
        if (removed[i]) continue;
        new_order.push_back(order[i]);
    }


    position.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        position[new_order[i]] = i;
    }

    for (int i = 0; i < n; ++i) {
        for (int u : graph[i]) {
            if (position[u] < position[i]) {
                cout << "-1\n";
                return 0;
            }
        }
    }

    for (int x : new_order) {
        cout << x + 1 << ' ';
    }
    cout << '\n';








    return 0;
}
