#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;

#define ll long long

bool op(char c) {
    if (c == '-' || c == '+' || c == '=')
        return true;
    return false;
}

bool numb(char c) {
    if (c >= '0' && c <= '9')
        return true;
    return false;
}

ll calculate (string s) {
    ll result = 0;
    int n = s.size();
    char op = '#';
    ll cur = 0;
    for (int i = 0; i < n; ++i) {
        int j = i;
        cur = 0;
        while (j < n && numb(s[j])) {
            cur = cur * 10 + (s[j] - '0');
            ++j;
        }
        if (op == '#' || op == '+')
            result += cur;
        else if (op == '-')
            result -= cur;
        if (j < n)
            op = s[j];
        i = j;
    }

    return result;
}

bool evaluate(string s) {
    int n = s.size();
    string s1 = "", s2 = "";
    int k = 0;
    while(s[k] != '=') {
        s1 += s[k];
        ++k;
    }
    ++k;
    while(k < n) {
        s2 += s[k];
        ++k;
    }
    ll res1 = calculate(s1);
    ll res2 = calculate(s2);
//    cout << s1 << "   " << s2 << "\n";
//    cout << "result1 = " << res1 << "\n";
//    cout << "result2 = " << res2 << "\n";
    if (res1 == res2)
        return true;
    return false;
}

bool check(string s) {
    int n = s.size();
    if (s[0] == '0' && numb(s[1]))
        return false;
    if (op(s[0]) || op(s[n - 1]))
        return false;
    for (int i = 0; i < n; ++i) {
        if (op(s[i]) && i + 1 < n && op(s[i + 1]))
            return false;
        if (op(s[i]) && s[i + 1] == '0' && i + 2 < n && numb(s[i + 2]))
            return false;
    }

    ll cur = 0;
    for (int i = 0; i < n; ++i) {
        int j = i;
        cur = 0;
        int size = 0;
        while (j < n && numb(s[j])) {
            cur = cur * 10 + (s[j] - '0');
            ++size;
            ++j;
        }
        if (size > 10)
            return false;
        i = j;
    }

    return true;
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
//    cout << check(s) << "\n";
//    cout << evaluate(s) << "\n";
    if (evaluate(s)) {
        cout << "Correct\n";
        return;
    }
    for (int i = 0; i < n; ++i) {
        string t = s;
        int j = i;
        if (!numb(s[i]))
            continue;
        while (j > 0) {
            swap(t[j], t[j - 1]);
            if (check(t) && evaluate(t)) {
                cout << t << "\n";
                return;
            }
            --j;
        }
        j = i;
        t = s;
        while (j < n - 1) {
            swap(t[j], t[j + 1]);
            if (check(t) && evaluate(t)) {
                cout << t << "\n";
                return;
            }
            ++j;
        }
    }

    cout << "Impossible\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
