#include <bits/stdc++.h>
using namespace std;

#define SQT 0.70710678118654752438189403651591646848828531801700592041015625l

#define len(a) ((int)(a).size())

struct pt {
    long long x, y, u, v;

    pt operator+(const pt& p) const { return {x + p.x, y + p.y, u + p.u, v + p.v}; }
    pt operator-(const pt& p) const { return {x - p.x, y - p.y, u - p.u, v - p.v}; }
    pt operator*(long long d) const { return {x * d, y * d, u * d, v * d}; }

    bool operator<(const pt& p) const {
        long double i = x + (u - v) * SQT;
        long double j = p.x + (p.u - p.v) * SQT;
        if(i == j){
            i = y + (u + v) * SQT;
            j = p.y + (p.u + p.v) * SQT;
            return i < j;
        }
        return i < j;
    }
    bool operator==(const pt& p) const { return x == p.x && y == p.y && u == p.u && v == p.v; }

    void rotate45(){
        long long temp = v;
        v = y;
        y = u;
        u = x;
        x = -temp;
    }
};

void print(pt& p){
    cout << "{" << p.x << " " << p.y << " " << p.u << " " << p.v << "}\n";
}

//constexpr int N = 5e4 + 5;
int n;
vector<pair<pt, pt>> vec;

void solve(){
    cin >> n;

    pt cur = {0, 0, 0, 0};
    pt dir = {1, 0, 0, 0};

    string comm;
    long long val;
    for(int i = 0; i < n; i++){
        cin >> comm;
        cin >> val;
        if(comm == "draw"){
            vec.push_back({cur, cur + dir * val});
            cur = cur + dir * val;
            continue;
        }
        if(comm == "rotate"){
            for(long long j = 45; j <= val; j += 45){
                dir.rotate45();
            }
            continue;
        }
        cur = cur + dir * val;
    }

    for(int i = 0; i < len(vec); i++){
        if(vec[i].second < vec[i].first) swap(vec[i].first, vec[i].second);
    }
    sort(vec.begin(), vec.end());

//    for(int i = 0; i < len(vec); i++){
//        print(vec[i].first);
//        print(vec[i].second);
//        cout << "\n";
//    }

    vector<pair<pt, pt>> rvec(vec);

    for(int ang = 45; ang < 360; ang += 45){
        for(int i = 0; i < len(rvec); i++){
            rvec[i].first.rotate45();
            rvec[i].second.rotate45();
            if(rvec[i].second < rvec[i].first) swap(rvec[i].first, rvec[i].second);
        }
        sort(rvec.begin(), rvec.end());
        pt diff = rvec[0].first - vec[0].first;
        bool ok = true;
        for(int i = 0; i < len(rvec); i++){
            if(rvec[i].first - vec[i].first != diff || rvec[i].second - vec[i].second != diff){
                ok = false;
                break;
            }
        }
        if(ok){
            cout << ang << "\n";
            return;
        }
    }
    cout << "360\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cout.precision(128);
    cout << fixed;

    solve();
    return 0;
}
