private fun LongArray.lowerBound(x: Long) = binarySearch(x).let { if (it < 0) it.inv() else it }
private fun LongArray.upperBound(x: Long) = binarySearch(x).let { if (it < 0) it.inv() else (it+1) }

private fun solve() {
    val (n, m, q) = readInts()
    val a = readInts().toIntArray()
    val d = readLongs().toLongArray()
    val l = readLongs().runningReduce(Long::plus).toLongArray()
    val qs = readLongs().toLongArray()

    val startTimes = LongArray(n + 1) { Long.MAX_VALUE }
    val endTimes = LongArray(n + 1) { Long.MAX_VALUE }
    val totalTaskLength = LongArray(n + 1)
    var last = Long.MAX_VALUE
    var index = n - 1
    for (task in d.indices.sortedByDescending { d[it] }) {
        last = minOf(last, d[task]) - a[task]
        totalTaskLength[index + 1] = a[task].toLong()
        endTimes[index] = last + a[task]
        startTimes[index] = last
        index--
    }
    for (i in 1..n) {
        totalTaskLength[i] += totalTaskLength[i - 1]
    }
    val results = qs.map {
        val tasksBefore = endTimes.lowerBound(it)
        val timeToWatch = minOf(it, startTimes[tasksBefore]) - totalTaskLength[tasksBefore]
        l.upperBound(timeToWatch)
    }
    println(results.joinToString(" "))
}

fun main() {
    repeat(readInt()) {
        solve()
    }
}

private fun readInt() = readln().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readln().split(" ")
private fun readInts() = readStrings().map { it.toInt() }