//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

struct Job {
  ll t, d;
};

void solveTest() {
  int n, m, q;
  cin >> n >> m >> q;
  vector<Job> jobs(n);
  for (int i = 0; i < n; ++i) {
    cin >> jobs[i].t;
  }
  for (int i = 0; i < n; ++i) {
    cin >> jobs[i].d;
  }
  sort(jobs.begin(), jobs.end(), [&](Job x, Job y) {
    return x.d > y.d;
  });
  vector<ll> lens(m);
  for (auto& x : lens) {
    cin >> x;
  }
  ll last = 1e18;
  vector<pair<ll, ll>> times;
  for (auto[t, d] : jobs) {
    ll end = min(last, d);
    times.emplace_back(end - t, end);
    last = end - t;
  }
  assert(last >= 0);
  sort(times.begin(), times.end());
  vector<ll> prefTime(n + 1);
  for (int i = 0; i < n; ++i) {
    prefTime[i + 1] = prefTime[i] + times[i].second - times[i].first;
  }
  vector<ll> prefWatch(m + 1);
  for (int i = 0; i < m; ++i) {
    prefWatch[i + 1] = prefWatch[i] + lens[i];
  }
  while (q--) {
    ll t; cin >> t;
    int i = lower_bound(times.begin(), times.end(), make_pair(t, 0ll)) - times.begin();
    ll used = prefTime[i];
    if (i > 0 && times[i - 1].second >= t) {
      used -= times[i - 1].second - t;
    }
    ll left = t - used;
    assert(left >= 0);
    cout << max(0, int(upper_bound(prefWatch.begin(), prefWatch.end(), left) - prefWatch.begin()) - 1) << " ";
  }
  cout << "\n";
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int tests_;
  cin >> tests_;
  for (int tt_ = 1; tt_ <= tests_; ++tt_) {
    solveTest();
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
