#include <bits/stdc++.h>

/**
 * Author: Niyaz Nigmatullin
 *
 */

using namespace std;

string to_string(string s) {
  return '"' + s + '"';
}

string to_string(const char* s) {
  return to_string((string) s);
}

string to_string(bool b) {
  return (b ? "true" : "false");
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
  return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A v) {
  bool first = true;
  string res = "{";
  for (const auto &x : v) {
    if (!first) {
      res += ", ";
    }
    first = false;
    res += to_string(x);
  }
  res += "}";
  return res;
}

void debug_out() { cerr << endl; }

template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
  cerr << " " << to_string(H);
  debug_out(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif


vector<int> readInts(int n) {
	vector<int> a(n);
	for (int &x: a) {
		cin >> x;
		if (x >= 0) x--;
	}
	return a;
}

void solve() {
	
	int n;
	cin >> n;
	auto p1 = readInts(n);
	auto p2 = readInts(n);
	int m;
	cin >> m;
	auto d1 = readInts(m);
	auto d2 = readInts(m);
	vector<int> used(n);
	for (int &x: d1) if (x >= 0) used[x] = true;
	vector<int> canWith(n);
	vector<int> canWithout(n);
	function<void(int, int)> go = [&](int posD, int pos) {
		while (posD < m && d1[posD] >= 0) {
			while (pos < n && p1[pos] != d1[posD]) {
				if (used[p1[pos]]) {
					return;
				}
				++pos;
			}
			assert(pos < n);
			posD++;
			pos++;
		}
		if (posD == m) {
			vector<int> s2;
			for (int &x: p2) {
				if (used[x]) s2.push_back(x);
			}
			bool bad = false;
			for (int i = 0; i < m; i++) {
				if (d2[i] >= 0 && d2[i] != s2[i]) {
					bad = true;
					break;
				}
			}
			if (!bad) {
				for (int i = 0; i < n; i++) {
					if (used[i]) {
						canWith[i] = true;
					} else {
						canWithout[i] = true;
					}
				}
			}
			return;
		}
		for (int x = pos; x < n; x++) {
			if (used[p1[x]]) {
				break;
			}
			used[p1[x]] = true;
			go(posD + 1, x + 1);
			used[p1[x]] = false;
		}
	};
	go(0, 0);
	bool exists = false;
	for (int i = 0; i < n; i++) {
		if (canWith[i]) {
			exists = true;
			break;
		}
	}
	if (!exists) {
		cout << "Inconsistent" << endl;
	} else {
		for (int i = 0; i < n; i++) {
			if (!canWith[i]) {
				cout << 'N';
			} else if (canWithout[i]) {
				cout << '?';
			} else {
				cout << 'Y';
			}
		}
		cout << endl;
	}
}

int main() {
	std::cin.tie(NULL); std::ios::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--) solve();
}
