#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <functional>

using namespace std;

vector<bool> slv(int l1, int x1, int dx1, int l2, int x2, int dx2, int L) {
	vector<bool> b;
	int cx1 = x1, cx2 = x2;
	int idx1 = dx1, idx2 = dx2;
	do {
		b.push_back(cx1 < cx2 + l2 && cx2 < cx1 + l1);
		if (cx1 == 0 || cx1 + l1 == L) dx1 = -dx1;
		if (cx2 == 0 || cx2 + l2 == L) dx2 = -dx2;
		cx1 += dx1;
		cx2 += dx2;
	} while(cx1 != x1 || cx2 != x2 || dx1 != idx1 || dx2 != idx2);
	return b;
}

void solve(int test_ind){
	int W, H;
	cin >> W >> H;
	int w1, h1, x1, y1, dx1, dy1;
	cin >> w1 >> h1 >> x1 >> y1 >> dx1 >> dy1;
	int w2, h2, x2, y2, dx2, dy2;
	cin >> w2 >> h2 >> x2 >> y2 >> dx2 >> dy2;
	vector<bool> v1 = slv(w1, x1, dx1, w2, x2, dx2, W);
	vector<bool> v2 = slv(h1, y1, dy1, h2, y2, dy2, H);
	// for (auto i: v1) cerr << i << " "; cerr << endl;
	// for (auto i: v2) cerr << i << " "; cerr << endl;
	int g = __gcd(v1.size(), v2.size());
	vector<int> vv1(g), vv2(g);
	for (int i=0;i<(int)v1.size();++i) {
		vv1[i%g] += v1[i];
	}
	for (int i=0;i<(int)v2.size();++i) {
		vv2[i%g] += v2[i];
	}
	long long num = 0;
	for (int i=0;i<g;++i) {
		num += vv1[i] * 1ll * vv2[i];
	}
	long long denom = (int)v1.size() / g * 1ll * (int)v2.size();
	g = __gcd(num, denom);
	num /= g;
	denom /= g;
	cout << num << "/" << denom << endl;
}

int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int t=1;
	cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
