#include <bits/stdc++.h>

using namespace std;

template <typename T_container, typename T = typename enable_if
        <!is_same<T_container, string>::value, typename
        T_container::value_type>::type>
ostream& operator<<(ostream &os, const T_container &v){
    os << '{';
    string sep;
    for (const T &x:v){
        os << sep << x;
        sep = ", ";
    }
    return os << '}';
}

void dbg_out(){cerr<<endl;}
template <typename Head, typename... Tail> void dbg_out(Head H
        ,Tail... T){cerr<<' '<<H; dbg_out(T...);}

#define dbg(...) dbg_out(__VA_ARGS__)
#define pi pair<int, int>
#define pb push_back
#define ft first
#define sd second
#define all(x) (x).begin(), (x).end()

//#define TEST_CASES
#define vt vector

void solve() {
    int n;
    cin >> n;
    vector<pi> op(n);
    vector<vector<int>> cnt(2, vector<int> (2));
    for (int i = 0; i < n; i++) {
        string s, t; cin >> s >> t;
        int val = t[0] == 't';
        if (s[0] == 's') {
            op[i] = {1, val};
            cnt[1][val]++;
        } else {
            op[i] = {0, val};
            cnt[0][val]++;
        }
    }
    //set = 1, unset = 0
    int m; cin >> m;
    vector<vector<int>> e(n);
    vector<int> in(n);
    for (int i = 0; i < m; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        e[u].pb(v);
        in[v]++;
    }
    vector<int> ts;
    vector<bool> vis(n, false);
    function<void(int)> dfs = [&](int f) {
        vis[f] = true;
        for (int to : e[f]) {
            if (!vis[to]) {
                dfs(to);
            }
        }
        ts.pb(f);
    };
    for (int i = 0; i < n; i++) {
        if (!vis[i]) {
            dfs(i);
        }
    }
    reverse(all(ts));
    if (!cnt[1][1]) {
        if (cnt[0][1] || cnt[1][0]) {
            cout << -1;
            return;
        }
        for (int i = 0; i < n; i++) {
            cout << ts[i] + 1 << ' ';
        }
        return;
    }
    fill(all(vis), false);
    queue<int> que;
    for (int i = 0; i < n; i++) {
        if (!in[i] && op[i].ft == 0 && op[i].sd == 0) {
            que.push(i);
            vis[i] = true;
        }
    }
    vector<int> ans;
    while (!que.empty()) {
        int v = que.front();
        ans.pb(v);
        que.pop();
        for (int to : e[v]) {
            in[to]--;
            if (!in[to] && op[to].ft == 0 && op[to].sd == 0) {
                que.push(to);
                vis[to] = true;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (op[i].ft == 1 && op[i].sd == 1) {
            ans.pb(i);
            vis[i] = true;
            for (int to : e[i]) {
                in[to]--;
            }
            break;
        }
    }
    for (int i = 0; i < n; i++) {
        if (!vis[i] && !in[i] && op[i].ft == 1 && op[i].sd == 0) {
            que.push(i);
            vis[i] = true;
        }
    }
    while (!que.empty()) {
        int v = que.front();
        ans.pb(v);
        que.pop();
        for (int to : e[v]) {
            in[to]--;
            if (!in[to] && op[to].ft == 1 && op[to].sd == 0) {
                que.push(to);
                vis[to] = true;
            }
        }
    }
    bool found = false;
    for (int i = 0; i < n; i++) {
        if (op[i].ft == 0 && op[i].sd == 1) {
            ans.pb(i);
            vis[i] = true;
            for (int to : e[i]) {
                in[to]--;
            }
            found = true;
            break;
        }
    }
    if (found) {
        for (int i = 0; i < n; i++) {
            if (!vis[i] && !in[i] && op[i].ft == 0 && op[i].sd == 0) {
                que.push(i);
                vis[i] = true;
            }
        }
        while (!que.empty()) {
            int v = que.front();
            ans.pb(v);
            que.pop();
            for (int to : e[v]) {
                in[to]--;
                if (!in[to] && op[to].ft == 0 && op[to].sd == 0) {
                    que.push(to);
                    vis[to] = true;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!vis[i]) {
            cout << -1;
            return;
        }
    }
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
#ifdef TEST_CASES
    cin >>tt;
#endif
    while(tt--)
        solve();
    return 0;
}
