#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long
#define ll long long
#define sz(x) x.begin(), x.end()

using namespace std;


int dx[] = {0, 1, 1, 1, 0, -1, -1, -1};
int dy[] = {1, 1, 0, -1, -1, -1, 0, 1};
struct point{
    vector<int> x, y;
    point(){
        x.resize(2);
        y.resize(2);
    }

    bool operator<(const point& other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
    bool operator==(const point& other) const {
        return tie(x, y) == tie(other.x, other.y);
    }
};

struct line
{
    point A, B;

    bool operator<(const line& other) const {
        return tie(A, B) < tie(other.A, other.B);
    }
};
line gx(point A, point B){
    if (B < A) {
        swap(A, B);
    }
    return {A, B};
}
void print(point A){
    cout << A.x[0] << ' ' << A.x[1] << ' '<< A.y[0] << ' ' << A.y[1] << ":";
}
void print(line A){
    cout << "P = ";
    print(A.A);print(A.B);
    cout << '\n';
}
vector < line > getPic(vector < pair< string , int > > ops, int ang){
    ang = (ang + 8)%8;
    point A;
    vector < pair<line, int> > res;
    for(auto [t, d]: ops){
        //print(A); cout << endl;
        if(t[0] == 'r'){
            d /= 45;
            ang = (ang - d + 8) % 8;
        }
        else if(t[0] == 'd'){
            auto B = A;
            B.x[ang&1] += d * dx[ang];
            B.y[ang&1] += d * dy[ang];
            res.push_back({gx(A,B), ang % 4});
            A = B;
        }
        else{
            A.x[ang&1] += d * dx[ang];
            A.y[ang&1] += d * dy[ang];
        }
    }
    sort(all(res));
    vector<pair<line, int>> new_res;
    for (auto& [l, ang] : res) {
        bool ok = false;
        for (auto& [nl, nang] : new_res) {
            if (ang != nang) continue;
            if (l.A == nl.B) {
                nl.B = l.B;
                ok = true;
                break;
            }
        }
        if (!ok) {
            new_res.push_back({l, ang});
        }
    }
    //print(A); cout << endl;
    vector<line> ret;
    for (auto [l, _] : new_res) {
        ret.push_back(l);
    }
    return ret;
}
vector < line > rt(vector < line > in, point P){
    for(int i = 0; i < in.size(); i++){
        in[i].A.x[0] -= P.x[0];
        in[i].A.x[1] -= P.x[1];
        in[i].A.y[0] -= P.y[0];
        in[i].A.y[1] -= P.y[1];

        in[i].B.x[0] -= P.x[0];
        in[i].B.x[1] -= P.x[1];
        in[i].B.y[0] -= P.y[0];
        in[i].B.y[1] -= P.y[1];
    }
    //for(auto x: in)
    //    print(x);
    //cout << "end\n";
    return in;
}

bool eq(vector<line> A, vector <line> B){
    int n = A.size();
    for(int i = 0; i < n; i++){
      //  print(A[i]);
       // print(B[i]);
        if(A[i].A.x != B[i].A.x)
            return false;
        if(A[i].A.y != B[i].A.y)
            return false;

        if(A[i].B.x != B[i].B.x)
            return false;
        if(A[i].B.y != B[i].B.y)
            return false;
    }
    return true;
}
void solve() {
    int n;
    cin >> n;
    vector<pair<string, int>> ops;
    for(int i = 0; i < n; i++){
        string type;
        int d;
        cin >> type >> d;
        if (type == "rotate") {
            if (d == 360) continue;
        }
        ops.push_back({type, d});
    }
    vector < line > in = getPic(ops, 0);
    sort(in.begin(), in.end());
    in = rt(in, in[0].A);
    for(int ang = -1, ans = 45; ang >= -8; ang--, ans += 45){
        auto vc = getPic(ops, ang);
        sort(vc.begin(), vc.end());
        
        for(int i = 0; i < vc.size(); i++){
            if(eq(rt(vc, vc[i].A) , in)){
                cout << ans;
                return;
            }
            if(eq(rt(vc, vc[i].B), in)){
                cout << ans;
                return;
            }
        }
    }
}

 main() {    
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
}