#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define ll long long
#define sz(x) x.begin(), x.end()

using namespace std;

typedef pair<int, int> pii;

const int N = 2e5 + 5;

vector<int> g[N];
int a[N];
int deg[N];
int parent[N];
bool killed[N];
vector<int> g2[N];
bool cover[N];
set<int> pos[N];

bool used[N];

void dfs1(int v, vector<int>& comp) {
    used[v] = true;
    comp.push_back(v);
    for (int u : g2[v]) {
        if (!used[u]) {
            dfs1(u, comp);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    int m = n;
    n *= 2;

    for (int i = 1; i <= n; ++i) {
        g[i].clear();
        deg[i] = 0;
        killed[i] = false;
        g2[i].clear();
        cover[i] = false;
        pos[i].clear();
        used[i] = false;
    }

    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pos[a[i]].insert(i);
    }
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        ++deg[v];
        ++deg[u];
    }
    
    queue<int> q;
    for (int v = 1; v <= n; ++v) {
        if (deg[v] == 1) {
            q.push(v);
        }
    }

    vector<pii> matching;
    map<int, int> match;

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        int p = -1;
        for (int u : g[v]) {
            if (!killed[u]) {
                p = u;
            }
        }
        if (p == -1) {
            continue;
        }
        killed[v] = true;
        killed[p] = true;
        match[v] = p;
        match[p] = v;
        matching.emplace_back(v, p);
        for (int u : g[p]) {
            if (!killed[u]) {
                --deg[u];
                if (deg[u] == 1) {
                    q.push(u);
                }
            }
        }
    }

    for (auto [x, y] : matching) {
        cover[x] = true;
        cover[y] = true;
        g2[a[x]].push_back(a[y]);
        g2[a[y]].push_back(a[x]);
    }

    for (int x = 1; x <= m; ++x) {
        if (used[x]) continue;
        if (g2[x].size() == 1) {
            vector<int> path;
            dfs1(x, path);
            int y = path.back();
            int X = -1, Y = -1;
            {
                int u = *pos[x].begin();
                int v = *++pos[x].begin();
                assert(cover[u] ^ cover[v]);
                if (!cover[u]) {
                    X = u;
                } else {
                    X = v;
                }
            }
            {
                int u = *pos[y].begin();
                int v = *++pos[y].begin();
                assert(cover[u] ^ cover[v]);
                if (!cover[u]) {
                    Y = u;
                } else {
                    Y = v;
                }
            }
            matching.emplace_back(X, Y);
            match[X] = Y;
            match[Y] = X;
        }
    }

    for (auto [x, y] : matching) {
        //cout << x << ' ' << y << endl;
    }

    vector<pii> output;

    for (auto [x, y] : matching) {
        while (a[x] != a[y]) {
            int u = *pos[a[x]].begin();
            int v = *++pos[a[x]].begin();
            //cout << x << ' ' << y << ' ' << a[x] << ' ' << a[y] << ' ' << u << ' ' << v << endl;
            assert(x == u || x == v);
            int z = x ^ u ^ v;
            output.push_back({y, z});
            pos[a[y]].erase(y);
            pos[a[z]].erase(z);
            swap(a[z], a[y]);
            pos[a[y]].insert(y);
            pos[a[z]].insert(z);
            assert(a[x] == a[y]);
            x = match[z];
            y = z;
        }
    }

    cout << output.size() << '\n';
    for (auto [x, y] : output) {
        cout << x << ' ' << y << '\n';
    }
}

int main() {    
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--)
        solve();
}