#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
void __print(int x){cerr << x;}
void __print(long x){cerr << x;}
void __print(long long x){cerr << x;}
void __print(long double x){cerr << x;}
void __print(unsigned x){cerr << x;}
void __print(unsigned long x){cerr << x;}
void __print(unsigned long long x){cerr << x;}
void __print(float x){cerr << x;}
void __print(double x){cerr << x;}
void __print(char x){cerr <<'\'' <<  x << '\'';}
void __print(const char *x){cerr <<'\"' <<  x << '\"';}
void __print(const string &x){cerr <<'\"' <<  x << '\"';}
void __print(bool x){cerr << (x ? "true":"false");}

template<typename T,typename V> 
void __print(const pair<T,V> &x){ cerr << "{";  __print(x.first); cerr<<","; __print(x.second); cerr << "}"; }
template<typename T>
void __print(const T &x){ int f = 0; cerr << "{"; for(auto &i:x) cerr << (f++ ? ",":""),__print(i); cerr << "}";}
void _print(){cerr << "]\n";}
template<typename T,typename ... V>
void _print(T t,V... v){__print(t);if(sizeof...(v)) cerr << ", ";_print(v...);}
#define debug(x...) cerr << "[" << #x << "] = [";_print(x);
#ifndef LOCAL
    #define debug(x...) 42
#endif
#define all(x) (x).begin(),(x).end()

const ld PI = 3.141592653589793;
const int MOD = 1e9 + 7;
const int INF = 1e9;
const ll INFLL = 4e18;
const double EPS = 1e-9;
const int MAXN = 1000*1007;

void solve(int NT){
    int n; cin >> n;
    
    vector<int> vals(2 * n + 1);
    vector<vector<int>> v(n + 1);
    for(int i = 1; i <= 2 * n; ++i) {
        cin >> vals[i];
        v[vals[i]].emplace_back(i);
    }

    vector<vector<int>> g(2 * n + 1);
    for(int i = 1; i < 2 * n; ++i) {
        int x, y; cin >> x >> y;
        g[x].emplace_back(y);
        g[y].emplace_back(x);
    }
    
    int cur = 0;
    vector<int> gr(2 * n + 1, -1);
    vector<vector<int>> lst;

    auto dfs = [&](auto&& dfs, int x, int p = 0) -> void {
        for(int z: g[x]) {
            if(z != p) {
                dfs(dfs, z, x);

                if(gr[z] == -1 && gr[x] == -1) {
                    lst.emplace_back();
                    lst.back().emplace_back(x);
                    lst.back().emplace_back(z);
                    gr[x] = gr[z] = cur++;
                }

            }
        }
    };
    
    dfs(dfs, 1);

    auto get_second = [&](int x) -> int {
        return v[vals[x]][0] + v[vals[x]][1] - x;
    };

    // debug(gr);

    vector<vector<int>> ng(cur);
    for(int i = 1; i <= 2 * n; ++i) {
        int group = gr[i];
        if(group != -1) {
            int y = get_second(i);
            if(gr[y] != -1) {
                ng[group].emplace_back(gr[y]);
                if(ng[group].size() == 2 && ng[group][0] == ng[group][1]) {
                    ng[group].pop_back();
                }
            }
        }
    }

    vector<int> indeg(cur);
    vector<int> vis(cur);
    for(int i = 0; i < cur; ++i) {
        for(int x: ng[i]) {
            indeg[x]++;
        }
    }

    vector<int> path;
    auto dfs2 = [&](auto&& dfs2, int x) -> void {
        vis[x] = 1;
        path.emplace_back(x);
        for(int z: ng[x]) {
            if(vis[z] == 0) {
                dfs2(dfs2, z);
            }
        }
    };

    vector<int> did(2 * n + 1);
    vector<pair<int, int>> ans;
    auto make_path = [&](bool is_cycle) {
        debug(path, is_cycle);
        int sz = path.size();
        for(int i = 0; i < sz - 1; ++i) {
            int x = lst[path[i]][0], y = lst[path[i]][1];
            int a = lst[path[i+1]][0], b = lst[path[i+1]][1];

            // debug(x, y);
            // debug(a, b);
            // debug(vals);
            // debug(did);

            if(vals[x] == vals[a] && max(did[y], did[a]) == 0) {
                ans.emplace_back(y, a);
                swap(vals[a], vals[y]);
            } else if(vals[x] == vals[b] && max(did[y], did[b]) == 0) {
                ans.emplace_back(y, b);
                swap(vals[b], vals[y]);
            } else if(vals[y] == vals[a] && max(did[x], did[a]) == 0) {
                ans.emplace_back(x, a);
                swap(vals[a], vals[x]);
            } else if(vals[y] == vals[b] && max(did[x], did[b]) == 0) {
                ans.emplace_back(x, b);
                swap(vals[x], vals[b]);
            }

            // debug(ans.back());

            auto [xx, yy] = ans.back();
            did[xx] = did[yy] = 1;
        }

        if(!is_cycle) {
            int x = lst[path[sz - 1]][0], y = lst[path[sz - 1]][1];
            if(did[x] == 0) {
                int z = get_second(x);
                ans.emplace_back(y, z);
            } else {
                int z = get_second(y);
                ans.emplace_back(x, z);
            }
            auto [xx, yy] = ans.back();
            did[xx] = did[yy] = 1;
        }
    };

    debug(gr);
    debug(ng);
    // debug(indeg);

    for(int i = 0; i < cur; ++i) {
        if(indeg[i] == 0 && vis[i] == 0) {
            path.clear();
            dfs2(dfs2, i);

            make_path(false);
        }
    }

    for(int i = 0; i < cur; ++i) {
        if(vis[i] == 0) {
            path.clear();
            dfs2(dfs2, i);

            make_path(true);
        }
    }

    cout << ans.size() << '\n';
    for(auto [x, y]: ans) {
        cout << x << ' ' << y << '\n';
    }
}

#define TESTCASES
int main(){
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    #ifdef TESTCASES
        cin >> t;
    #endif
    for(int i = 1; i <= t; ++i ){
        solve(i);
        // cout << '\n';
    }
    return 0;
}