#include <bits/stdc++.h>
#define ll long long
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sk continue

using namespace std;

const int maxn = 1e6 + 111;
const ll inf = 1e9 + 7;
const ll INF = (ll)1e18;

class Coordinate{
public:

    ll x_whole, x_part, y_whole, y_part;

    Coordinate(ll a, ll b, ll c, ll d){
        x_whole = a;
        x_part = b;
        y_whole = c;
        y_part = d;
    }

    Coordinate operator +(Coordinate other){
        return Coordinate(x_whole + other.x_whole,
                          x_part + other.x_part,
                          y_whole + other.y_whole,
                          y_part + other.y_part);
    }

    Coordinate operator -(Coordinate other){
        return Coordinate(x_whole - other.x_whole,
                          x_part - other.x_part,
                          y_whole - other.y_whole,
                          y_part - other.y_part);
    }

    void operator +=(Coordinate other){
        x_whole += other.x_whole;
        x_part += other.x_part;
        y_whole += other.y_whole;
        y_part += other.y_part;
        return;
    }

    void operator -=(Coordinate other){
        x_whole -= other.x_whole;
        x_part -= other.x_part;
        y_whole -= other.y_whole;
        y_part -= other.y_part;
        return;
    }

    Coordinate operator *(ll mult){
        return Coordinate(x_whole * mult, x_part * mult, y_whole * mult, y_part * mult);
    }

    void operator *=(ll mult){
        x_whole *= mult;
        x_part *= mult;
        y_whole *= mult;
        y_part *= mult;
        return;
    }

};

bool operator ==(Coordinate a, Coordinate b){
    return (a.x_whole == b.x_whole &&
            a.x_part == b.x_part &&
            a.y_whole == b.y_whole &&
            a.y_part == b.y_part);
}

int final_angle = -1;

vector <pair <Coordinate, Coordinate> > eval(vector <pair <char, int> > ops, int statring_angle){

    vector <pair <Coordinate, Coordinate> > res;

    Coordinate curr_coordinate = Coordinate(0, 0, 0, 0);
    int angle = statring_angle;
    if(angle >= 360){
        angle -= 360;
    }

    for(int i = 0; i < ops.size(); i ++){
        if(ops[i].f == 'r'){
            angle += ops[i].s;
            if(angle >= 360){
                angle -= 360;
            }
        }
        else{
            int d = ops[i].s;
            Coordinate next_coordinate = curr_coordinate;
            if(angle == 0){
                next_coordinate += Coordinate(d, 0, 0, 0);
            }
            else if(angle == 45){
                next_coordinate += Coordinate(0, d, 0, d);
            }
            else if(angle == 90){
                next_coordinate += Coordinate(0, 0, d, 0);
            }
            else if(angle == 135){
                next_coordinate += Coordinate(0, -d, 0, d);
            }
            else if(angle == 180){
                next_coordinate += Coordinate(-d, 0, 0, 0);
            }
            else if(angle == 225){
                next_coordinate += Coordinate(0, -d, 0, -d);
            }
            else if(angle == 270){
                next_coordinate += Coordinate(0, 0, -d, 0);
            }
            else if(angle == 315){
                next_coordinate += Coordinate(0, d, 0, -d);
            }
            else{
                assert(false);
            }
            if(ops[i].f == 'd'){
                res.pb({curr_coordinate, next_coordinate});
            }
            curr_coordinate = next_coordinate;
        }
    }

    final_angle = angle;

    return res;
}

vector <pair <Coordinate, Coordinate> > simplify(vector <pair <Coordinate, Coordinate> > vec){

    Coordinate pseudo_min_coord = Coordinate(INF, INF, INF, INF);

    /*for(int i = 0; i < vec.size(); i ++){
        cout << "\t\t" << vec[i].f.x_whole << ' ' << vec[i].f.x_part << ' ' << vec[i].f.y_whole << ' ' << vec[i].f.y_part << " : " << vec[i].s.x_whole << ' ' << vec[i].s.x_part << ' ' << vec[i].s.y_whole << ' ' << vec[i].s.y_part << '\n';
    }*/

    for(int i = 0; i < vec.size(); i ++){
        pseudo_min_coord.x_whole = min({pseudo_min_coord.x_whole, vec[i].f.x_whole, vec[i].s.x_whole});
        pseudo_min_coord.x_part = min({pseudo_min_coord.x_part, vec[i].f.x_part, vec[i].s.x_part});
        pseudo_min_coord.y_whole = min({pseudo_min_coord.y_whole, vec[i].f.y_whole, vec[i].s.y_whole});
        pseudo_min_coord.y_part = min({pseudo_min_coord.y_part, vec[i].f.y_part, vec[i].s.y_part});
    }

    // cout << "\t\t\t" << pseudo_min_coord.x_whole << ' ' << pseudo_min_coord.x_part << ' ' << pseudo_min_coord.y_whole << ' ' << pseudo_min_coord.y_part << "\n\n";

    for(int i = 0; i < vec.size(); i ++){
        vec[i].f -= pseudo_min_coord;
        vec[i].s -= pseudo_min_coord;
    }

    /*for(int i = 0; i < vec.size(); i ++){
        cout << "\t\t" << vec[i].f.x_whole << ' ' << vec[i].f.x_part << ' ' << vec[i].f.y_whole << ' ' << vec[i].f.y_part << " : " << vec[i].s.x_whole << ' ' << vec[i].s.x_part << ' ' << vec[i].s.y_whole << ' ' << vec[i].s.y_part << '\n';
    }
    cout << "\n";*/

    return vec;
}

bool is_equal(vector <pair <Coordinate, Coordinate> > a, vector <pair <Coordinate, Coordinate> > b){

    a = simplify(a);
    b = simplify(b);

    assert(a.size() == b.size());

    for(int i = 0; i < a.size(); i ++){
        bool is_good = false;
        for(int j = 0; j < b.size(); j ++){
            if(a[i] == b[j]){
                is_good = true;
                swap(b[j], b.back());
                b.pop_back();
                break;
            }
            swap(b[j].f, b[j].s);
            if(a[i] == b[j]){
                is_good = true;
                swap(b[j], b.back());
                b.pop_back();
                break;
            }
        }
        if(!is_good){
            // cout << "NOPE!\n";
            return false;
        }
    }

    assert(b.empty());

    return true;
}

int main () {

    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(NULL);

    int n;
    cin >> n;

    vector <pair <char, int> > ops;

    for(int i = 1; i <= n; i ++){
        string type;
        int val;
        cin >> type >> val;
        ops.pb({type[0], val});
    }

    vector <pair <Coordinate, Coordinate> > drawing = eval(ops, 0);

    int start_angle = final_angle;

    for(int angle = 45; angle <= 360; angle += 45){
        vector <pair <Coordinate, Coordinate> > new_drawing = eval(ops, (start_angle + angle) % 360);
        // cout << angle << ' ' << new_drawing.size() << " (" << drawing.size() << ")\n";
        // cout << "\t" << angle << ":\n";
        if(is_equal(drawing, new_drawing)){
            cout << angle << '\n';
            return 0;
        }
    }

    assert(false);

    return 0;
}
