#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> g(n), gr(n);
    vector<int> vset(n), eset(n);
    for (int i  = 0; i < n; ++i) {
        string s, t;
        cin >> s >> t;
        int set = (s == "set");
        int res = (t == "true");
        vset[i] = set ^ res;
        eset[i] = set;
    }

    int m;
    cin >> m;

    vector<int> out(n), in(n);
    vector<int> p(n), sz(n, 1);
    for (int i = 0; i < n; ++i) p[i] = i;

    function<int(int)> root = [&](int v)
    {
        if (p[v] == v) return v;
        return p[v] = root(p[v]);
    };

    auto unite = [&](int a, int b) {
        a = root(a);
        b = root(b);
        if (a == b) return;
        if (sz[a] < sz[b]) swap(a, b);
        p[b] = a;
        sz[a] += sz[b];
    };

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        unite(u, v);
        g[u].push_back(v);
        in[v]++;
    }

    for (int i = 0; i < n; ++i) {
        if (vset[i] == 0 && eset[i] == 1) {
            for (int j = 0; j < n; ++j) {
                if (vset[j] == 1 && root(i) != root(j)) {
                    g[i].push_back(j);
//                    in[j]++;
                }
            }
        }
        if (vset[i] == 1  && eset[i] == 0) {
            for (int j = 0; j < n; ++j) {
                if (vset[j] == 0 && root(i) != root(j)) {
                    g[i].push_back(j);
//                    in[j]++;
                }
            }
        }
    }

    vector<int> ans;
    priority_queue<pair<pair<int, int>, int>> white, black;
    for (int i = 0; i  < n; ++i) {
        if (vset[i] == 0 && in[i] == 0) {
            white.push({{0, vset[i] == eset[i]}, i});
        }
    }

    vector<int> used(n);

    while (!white.empty()) {
        auto [p, v] = white.top();
        auto [d, go] = p;
        d = -d;
        white.pop();
        ans.push_back(v);
        used[v] = 1;
        for (auto to : g[v]) {
            if (vset[to] == 0) {
                white.push({{-(d + 1), vset[to] == eset[to]}, to});
            } else {
                black.push({{-(d + 1), vset[to] == eset[to]}, to});
            }
        }
        if (vset[v] != eset[v]) break;
    }

    while (!white.empty()) white.pop();

    while (!black.empty()) {
        auto [p, v] = black.top();
        auto [d, go] = p;
        d = -d;
        black.pop();
        ans.push_back(v);
        for (auto to : g[v]) {
            if (vset[to] == 1) {
                black.push({{-(d + 1), vset[to] == eset[to]}, to});
            } else {
                white.push({{-(d + 1), vset[to] == eset[to]}, to});
            }
        }
        if (vset[v] != eset[v]) break;
    }

    while (!white.empty()) {
        auto [p, v] = white.top();
        auto [d, go] = p;
        d = -d;
        white.pop();
        if (used[v]) continue;
        ans.push_back(v);
        for (auto to : g[v]) {
            if (vset[to] == 0 && !used[to]) {
                white.push({{-(d + 1), vset[to] == eset[to]}, to});
            }
        }
    }

    if (ans.size() == n) {
        for (auto el : ans) cout << el + 1 << ' ';
        cout << '\n';
    } else {
        cout << -1 << '\n';
    }
}

int main() {
    int t = 1;
//    cin >> t;
    while (t--) solve();
}

