import math

class Rect:
    def __init__(self, x, y, w, h, dirx, diry):
        self.x = x
        self.y = y
        self.w = w
        self.h = h
        self.dirx = dirx
        self.diry = diry

    def move(self, xb, yb):
        if self.x + self.w == xb or self.x == 0:
            self.dirx *= -1
        if self.y + self.h == yb or self.y == 0:
            self.diry *= -1
        self.x = abs(self.x + self.dirx)
        self.y = abs(self.y + self.diry)

    def overlap(self, r):
        return (self.x <= r.x < self.x + self.w) and (self.y <= r.y < self.y + self.h) or \
               (self.x <= r.x < self.x + self.w) and (self.y <= r.y + r.h < self.y + self.h)

    def compare(self, r):
        return self.x == r.x and self.y == r.y and self.w == r.w and self.h == r.h and self.dirx == r.dirx and self.diry == r.diry

    def __str__(self):
        return f"x, y: {self.x}, {self.y}\nw, h: {self.w}, {self.h}\ndirx, diry: {self.dirx}, {self.diry}\n"


def reduce(k, c):
    while (a := math.gcd(k, c)) != 1:
        k //= a
        c //= a
    return f"{k}/{c}"

t = int(input())
for _ in range(t):
    screenw, screenh = map(int, input().split())
    w, h, x, y, dx, dy = map(int, input().split())
    r1 = Rect(x, y, w, h, dx, dy)
    br1 = Rect(x, y, w, h, dx, dy)
    w, h, x, y, dx, dy = map(int, input().split())
    r2 = Rect(x, y, w, h, dx, dy)
    br2 = Rect(x, y, w, h, dx, dy)
    k = 0
    c = 0
    r1.move(screenw, screenh)
    r2.move(screenw, screenh)
    while not (r1.compare(br1) and r2.compare(br2)):
        #input()
        #print("r1:\n", r1)
        #print("r2:\n", r2)
        k += r1.overlap(r2) or r2.overlap(r1)
        c += 1
        r1.move(screenw, screenh)
        r2.move(screenw, screenh)
    k += r1.overlap(r2) or r2.overlap(r1)
    c += 1
    print(reduce(k, c))
'''
1
3 3
1 1 1 1 1 1
1 1 1 1 1 -1
'''