#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<ranges::input_range R>
requires (!is_same_v<string, R> && !is_convertible_v<R, string>)
ostream &operator<<(ostream &out, const R &v) {
    string space = "\n";
    if constexpr (is_scalar_v<typename R::value_type>) {
        space = " ";
    }
    for (const auto &a: v) {
        out << a << space;
    }
    return out;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;

/*
 *
 */

using graph = vector<vector<int>>;

void set_good(graph& g, int v, vector<bool>& bad, int& cnt_good) {
    bad[v] = false;
    ++cnt_good;
    for (int u :g[v]) {
        if (bad[u]) {
            set_good(g, u, bad, cnt_good);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    graph g(n);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a;--b;
        g[b].push_back(a);
    }
    vector<bool> bad(n, true);
    int cnt_good = 0;
    set_good(g, n - 1, bad, cnt_good);
    if (bad[0]) {
        cout << "-1";
        return;
    }
    queue<int> q;
    vector<int> dp(n, n);
    for (int i = 0; i < n; ++i) {
        if (bad[i]) {
            q.push(i);
            dp[i] = -1;
        }
    }
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u: g[v]) {
            if (mini(dp[u], dp[v] + 1) && u != n - 1) {
                q.push(u);
            }
        }
    }
    cout << dp[0];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.txt", "r", stdin);
    freopen("./../bober.txt", "w", stdout);
#endif

#ifdef BOBRY
    cin >> test;
#endif

    while (test--) {
        solve();
        cout << '\n';
    }
}