#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<ranges::input_range R>
requires (!is_same_v<string, R> && !is_convertible_v<R, string>)
ostream &operator<<(ostream &out, const R &v) {
    string space = "\n";
    if constexpr (is_scalar_v<typename R::value_type>) {
        space = " ";
    }
    for (const auto &a: v) {
        out << a << space;
    }
    return out;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;

/*
 *
 */

struct edge {
    int to;
    ll w;

    edge(int to, ll w) : to(to), w(w) {}
};

using graph = vector<vector<int>>;
using wgraph = vector<vector<edge>>;

void set_good(wgraph& g, int v, vector<bool>& bad, int& cnt_good) {
    bad[v] = false;
    ++cnt_good;
    for (edge e :g[v]) {
        if (bad[e.to]) {
            set_good(g, e.to, bad, cnt_good);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    wgraph g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        --a;--b;
        g[b].emplace_back(a, c);
    }
    vector<bool> bad(n, true);
    int cnt_good = 0;
    set_good(g, n - 1, bad, cnt_good);
    if (bad[0]) {
        cout << "-1";
        return;
    }


    vector<ll> d(n);
    queue<int> qd;
    d[n - 1] = 0;
    qd.push(n - 1);
    while (!qd.empty()) {
        int v = qd.front();
        qd.pop();
        for (edge e:g[v]) {
            if (mini(d[e.to], d[v] + e.w)) {
                qd.push(e.to);
            }
        }
    }


    queue<int> q0;
    queue<int> q;
    vector<int> dp(n, n);
    for (int i = 0; i < n; ++i) {
        if (bad[i]) {
            q.push(i);
            dp[i] = -1;
        }
    }

    while (!q0.empty() || !q.empty()) {
        int v;
        if (q0.empty()) {
            v = q.front();
            q.pop();
        } else {
            v = q0.front();
            q0.pop();
        }
        if (v == n - 1) {
            continue;
        }
        for (edge e: g[v]) {
            if (d[e.to] == d[v] + e.w && mini(dp[e.to], dp[v])) {
                q0.push(e.to);
            }
            else if (mini(dp[e.to], dp[v] + 1) && e.to != n - 1) {
                q.push(e.to);
            }
        }
    }
    cout << dp[0];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.txt", "r", stdin);
    freopen("./../bober.txt", "w", stdout);
#endif

#ifdef BOBRY
    cin >> test;
#endif

    while (test--) {
        solve();
        cout << '\n';
    }
}