#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    // {deadline, consumption}
    vector <pair <ll, ll>> required(n);

    for (int i =0;i < n;i++)
        cin >> required[i].second;
    for (int i =0;i < n;i++)
        cin >> required[i].first;

    sort(required.begin(), required.end());

    vector <ll> series_prefixed(m);
    for (int i = 0; i < m; i++) {
        cin >> series_prefixed[i];
        if (i)
            series_prefixed[i] += series_prefixed[i - 1];
    }

    // {q, index}
    vector <pair <ll, int>> queries(q);
    vector<int>ans(q);
    for (int i =0;  i<q;i++) {
        ll qu;cin>>qu;
        queries[i] = {qu, i};
    }
    sort(queries.rbegin(), queries.rend());


    ll start_right = 1e18;
    int next_right = n - 1;

    long long accumulated_left = 0;
    for (auto i : required)
        accumulated_left += i.second;

    for (auto query : queries) {
        while (next_right >= 0 && required[next_right].first > query.first) {
            accumulated_left -= required[next_right].second;
            start_right = min(start_right, required[next_right].first) - required[next_right].second;
            next_right--;
        }

        long long target_sum = min(start_right, query.first) - accumulated_left;
        ans[query.second] = upper_bound(series_prefixed.begin(), series_prefixed.end(), target_sum) - series_prefixed.begin();
    }
    for (auto i : ans) {
        cout << max(0, i) << " ";
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
    return 0;
}
