def is_sign(s):
    return s == '-' or s == '+'

class Number:
    def __init__(self, sign, staff):
        self.sign = sign
        self.staff = staff

    def __repr__(self):
        return (f"{self.sign}{self.staff}")

    def __str__(self):
        return (f"{self.sign}{self.staff}")

    def removeI(self, i):
        self.staff = self.staff[:i] + self.staff[i + 1:]

    def putI(self, i, digit):
        self.staff = self.staff[:i] + digit + self.staff[i:]

    def canTake(self, i):
        if (len(self.staff) == 1):
            return False

        if (i == 0 and len(self.staff) > 2 and self.staff[1] == '0'):
            return False

        return True

    def canPut(self, i, digit):
        if (i != 0 and self.staff == '0'):
            return False

        if (len(self.staff) == 10):
            return False

        if (i == 0 and digit == '0'):
            return False

        return True


def parseString(expr):
    arr = []
    if is_sign(expr[0]):
        number = Number(expr[0], '')
        expr = expr[1:]
    else:
        number = Number('+', '')

    for i in expr:
        if is_sign(i):
            arr.append(number)
            if is_sign(i):
                number = Number(i, '')
            else:
                number = Number('+', '')
        else:
            number.staff += i
    arr.append(number)

    return arr

def evaluate(numbersList):
    s = 0
    for number in numbersList:
        s += eval(number.__str__())
    return s

def print_expr(left, right):
    left_res = ''.join(map(str, left))
    if is_sign(left_res[0]):
        left_res = left_res[1:]
    right_str = ''.join(map(str, right))
    if is_sign(right_str[0]):
        right_str = right_str[1:]

    print(f"{left_res}={right_str}")

def copy_to_new(arr):
    new_arr = []
    for i in arr:
        new_arr.append(Number(i.sign, i.staff))
    return new_arr

def take_from_left(leftParsed, rightParsed, reversed):
    for i in range(len(leftParsed)):
        leftNum = leftParsed[i]
        for di in range(len(leftNum.staff)):
            if (not leftNum.canTake(di)):
                continue

            leftCpy = copy_to_new(leftParsed)
            rightCpy = copy_to_new(rightParsed)

            digit = leftCpy[i].staff[di]
            leftCpy[i].removeI(di)

            for j in range(len(leftCpy)):
                ln = len(leftCpy[j].staff) + 1
                for dj in range(ln):
                    if (not leftCpy[j].canPut(dj, digit)):
                        continue

                    leftCpy[j].putI(dj, digit)

                    if (evaluate(leftCpy) == evaluate(rightCpy)):
                        if (reversed):
                            print_expr(rightCpy, leftCpy)
                        else:
                            print_expr(leftCpy, rightCpy)

                        return True

                    leftCpy[j].removeI(dj)

            for j in range(len(rightCpy)):
                ln = len(rightCpy[j].staff) + 1
                for dj in range(ln):
                    if (not rightCpy[j].canPut(dj, digit)):
                        continue

                    rightCpy[j].putI(dj, digit)

                    if (evaluate(leftCpy) == evaluate(rightCpy)):
                        if (reversed):
                            print_expr(rightCpy, leftCpy)
                        else:
                            print_expr(leftCpy, rightCpy)
                        return True

                    rightCpy[j].removeI(dj)
    return False


def solve():
    s = input()

    left, right = s.split('=')

    leftParsed = parseString(left)
    rightParsed = parseString(right)

    if (evaluate(leftParsed) == evaluate(rightParsed)):
        print("Correct")
        return

    if take_from_left(leftParsed, rightParsed, reversed=False):
        return

    if take_from_left(rightParsed, leftParsed, reversed=True):
        return

    print("Impossible")


def main():
    solve()

main()

