#include <bits/stdc++.h>

#define isz(x) static_cast <int> (x.size())

using namespace std;

class RDecomposition{
public:
    explicit RDecomposition(const vector <int64_t> &a){
        this->a = a;
        size = isz(a);
        blockSize = static_cast<int>(ceil(size / 2.));
        cntBlocks = size / blockSize + 1;
        addInBlock.assign(cntBlocks,0);
        minInBlock.assign(cntBlocks,3e18);
    }
    void build(){
        for (int b = 0;b < cntBlocks;b++)
            build_block(b);
    }
    void add(int l,int r,int64_t value){
        l--; r--;
        int leftBlock = get_block(l),rightBlock = get_block(r);
        if (leftBlock != rightBlock){
            update_block(leftBlock);
            for (int i = l;i < end_block(leftBlock);i++)
                a[i] += value;
            build_block(leftBlock);
            for (int b = leftBlock + 1;b < rightBlock;b++){
                addInBlock[b] += value;
                minInBlock[b] += value;
            }
            update_block(rightBlock);
            for (int i = begin_block(rightBlock);i <= r;i++)
                a[i] += value;
            build_block(rightBlock);
        }
        else{
            update_block(leftBlock);
            for (int i = l;i <= r;i++) a[i] += value;
            build_block(leftBlock);
        }
    }
    int find(int64_t value){
        int curBlock = cntBlocks - 1;
        int realPos = size - 1;
        while(curBlock > 0 && minInBlock[curBlock] >= value){
            realPos = begin_block(curBlock);
            curBlock--;
        } 
        int begin = begin_block(curBlock),end = end_block(curBlock);
        for (int i = end - 1;i >= begin;i--){
            if (a[i] >= value) realPos = i;
            else break;
        }
        return realPos;
    }
private:
    int size;
    int blockSize;
    int cntBlocks;
    vector <int64_t> a;
    vector <int64_t> addInBlock;
    vector <int64_t> minInBlock;
    int get_block(int pos) const{
        return pos / blockSize;
    }
    int begin_block(int b) const{
        return b * blockSize;
    }
    int end_block(int b) const{
        return min(size,begin_block(b) + blockSize);
    }
    void build_block(int b){
        int begin = begin_block(b),end = end_block(b);
        minInBlock[b] = 3e18;
        for (int i = begin;i < end;i++)
            minInBlock[b] = min(minInBlock[b],a[i]);
    }
    void update_block(int b){
        if (addInBlock[b] == 0) return;
        int begin = begin_block(b),end = end_block(b);
        for (int i = begin;i < end;i++)
            a[i] += addInBlock[b];
        addInBlock[b] = 0;
    }
};

int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t; std::cin >> t;
    while(t--){
        int n,m,q; std::cin >> n >> m >> q;
        vector <int64_t> a(n),d(n),l(m),t(q);
        for (auto& val : a) std::cin >> val;
        for (auto& val : d) std::cin >> val;
        for (auto& val : l) std::cin >> val;
        for (auto& val : t) std::cin >> val;
        vector <int64_t> prefSum(n + 1);
        vector < pair <int64_t,int64_t> > realD;
        for (int i = 0;i < n;i++){
            realD.emplace_back(d[i],a[i]);
        }
        sort(realD.begin(),realD.end());
        vector <int64_t> k;
        int64_t add = 0;
        for (int i = 0;auto& [x,y] : realD){
            add += y;
            k.push_back(x - add);
            prefSum[i + 1] += prefSum[i] + y;
            i++;
        }
        k.push_back(3e18);
        RDecomposition sqrtD(k);
        sqrtD.build();
        vector <int64_t> ans;
        int64_t haveSum = 0;
        for (int i = 0;i < m;i++){
            int j = sqrtD.find(l[i]);
            sqrtD.add(j + 1,isz(k),-l[i]);
            haveSum += l[i];
            ans.push_back(haveSum + prefSum[j]);
        }
        sort(ans.begin(),ans.end());
        for (auto& val : t){
            std::cout << upper_bound(ans.begin(),ans.end(),val) - ans.begin() << ' ';
        }
        std::cout << "\n";
    }
}   