#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;

using ld = long double;
using pt = pair<ld, ld>;

ld SIN[360], COS[360];

const ld PI = atan2(0, -1);

void precalc() {
    rep(i, 360) {
        SIN[i] = sin(PI * i / (ld)180);
        COS[i] = cos(PI * i / (ld)180);
    }
}

ld operator*(const pt &a, const pt &b) {
    return a.first * b.second - a.second * b.first;
}

pt operator-(const pt &a, const pt &b) {
    return {a.first - b.first, a.second - b.second};
}

const ld EPS = 1e-6;

bool check(ld l1, ld r1, ld l2, ld r2) {
    if (l1 > r1) swap(l1, r1);
    if (l2 > r2) swap(l2, r2);
    return max(l1, l2) - EPS <= min(r1, r2);
}

vector<ar<int, 2>> commands;
vector<pair<pt, pt>> get_segs(int ang) {
    vector<pair<pt, pt>> who;

    auto Add = [&] (pair<pt, pt> seg) {
        if (seg.first > seg.second) swap(seg.first, seg.second);
        vector<bool> ok(who.size(), true);
        rep(i, who.size()) {
            pt v1 = seg.second - seg.first;
            auto [u, v] = who[i];
            pt v2 = v - u;

            ld res = v1 * v2;
            if (abs(res) > EPS) continue;

            pt v3 = v - seg.first;
            res = v1 * v3;
            if (abs(res) > EPS) continue;

            if (!check(seg.first.first, seg.second.first, u.first, v.first)) continue;
            if (!check(seg.first.second, seg.second.second, u.second, v.second)) continue;
            ok[i] = false;

            pt mn = min({seg.first, seg.second, u, v});
            pt mx = max({seg.first, seg.second, u, v});
            seg = {mn, mx};
        }

        int j = 0;
        rep(i, who.size()) {
            if (!ok[i]) continue;
            swap(who[i], who[j++]);
        }
        who.resize(j);

        who.emplace_back(seg);
    };

    pt cur = {0, 0};
    for(auto &[tp, d] : commands) {
        if (tp == 0) {
            ang += d;
            ang %= 360;
            continue;
        }
        pt nxt = cur;
        nxt.first += COS[ang] * d;
        nxt.second += SIN[ang] * d;
        if (tp == 1) Add({cur, nxt});
        cur = nxt;
    }

    pt mn = {INF, INF};
    for(auto &[u, v] : who) {
        mn = min(mn, u);
    }
    for(auto &[u, v] : who) {
        u = u - mn;
        v = v - mn;
    }
    sort(all(who));
    return who;
}

bool eq(pt a, pt b) {
    return abs(a.first - b.first) <= EPS && abs(a.second - b.second) <= EPS;
}

ld len(pt diff) {
    return sqrtl(diff.first * diff.first + diff.second * diff.second);
}

bool inside(vector<pair<pt, pt>> &A, vector<pair<pt, pt>> &B) {
    for(auto &seg : A) {
        ld in = 0;
        for(auto &[u, v] : B) {
            pt v1 = seg.second - seg.first;
            pt v2 = v - u;

            ld res = v1 * v2;
            if (abs(res) > EPS) continue;

            pt v3 = v - seg.first;
            res = v1 * v3;
            if (abs(res) > EPS) continue;

            if (!check(seg.first.first, seg.second.first, u.first, v.first)) continue;
            if (!check(seg.first.second, seg.second.second, u.second, v.second)) continue;

            pt l = max({seg.first, u});
            pt r = min({seg.second, v});
            pt diff = r - l;
            in += len(diff);
        }
        ld must = len(seg.second - seg.first);
        if (abs(must - in) > EPS) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n; cin >> n;
    rep(_, n) {
        ar<int, 2> cur;
        string s; cin >> s;
        if (s == "rotate") {
            cur[0] = 0;
        } else if (s == "draw") {
            cur[0] = 1;
        } else {
            cur[0] = 2;
        }
        cin >> cur[1];
        commands.push_back(cur);
    }

    auto segs = get_segs(0);
    for(int ang = 45; ang <= 360; ang += 45) {
        auto segs2 = get_segs(ang % 360);
        if (!inside(segs, segs2)) continue;
        if (!inside(segs2, segs)) continue;
        cout << ang << '\n';
        return;
    }
    assert(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    precalc();
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}