#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;

const int N = 4e5 + 5;
vector<pair<int, int>> g[N], gr[N];
vector<pair<int, int>> g2[N], gr2[N];


void solve() {
    int n, m; cin >> n >> m;
    rep(_, m) {
        int u, v, w; cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        gr[v].emplace_back(u, w);
    }

    vector<ll> dist(n + 1, INF);
    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<>> pq;
    dist[n] = 0;
    pq.push({0, n});
    while(!pq.empty()) {
        auto [dv, v] = pq.top();
        pq.pop();
        if (dist[v] != dv) continue;
        for(auto &[u, w] : gr[v]) {
            if (dist[u] > dv + w) {
                dist[u] = dv + w;
                pq.push({dist[u], u});
            }
        }
    }

    deque<int> q;
    vector<bool> was(n + 1);

    vector<ll> d(n + 1, INF);
    for(int i = 1; i <= n; ++i) {
        for(auto &[j, w] : g[i]) {
            if (dist[j] + w == dist[i]) {
                g2[i].emplace_back(j, w);
                gr2[j].emplace_back(i, w);
            }
        }
    }

    for(int i = 1; i <= n; ++i) {
        if (dist[i] == INF) {
            q.push_back(i);
            d[i] = -1;
        }
    }

    vector<int> deg(n + 1);
    for(int i = 1; i <= n; ++i) {
        deg[i] = g2[i].size();
    }
    while(!q.empty()) {
        int v = q.front();
        q.pop_front();
        if (was[v]) continue;
        was[v] = true;
        if (v == n) continue;

        for(auto &[u, w] : gr[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push_back(u);
            }
        }

        for(auto &[u, w] : gr2[v]) {
            deg[u]--;
            if (deg[u] == 0 && d[u] > d[v]) {
                d[u] = d[v];
                q.push_front(u);
            }
        }
    }

    cout << min(d[1], 1ll * n) << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}