#include <bits/stdc++.h>

using namespace std;

#define vec std::vector

vec<int> ops;

int main() {
    int n;
    cin >> n;
    vec<int> mas(n);

    for (auto& e : mas) {
        string a, b;
        cin >> a >> b;
        e = 0;
        if (a == "unset") {
            e += 2;
        }
        if (b == "false") {
            e += 1;
        }
    }

    int m;
    cin >> m;

    vec<vec<int>> graph_bi(n);
    vec<vec<int>> graph_dir(n);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph_bi[a].push_back(b);
        graph_bi[b].push_back(a);
        graph_dir[a].push_back(b);
    }

    vec<vec<int>> components;

    {
        vec<int> colors(n, -1);
        function<void(int, int)> dfs = [&](int v, int c) {
            if (colors[v] == c) return;
            colors[v] = c;
            components[c].push_back(v);
            for (auto e : graph_bi[v]) {
                dfs(e, c);
            }
        };
        for (int i = 0; i < n; i++) {
            if (colors[i] != -1) continue;
            components.push_back({});
            dfs(i, components.size() - 1);
        }
    }

    {
        vec<vec<int>> order(components.size());
        vec<int> modes(mas.size(), -1);
        function<void(int, int)> dfs = [&](int v, int m) {
            bool draw = false;
            if (modes[v] == -1) {
                int nm = 0;
                draw = true;
                if (mas[v] == 0) {
                    nm = 1;
                }
                if (mas[v] == 1) {
                    nm = 2;
                }
                if (mas[v] == 2) {
                    nm = 3;
                }
                if (mas[v] == 3) {
                    nm = 0;
                }
                modes[v] = nm;
            }

            if (m != -1) {
                if (modes[v] == 0 && m > 0) {
                    modes[v] = 4;
                    draw = true;
                }
                if (modes[v] < m) {
                    throw std::string("bad");
                }
            }

            if (!draw) return;
            for (auto e : graph_dir[v]) {
                dfs(e, modes[v]);
            }
        };
        for (int i = 0; i < components.size(); i++) {
            for (int ii = 0; ii < components[i].size(); ii++) {
                if (modes[components[i][ii]] != -1) continue;
                try {
                    dfs(components[i][ii], -1);
                } catch (...) {
                    cout << -1;
                    return 0;
                }
            }
        }

        vec<int> used(n, 0);
        function<void(int, int)> odfs = [&](int v, int o) {
            if (used[v] == 1) {
                throw std::string("circ");
            }
            if (used[v] == 2) {
                return;
            }
            used[v] = 1;
            for (auto& e : graph_dir[v]) {
                odfs(e, o);
            }
            used[v] = 2;
            order[o].push_back(v);
        };

        for (int i = 0; i < components.size(); i++) {
            for (int ii = 0; ii < components[i].size(); ii++) {
                if (used[components[i][ii]]) continue;
                try {
                    odfs(components[i][ii], i);
                } catch (...) {
                    cout << -1;
                    return 0;
                }
            }
        }
        vec<vec<int>> result(5);
        for (int i = 0; i < order.size(); i++) {
            for (int ii = 0; ii < order[i].size(); ii++) {
                result[modes[order[i][ii]]].push_back(order[i][ii]);
            }
        }

        if (result[1].empty() && !result[3].empty()) {
            cout << -1;
            return 0;
        }

        if (result[1].empty() && !result[2].empty()) {
            cout << -1;
            return 0;
        }

        if (result[3].empty() && !result[4].empty()) {
            cout << -1;
            return 0;
        }

        if (result[1].size() > 1 || result[3].size() > 1) {
            cout << -1;
            return 0;
        }

        for (auto& line : result) {
            for (auto& e : line) {
                cout << e + 1
                << ' ';
            }
        }
    }
}
