#include <iostream>
#include <vector>
#include <random>
#include <algorithm>

using namespace std;

random_device rd;
mt19937 rng(rd());

vector<int> topsort;
const int N = 1e5 + 123;
int used[N];
vector<int> g[N], gt[N];
void dfs(int v) {
  used[v] = true;
  for (int u : g[v]) {
    if (!used[u]) {
      dfs(u);
    }
  }
  topsort.push_back(v);
}

vector<int> sorted_types[3];
int cnt[4];

#define KEK cerr << "KEK: " << __LINE__ << endl

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> type(n);
  for (int i = 0; i < n; i++) {
    string a, b;
    cin >> a >> b;
    if (a == "set" && b == "true") { // 0 -> 1
      type[i] = 1;
    } else if (a == "set" && b == "false") { // 1 -> 1
      type[i] = 3;
    } else if (a == "unset" && b == "true") { // 1 -> 0
      type[i] = 2;
    } else { // 0 -> 0
      type[i] = 0;
    }
    cnt[type[i]]++;
  }
  int m;
  cin >> m;
  vector<pair<int, int>> edges;
  for (int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    edges.emplace_back(a - 1, b - 1);
    g[a - 1].push_back(b - 1);
    gt[b - 1].push_back(a - 1);
  }

  vector<int> order(n);
  for (int i = 0; i < n; i++) order[i] = i;


  for (int iters = 0; iters < 100; iters++) {
    fill(used, used+N, 0);
  for (int i : order) {
    if (!used[i]) {
      dfs(i);
    }
  }

  reverse(topsort.begin(), topsort.end());


  for (int i = 0; i < 3; i++) {
    sorted_types[i].clear();
  }

  for (int i : topsort) {
    if (type[i] == 0 || type[i] == 3) {
      sorted_types[0].push_back(i);
    } else {
      sorted_types[type[i]].push_back(i);
    }
  }

//   for (int i = 0; i < 3; i++) {
//     cout << i << ": ";
//     for (int j : sorted_types[i]) {
//       cout << j << " ";
//     }
//     cout << endl;
//   }

  if (sorted_types[1].size() < sorted_types[2].size()) {
    cout << "-1\n";
    // KEK;
    return 0;
  }

  if (sorted_types[1].size() == 0) {
    if (cnt[3] > 0) {
      cout << "-1\n";
      return 0;
    }
    for (int i : topsort) {
      cout << i + 1 << " ";
    }
    cout << "\n";
    return 0;
  }

  vector<int> order01(sorted_types[1].size() + sorted_types[2].size());
  vector<int> ind(n, -1);
  for (int i = 0; i < sorted_types[1].size(); i++) {
    order01[2 * i] = sorted_types[1][i];
    ind[sorted_types[1][i]] = 2 * i;
  }
  for (int i = 0; i < sorted_types[2].size(); i++) {
    order01[2 * i + 1] = sorted_types[2][i];
    ind[sorted_types[2][i]] = 2 * i + 1;
  }

  vector<int> first;
  vector<vector<int>> q(order01.size());
  // 00
  int prev_pos = -1;
  bool kek = true;
  for (int cur : sorted_types[0]) {
    int rightmost = prev_pos;
    for (int v : gt[cur]) {
      // ind[v] == -1 is ok
      rightmost = max(rightmost, ind[v]);
    }
    if (type[cur] == 0) {
      if (rightmost % 2 == 0) {
        rightmost++;
      }
    } else {
      if (rightmost == -1) {
        rightmost = 0;
      }
      if (rightmost % 2 == 1) {
        rightmost++;
      }
    }
    // cout << cur << " " << rightmost << " " << q.size() << endl;
    if (rightmost >= (int)q.size()) {
      cout << "-1\n";
      // KEK;
      kek = false;
    }
    if (!kek) break;
    if (rightmost == -1) {
      first.push_back(cur);
    } else {
      q[rightmost].push_back(cur);
    }
    prev_pos = rightmost;
  }
  if (!kek) continue;

  vector<int> answer, answer_inv(n);
  answer.reserve(n);
  for (int i : first) {
    answer_inv[i] = answer.size();
    answer.push_back(i);
  }
  for (int i = 0; i < order01.size(); i++) {
    answer_inv[order01[i]] = answer.size();
    answer.push_back(order01[i]);
    for (int j : q[i]) {
      answer_inv[j] = answer.size();
      answer.push_back(j);
    }
  }

//   for (int i : answer) {
//     cout << i + 1 << " ";
//   }
//   cout << "\n";

  bool flg = true;
  for (auto [a, b] : edges) {
    if (answer_inv[a] > answer_inv[b]) {
      cout << "-1\n";
      // KEK;
      flg = false;
    }
  }
  
  if (!flg) continue;
  for (int i : answer) {
    cout << i + 1 << " ";
  }
  cout << "\n";
  return 0;
  }
}
