#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int,int>;
using pll = pair<ll,ll>;
using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int mod = 1'000'000'007;
const ld eps = 1e-9;
const ll inf = 3'000'000'000'000'000'007ll;

struct IOInit {
    IOInit() {
        cin.tie(0)->sync_with_stdio(0);
        cout << fixed << setprecision(12);
    }
    ~IOInit() {
        #ifdef DEBUG
            cerr << fixed << setprecision(5) << "Runtime: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
        #endif
    }
} _io;

template<class ...T> void read(T&... x) {(cin >> ... >> x);}
template<class ...T> void print(const T&... x) {(cout << ... << x);}
template<class ...T> void println(const T&... x) {print(x..., '\n');}

template<class T> int sz(const T& x) {return x.size();}
template<class T, class U> bool chmin(T& x, const U& y) {return y < x?x=y,1:0;}
template<class T, class U> bool chmax(T& x, const U& y) {return x < y?x=y,1:0;}

#ifdef DEBUG
    template<class T>
    string pdbg(const T& x) {
        if constexpr (same_as<T, string>) {
            return "\"" + x  +"\"";
        }
        if constexpr (requires{x.first;}) {
            return "{" + pdbg(x.f) + ", " + pdbg(x.s) + "}";
        }
        if constexpr (requires{cout << x;}) {
            stringstream ss;
            ss << x;
            return ss.str();
        }
        if constexpr(ranges::range<T>) {
            string ans = "{";
            string del = ", ";
            auto it = begin(x);
            if (it != end(x)) ans += pdbg(*it++);
            while (it !=end(x)) ans += del + pdbg(*it++);
            return ans + "}";
        }
        return "Can't parse type";
    }
    template<class T, class ...U>
    string pdbg(const T& x, const U&... y) {
        return pdbg(x) + ", " + pdbg(y...);
    }
    #define dbg(...) print("[",#__VA_ARGS__,"] = ", pdbg(__VA_ARGS__)), cout << endl
#else
    #define dbg(...) 0
#endif

vector<string> s;
vector<int> cnt(2);
vector<vector<bool>> used;

void dfs(int i, int j) {
    if (i < 0 || i >= sz(s) || j < 0 || j >= sz(s[i])) return;
    if (s[i][j] == '#') return;
    if (used[i][j]) return;
    used[i][j] = true;
    ++cnt[(i + j) % 2];
    vector<pii> d = {
        {0, 1},
        {0, -1},
        {1, 0},
        {-1, 0}
    };
    for (auto [dx, dy] : d) {
        dfs(i + dx, j + dy);
    }

}

void solve() {
    int n;
    read(n);
    dbg(n);
    s = vector<string>(2);
    for (auto &i : s) read(i);
    used = vector<vector<bool>>(2, vector<bool>(n));
    bool multiple = false;
    for (int i = 0; i + 1 < n; ++i) {
        bool up = s[0][i] == '.' && s[0][i + 1] == '.';
        bool down = s[1][i] == '.' && s[1][i + 1] == '.';
        bool here = s[0][i] == '.' && s[1][i] == '.';
        if (up && down) {
            s[0][i] = s[0][i + 1] = s[1][i] = s[1][i + 1] = '#';
            multiple = true;
        } else if (here) {
            s[0][i] = s[1][i] = '#';
        } else if (up) {
            s[0][i] = s[0][i + 1] = '#';
        } else if (down) {
            s[1][i] = s[1][i + 1] = '#';
        }
    }
    if (find(all(s[0]), '.') != s[0].end() || find(all(s[1]), '.') != s[1].end()) {
        println("None");
        return;
    }
    println(multiple ? "Multiple" : "Unique");
}

int main() {
    int t;
    read(t);
    while (t--) solve();
    return 0;
}