#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int,int>;
using pll = pair<ll,ll>;
using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int mod = 1'000'000'007;
const ld eps = 1e-9;
const ll inf = 3'000'000'000'000'000'007ll;

struct IOInit {
    IOInit() {
        cin.tie(0)->sync_with_stdio(0);
        cout << fixed << setprecision(12);
    }
    ~IOInit() {
        #ifdef DEBUG
            cerr << fixed << setprecision(5) << "Runtime: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
        #endif
    }
} _io;

template<class T> istream& operator>>(istream& str, vector<T> &x) {
    for (auto &i : x) str >> i;
    return str;
}
template<class ...T> void read(T&... x) {(cin >> ... >> x);}
template<class ...T> void print(const T&... x) {(cout << ... << x);}
template<class ...T> void println(const T&... x) {print(x..., '\n');}

template<class T> int sz(const T& x) {return x.size();}
template<class T, class U> bool chmin(T& x, const U& y) {return y < x?x=y,1:0;}
template<class T, class U> bool chmax(T& x, const U& y) {return x < y?x=y,1:0;}

#ifdef DEBUG
    template<class T>
    string pdbg(const T& x) {
        if constexpr (same_as<T, string>) {
            return "\"" + x  +"\"";
        }
        if constexpr (requires{x.first;}) {
            return "{" + pdbg(x.f) + ", " + pdbg(x.s) + "}";
        }
        if constexpr (requires{cout << x;}) {
            stringstream ss;
            ss << x;
            return ss.str();
        }
        if constexpr(ranges::range<T>) {
            string ans = "{";
            string del = ", ";
            auto it = begin(x);
            if (it != end(x)) ans += pdbg(*it++);
            while (it !=end(x)) ans += del + pdbg(*it++);
            return ans + "}";
        }
        return "Can't parse type";
    }
    template<class T, class ...U>
    string pdbg(const T& x, const U&... y) {
        return pdbg(x) + ", " + pdbg(y...);
    }
    #define dbg(...) print("[",#__VA_ARGS__,"] = ", pdbg(__VA_ARGS__)), cout << endl
#else
    #define dbg(...) 0
#endif

#include <format>

void solve() {
    ll n;
    ll m;
    ll q;
    read(n, m, q);
    vector<pll> tasks(n);
    for (auto &[f, s] : tasks) read(s);
    for (auto &[f, s] : tasks) read(f);
    sort(all(tasks));
    for (int i = 1; i < n; ++i) {
        tasks[i].s += tasks[i - 1].s;
    }
    tasks.pb({inf, 0});
    dbg(tasks);
    vector<ll> l(m);
    read(l);
    vector<ll> t(q);
    read(t);
    dbg(l);
    dbg(t);
    vector<int> iq(q);
    iota(all(iq), 0);
    sort(all(iq), [&](int i, int j) {
        return t[i] < t[j];
    });
    int pser = 0;
    ll add = 0;
    vector<ll> events;
    for (int i = 0; i < sz(tasks); ++i) {
        while (pser < m && tasks[i].s + add + l[pser] <= tasks[i].f) {
            add += l[pser];
            events.pb((i == 0 ? 0 : tasks[i - 1].s) + add);
            ++pser;
        }
    }
    dbg(events);
    vector<ll> ans(q);
    for (auto iq : iq) {
        ans[iq] = upper_bound(all(events), t[iq]) - events.begin();
    }
    for (auto i : ans) print(i, ' ');
    println();
}

int main() {
    int t;
    read(t);
    while (t--) solve();
    return 0;
}