#include<bits/stdc++.h>
using namespace std;
#ifdef LOCAL
#define debug(...) [](auto...a){ ((cout << a << ' '), ...) << endl; }(#__VA_ARGS__, ": ", __VA_ARGS__)
#define debugv(v) do { cout << #v << ": "; for (auto x : v) cout << x << ' '; cout << endl; } while(0)
#else
#define debug(...)
#define debugv(v)
#endif // LOCAL
#define int long long
#define app push_back
#define all(x) x.begin(), x.end()

bool digit(char c) {
    return '0' <= c && c <= '9';
}

bool number(string s) {
    if (s.empty()) {
        return false;
    }
    for (char c : s) {
        if (!digit(c)) {
            return false;
        }
    }
    if (s.front() == '0' && s.size()>1) {
        return false;
    }
    if (s.size() > 10) {
        return false;
    }
    return true;
}

int val(string s) {
    int ans = 0;
    for (char c : s) {
        ans = ans * 10 + (c - '0');
    }
    return ans;
}

bool check(string s) {
    for (int i = 0; i < s.size(); ++i) {
        if (!digit(s[i])) {
            if (s[i] != '+' && s[i] != '-') {
                return false;
            }
        }
    }
    return true;
}

vector <int> getsigns(string s) {
    vector <int> signs = {-1};
    for (int i = 0; i < s.size(); ++i) {
        if (!digit(s[i])) {
            signs.push_back(i);
        }
    }
    signs.push_back(s.size());
    return signs;
}

bool expression(string s) {
    if (!check(s)) {
        return false;
    }
    auto signs = getsigns(s);
    for (int i = 0; i + 1 < signs.size(); ++i) {
        if (!number(s.substr(signs[i] + 1, signs[i + 1] - signs[i] - 1))) {
            return false;
        }
    }
    return true;
}

int eval(string s) {
    int ans = 0;
    auto signs = getsigns(s);
    for (int i = 0; i + 1 < signs.size(); ++i) {
        int x = val(s.substr(signs[i] + 1, signs[i + 1] - signs[i] - 1));
        if (i == 0 || s[signs[i]] == '+') {
            ans += x;
        }
        else {
            ans -= x;
        }
    }
    return ans;
}

bool correct(string s) {
    int p = -1;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '=') {
            p = i;
        }
    }
    if (p == -1) {
        return false;
    }
    string l = s.substr(0, p);
    string r = s.substr(p + 1, (int)s.size() - p - 1);
    return expression(l) && expression(r) && eval(l) == eval(r);
}

int32_t main() {
    cin.tie(0); ios_base::sync_with_stdio(0);

    string s;
    cin >> s;

    if (correct(s)) {
        cout << "Correct\n";
    }
    else {
        for (int i = 0; i < s.size(); ++i) {
            if (digit(s[i])) {
                auto t = s;
                t.erase(t.begin() + i);
                for (int j = 0; j <= t.size(); ++j) {
                    auto nt = t;
                    nt.insert(nt.begin() + j, s[i]);
                    if (correct(nt)) {
                        cout << nt << '\n';
                        exit(0);
                    }
                }
            }
        }
        cout << "Impossible\n";
    }

    return 0;
}
