#include<bits/stdc++.h>
using namespace std;
#ifdef LOCAL
#define debug(...) [](auto...a){ ((cout << a << ' '), ...) << endl; }(#__VA_ARGS__, ": ", __VA_ARGS__)
#define debugv(v) do { cout << #v << ": "; for (auto x : v) cout << x << ' '; cout << endl; } while(0)
#else
#define debug(...)
#define debugv(v)
#endif // LOCAL
#define int long long
#define app push_back
#define all(x) x.begin(), x.end()

auto read(int n) {
    vector<int> v(n);
    for (int &x : v) { cin >> x; if (x != -1) --x;}
    return v;
}

auto process(int n, int k, vector<int> p, vector<int> s) {
    vector<int> seen(n);
    for (int x : s) if (x != -1) seen[x] = 1;
    vector<vector<int>> sets;
    sets.push_back({});
    for (int x : p) {
        if (seen[x]) sets.push_back({}); else sets.back().push_back(x);
    }
    vector<int> cnt(1);
    for (int x : s) {
        if (x == -1) cnt.back()++; else cnt.push_back(0);
    }
    assert(cnt.size() == sets.size());
    vector<int> pos(n, -1);
    for (int i = 0; i < sets.size(); ++i) {
        for (int x : sets[i]) pos[x] = i;
    }
    while (cnt.size() < k + 1) cnt.push_back(0);
    while (sets.size() < k + 1) sets.push_back({});
    debugv(pos);
    debugv(cnt);
    return tuple{pos, cnt, sets};
}

#define pb push_back
struct Dinic {
    struct edge {
        int to, flow, cap;
    };
    const static int N = 4010;
    vector<edge> e;
    vector<int> g[N + 7];
    int dp[N + 7];
    int ptr[N + 7];
    void clear() {
        for (int i = 0; i < N + 7; ++i) g[i].clear();
        e.clear();
    }
    void addEdge(int a, int b, int cap) {
        debug(a, b, cap);
        g[a].pb(e.size());
        e.pb({b, 0, cap});
        g[b].pb(e.size());
        e.pb({a, 0, 0});
    }
    int minFlow, start, finish;
    bool bfs() {
        for (int i = 0; i < N; ++i) {
            dp[i] = -1;
        }
        dp[start] = 0;
        vector<int> st;
        st.pb(start);
        int uk = 0;
        while (uk < st.size()) {
            int v = st[uk++];
            for (int to : g[v]) {
                auto ed = e[to];
                if (ed.cap - ed.flow >= minFlow && dp[ed.to] == -1) {
                    dp[ed.to] = dp[v] + 1;
                    st.pb(ed.to);
                }
            }
        }
        return dp[finish] != -1;
    }
    int dfs(int v, int flow) {
        if (v == finish) return flow;
        for (; ptr[v] < g[v].size(); ptr[v]++) {
            int to = g[v][ptr[v]];
            edge ed = e[to];
            if (ed.cap - ed.flow >= minFlow && dp[ed.to] == dp[v] + 1) {
                int add = dfs(ed.to, min(flow, ed.cap -  ed.flow));
                if (add) {
                    e[to].flow += add;
                    e[to ^ 1].flow -= add;
                    return add;
                }
            }

        }
        return 0;
    }

    int dinic(int start, int finish, int fl) {
        debug(start, finish);
        Dinic::start = start;
        Dinic::finish = finish;
        int flow = 0;
        for (minFlow = (1 << 30); minFlow; minFlow >>= 1) {
            while (flow < fl && bfs()) {
                for (int i = 0; i < N; ++i) ptr[i] = 0;
                while (flow < fl) {
                    debug(flow);
                    int now = dfs(start, fl - flow);
                    if (now == 0) break;
                    assert(flow + now <= fl);
                    flow += now;
                }
            }
        }
        return flow;
    }
};

Dinic dinic;
void solve();
int32_t main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
       solve();
    }
    return 0;
}
void NO() {
    cout << "Inconsistent" << '\n';
    return;
}

void solve() {
    int n;
    cin >> n;
    auto p1 = read(n);
    auto p2 = read(n);
    int k; cin >> k;
    auto s1 = read(k);
    auto s2 = read(k);
    auto [pos1, cnt1, sets1] = process(n, k, p1, s1);
    auto [pos2, cnt2, sets2] = process(n, k, p2, s2);

    for (int i = 0; i < k + 1; ++i) if (cnt1[i] > sets1[i].size()) return NO();
    for (int i = 0; i < k + 1; ++i) if (cnt2[i] > sets2[i].size()) return NO();
    vector<int> sz1(k + 1), sz2(k + 1);
    for (int i = 0; i < k+1; ++i) { sz1[i] = sets1[i].size(); sz2[i] = sets2[i].size(); }
    debug(cnt1.size());
    debug(cnt2.size());
    assert(cnt1.size() == k + 1);
    assert(cnt2.size() == k + 1);
    vector<vector<int>> e(k + 1, vector<int>(k + 1));
    vector<pair<int, int>> where(n);
    for (int i = 0; i < n; ++i) {
        where[i] = {pos1[i], pos2[i]};
        if (pos1[i] != -1 && pos2[i] == -1) {
            cnt1[pos1[i]]--;
            sz1[pos1[i]]--;
        }
        if (pos1[i] == -1 && pos2[i] != -1) {
            cnt2[pos2[i]]--;
            sz2[pos2[i]]--;
        }
        if (pos1[i] != -1 && pos2[i] != -1) {
            e[pos1[i]][pos2[i]]++;
        }
    }
    for (int x : cnt1) if (x < 0) return NO();
    for (int x : cnt2) if (x < 0) return NO();
    debugv(cnt1);
    debugv(cnt2);
    for (auto &row : e) debugv(row);
    int a1 = accumulate(all(cnt1), 0LL);
    int a2 = accumulate(all(cnt2), 0LL);
    debug(a1, a2);
    assert(a1 == a2);
    dinic.clear();
    int s = 2 * (k + 1), t = 2 * (k + 1) + 1;
    for (int i = 0; i < k + 1; ++i) {
        dinic.addEdge(s, i, min(sz1[i], cnt1[i]));
    }
    for (int i = k + 1; i < 2 * (k + 1); ++i) {
        dinic.addEdge(i, t, min(sz2[i-k-1],cnt2[i-k-1]));
    }
    for (int i = 0; i < k+1;++i) {
        for (int j = 0; j < k+1; ++j) {
            if (e[i][j] < 0) return NO();
            dinic.addEdge(i, j+k+1, e[i][j]);
        }
    }
    int f = dinic.dinic(s, t, a1);
    debug(f);
    assert(f <= a1);
    if (f != a1) return NO();
    vector<vector<int>> g(2 * k + 4);
    vector<vector<int>> fl(2 * k + 4, vector<int>(2 * k + 4));
    vector<vector<int>> ca(2 * k + 4, vector<int>(2 * k + 4));
    for (int x = 0; x < 2 * k + 4; ++x) {
        for (auto idx : dinic.g[x]) {
            auto [y, flow, cap] = dinic.e[idx];
            fl[x][y] = flow;
            ca[x][y] = cap;
            if (flow < cap) g[x].push_back(y);
            if (flow > 0) g[y].push_back(x);
        }
    }
    int N = g.size();
    vector<vector<int>> r(N);
    for (int i = 0; i < g.size(); ++i) {
        for (int j : g[i]) r[j].push_back(i);
    }
    vector<int> used(N), tout(N);
    int time = 0;
    auto dfs = [&](auto dfs, int cur) -> void {
        if (used[cur]) return;
        used[cur] = 1;
        for (int nxt : g[cur]) {
            dfs(dfs, nxt);
        }
        tout[cur] = time++;
    };
    for (int i = 0; i < N; ++i) if (!used[i]) dfs(dfs, i);
    vector<int> ind(N);
    iota(all(ind), 0);
    sort(all(ind), [&](int i, int j){return tout[i] > tout[j]; });
    vector<int> scc(N, -1);
    auto go = [&](auto go, int cur, int color) -> void {
        if (scc[cur] != -1) return;
        scc[cur] = color;
        for (int nxt : r[cur]) {
            go(go, nxt, color);
        }
    };
    int color = 0;
    for (int i : ind) if (scc[i] == -1) go(go, i, color++);
    debugv(scc);
    string ans(n, '.');
    for (int x : s1) if (x != -1) ans[x] = 'Y';
    for (int x : s2) if (x != -1) ans[x] = 'Y';
    for (int i = 0; i < n; ++i) {
        auto [u, v] = where[i];
        if (u == -1 || v == -1) { assert(ans[i] == 'Y'); continue; }
        v+=k+1;
        debug(i, u, v);
        assert(ca[u][v] > 0);
        bool any = 0, not_all = 0;
        if (fl[u][v] > 0 || scc[v] == scc[u]) { any = 1; }
        if (fl[u][v] < ca[u][v] || scc[u] == scc[v]) {not_all = 1;}
        if (!any) ans[i] = 'N'; else if (!not_all) ans[i] = 'Y'; else ans[i] = '?';
    }
    cout << ans << '\n';
}

