#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;
const ll inf = 1e18;

struct edge{
    int to;
    ll w;
};

int n, m;
vector<vector<edge>> g, rg;
vector<ll> dist;
vector<int> cnt;


void dijkstra(){
    dist.assign(n, inf);
    dist[n - 1] = 0;
    set<pair<ll, int>> q;
    q.emplace(dist[n - 1], n - 1);
    while(!q.empty()){
        int v = q.begin()->second;
        q.erase(q.begin());
        for(auto [to, w]: rg[v]){
            if(dist[to] > dist[v] + w){
                if(dist[to] < inf){
                    q.erase(make_pair(dist[to], to));
                }
                dist[to] = dist[v] + w;
                q.insert(make_pair(dist[to], to));
            }
        }
    }
}


signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin >> n >> m;
    g.assign(n, vector<edge>());
    rg.assign(n, vector<edge>());
    rep(i, m){
        int u, v;
        cin >> u >> v;
        ll w;
        cin >> w;
        --u;
        --v;
        g[u].push_back(edge{v, w});
        rg[v].push_back(edge{u, w});
    }
    dijkstra();
    cnt.assign(n, 0);
    for(int v = 0; v < n - 1; v += 1){
        if(dist[v] < inf / 2){
            for(auto [to, w]: g[v]){
                if(dist[v] == dist[to] + w){
                    cnt[v] += 1;
                }
            }
            assert(cnt[v] > 0);
        }
    }
    deque<int> q;
    vector<int> d(n, n);
    for(int v = 0; v < n; v += 1){
        if(dist[v] >= inf / 2){
            q.push_back(v);
            d[v] = -1;
        }
    }
    vector<int> usd(n, false);
    while(!q.empty()){
        int v = q.front();
        q.pop_front();
        if(usd[v]){
            continue;
        }
        usd[v] = true;
        for(auto [to, w]: rg[v]){
            if(to == n - 1){
                continue;
            }
            if(dist[to] == dist[v] + w){
                cnt[to] -= 1;
                if(cnt[to] == 0 and !usd[to]){
                    d[to] = d[v];
                    q.push_front(to);
                    continue;
                }
            }
            if(d[to] == n){
                d[to] = d[v] + 1;
                q.push_back(to);
            }
        }
    }
    cout << d[0] << "\n";
    return 0;
}
