#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;


struct edge{
    int to;
    int v1;
    int v2;
};

int n;
vector<int> a;
vector<vector<int>> g;
vector<pair<int, int>> ctov;
vector<int> usd;
vector<vector<edge>> g2;
int result;
vector<pair<int, int>> swaps;
vector<int> usd_in_swp;

bool dfs1(int v, int p){
    bool good = true;
    for(auto to: g[v]){
        if(to == p){
            continue;
        }
        bool to_good = dfs1(to, v);
        if(good && to_good){
            good = false;
            result += 1;
            if(a[v] != a[to]){
                g2[a[v]].push_back(edge{a[to], v, to});
                g2[a[to]].push_back(edge{a[v], to, v});
            }
        }
    }
    return good;
}


int get_second_vertex(int v){
    return ctov[a[v]].first ^ ctov[a[v]].second ^ v;
}


void dfs2(int v, deque<pair<int, int>> &d){
    usd[v] = true;
    for(auto [to, v1, v2]: g2[v]){
        if(usd[to]){
            continue;
        }
        d.push_back(make_pair(v1, v2));
        dfs2(to, d);
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    rep(itr, t){
        cin >> n;
        a.resize(2 * n);
        rep(i, 2 * n){
            cin >> a[i];
            --a[i];
        }
        ctov.assign(n, make_pair(-1, -1));
        for(int i = 0; i < 2 * n; i += 1){
            if(ctov[a[i]].first == -1){
                ctov[a[i]].first = i;
            } else{
                ctov[a[i]].second = i;
            }
        }
        g.assign(2 * n, vector<int>());
        for(int i = 0; i < 2 * n - 1; i += 1){
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        result = 0;
        g2.assign(n, vector<edge>());
        dfs1(0, -1);
        swaps.clear();
        usd.assign(n, false);
        usd_in_swp.assign(2 * n, false);
        auto resolve = [&](deque<pair<int, int>> d, bool start_banned){
            while(len(d) > 1){
                if(start_banned){
                    swaps.push_back(make_pair(d[0].second, d.back().second));
                    d.pop_front();
                    start_banned = false;
                } else{
                    swaps.push_back(make_pair(d[0].first, d.back().first));
                    d.pop_back();
                    start_banned = true;
                }
            }
        };
        for(int v = 0; v < n; v += 1){
            if(!usd[v] and len(g2[v]) == 1){
                deque<pair<int, int>> d;
                dfs2(v, d);
                if(len(d) > 0){
                    resolve(d, true);
                    swaps.push_back(make_pair(d[0].first, get_second_vertex(d.back().second)));
                }
            }
        }
        for(int v = 0; v < n; v += 1){
            if(!usd[v]){
                deque<pair<int, int>> d;
                dfs2(v, d);
                if(len(d) > 0){
                    d.push_back(make_pair(get_second_vertex(d.back().second), get_second_vertex(d[0].first)));
                    resolve(d, true);
                }
            }
        }
        cout << len(swaps) << "\n";
        for(auto [u, v]: swaps){
            cout << u + 1 << " " << v + 1 << "\n";
        }
    }
    return 0;
}


/*
1
4
1 3 1 2 3 2 4 4
1 2
2 3
3 4
4 5
5 6
6 7
6 8


1
3
3 1 2 3 1 2
1 2
1 3
3 4
3 5
5 6


3
2
1 2 2 1
1 2
2 3
3 4
4
4 3 1 3 2 4 1 2
1 2
3 1
3 4
5 1
5 6
2 7
2 8
3
1 1 2 2 3 3
1 2
1 3
1 4
1 5
1 6

*/