#include  <bits/stdc++.h>

typedef long long ll;

using namespace std;


struct Num {
    ll a;
    ll b;

    Num() : a(0), b(0) {}

    Num(ll a, ll b) : a(a), b(b) {}
};

bool operator<(Num a, Num b) {
    return (a.b - b.b) < (b.a - a.a) * sqrt(2);
}

bool operator==(Num a, Num b) {
    return !(a < b) && !(b < a);
}

Num operator+(Num a, Num b) {
    return Num(a.a + b.a, a.b + b.b);
}

Num operator-(Num a, Num b) {
    return Num(a.a - b.a, a.b - b.b);
}

Num operator*(Num a, ll k) {
    return Num(a.a * k, a.b * k);
}

struct Point {
    Num x;
    Num y;

    Point() : x(Num()), y(Num()) {}

    Point(Num x, Num y) : x(x), y(y) {}
};

bool operator<(Point a, Point b) {
    return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

bool operator==(Point a, Point b) {
    return !(a < b) && !(b < a);
}

Point operator*(Point a, ll k) {
    return Point(a.x * k, a.y * k);
}

Point operator+(Point a, Point b) {
    return Point(a.x + b.x, a.y + b.y);
}

Point rotated(int deg) {
    deg %= 360;
    switch (deg) {
        case 0:
            return Point(Num(1, 0), Num(0, 0));
        case 45:
            return Point(Num(0, 1), Num(0, 1));
        case 90:
            return Point(Num(0, 0), Num(1, 0));
        case 135:
            return Point(Num(0, -1), Num(0, 1));
        case 180:
            return Point(Num(-1, 0), Num(0, 0));
        case 225:
            return Point(Num(0, -1), Num(0, -1));
        case 270:
            return Point(Num(0, 0), Num(-1, 0));
        case 315:
            return Point(Num(0, 1), Num(0, -1));
    }
    assert(false);
}

typedef std::vector<std::pair<Point, int>> Figure;

vector<map<Num, vector<Point>>> simplify(vector<Figure> fig) {
    vector<map<Num, vector<Point>>> result(4);
    {
        map<Num, vector<pair<Num, int>>> mp;
        for (int i = 0; i < fig[0].size(); i++) {
            mp[fig[0][i].first.y].push_back({fig[0][i].first.x, fig[0][i].second});
        }
        for (auto &p: mp) {
            int balance = 0;
            set<int> visited;
            sort(p.second.begin(), p.second.end());
            for (int i = 0; i < p.second.size(); ++i) {
                int now = p.second[i].second;
                if (visited.count(now)) {
                    if (i + 1 < p.second.size() && p.second[i + 1].first == p.second[i].first) {
                        balance--;
                    } else {
                        balance--;
                        if (balance == 0) {
                            result[0][p.first].push_back(Point(p.second[i].first, p.first));
                        }
                    }
                } else {
                    if (balance == 0) {
                        result[0][p.first].push_back(Point(p.second[i].first, p.first));
                    }
                    balance++;
                    visited.insert(now);
                }
            }
        }
    }

    {
        map<Num, vector<pair<Num, int>>> mp;
        for (int i = 0; i < fig[1].size(); i++) {
            mp[fig[1][i].first.y - fig[1][i].first.x].push_back({fig[1][i].first.x + fig[1][i].first.y, fig[1][i].second});
        }
        for (auto &p: mp) {
            int balance = 0;
            set<int> visited;
            sort(p.second.begin(), p.second.end());
            for (int i = 0; i < p.second.size(); ++i) {
                int now = p.second[i].second;
                if (visited.count(now)) {
                    if (i + 1 < p.second.size() && p.second[i + 1].first == p.second[i].first) {
                        balance--;
                    } else {
                        balance--;
                        if (balance == 0) {
                            result[1][p.first].push_back(Point(p.second[i].first, p.first));
                        }
                    }
                } else {
                    if (balance == 0) {
                        result[1][p.first].push_back(Point(p.second[i].first, p.first));
                    }
                    balance++;
                    visited.insert(now);
                }
            }
        }
    }


    {
        map<Num, vector<pair<Num, int>>> mp;
        for (int i = 0; i < fig[2].size(); i++) {
            mp[fig[2][i].first.x].push_back({fig[2][i].first.y, fig[2][i].second});
        }
        for (auto &p: mp) {
            int balance = 0;
            set<int> visited;
            sort(p.second.begin(), p.second.end());
            for (int i = 0; i < p.second.size(); ++i) {
                int now = p.second[i].second;
                if (visited.count(now)) {
                    if (i + 1 < p.second.size() && p.second[i + 1].first == p.second[i].first) {
                        balance--;
                    } else {
                        balance--;
                        if (balance == 0) {
                            result[2][p.first].push_back(Point(p.second[i].first, p.first));
                        }
                    }
                } else {
                    if (balance == 0) {
                        result[2][p.first].push_back(Point(p.second[i].first, p.first));
                    }
                    balance++;
                    visited.insert(now);
                }
            }
        }
    }

    {
        map<Num, vector<pair<Num, int>>> mp;
        for (int i = 0; i < fig[3].size(); i++) {
            mp[fig[3][i].first.x + fig[3][i].first.y].push_back({fig[3][i].first.y - fig[3][i].first.x, fig[3][i].second});
        }
        for (auto &p: mp) {
            int balance = 0;
            set<int> visited;
            sort(p.second.begin(), p.second.end());
            for (int i = 0; i < p.second.size(); ++i) {
                int now = p.second[i].second;
                if (visited.count(now)) {
                    if (i + 1 < p.second.size() && p.second[i + 1].first == p.second[i].first) {
                        balance--;
                    } else {
                        balance--;
                        if (balance == 0) {
                            result[3][p.first].push_back(Point(p.second[i].first, p.first));
                        }
                    }
                } else {
                    if (balance == 0) {
                        result[3][p.first].push_back(Point(p.second[i].first, p.first));
                    }
                    balance++;
                    visited.insert(now);
                }
            }
        }
    }

    return result;
}

pair<vector<Figure>, vector<Point>> buildFigure(const vector<pair<string, ll>> &actions, int initRot, Point initPoint) {
    int rotate = initRot;
    Point lastPoint = initPoint;
    vector<Figure> fig(4);
    vector<Point> points;

    for (int i = 0; i < actions.size(); i++) {
        if (actions[i].first == "move") {
            lastPoint = lastPoint + rotated(rotate) * actions[i].second;
        }
        if (actions[i].first == "draw") {
            fig[(rotate / 45) % 4].emplace_back(lastPoint, i);
            points.emplace_back(lastPoint);
            lastPoint = lastPoint + rotated(rotate) * actions[i].second;
            fig[(rotate / 45) % 4].emplace_back(lastPoint, i);
            points.emplace_back(lastPoint);
        }
        if (actions[i].first == "rotate") {
            rotate += actions[i].second;
            rotate %= 360;
        }
    }

    return {fig, points};
}

void solve() {
    int n;
    cin >> n;
    vector<pair<string, ll>> actions;
    for (int i = 0; i < n; i++) {
        string action;
        int d;
        cin >> action >> d;
        actions.emplace_back(action, d);
    }

    auto initial = buildFigure(actions, 0, Point());
    auto simplifiedFigureInitial = simplify(initial.first);

    for (int deg = 45; deg <= 360; deg += 45) {
        for (const auto &p: initial.second) {
            auto now = buildFigure(actions, deg, p);
            auto simplifiedFigureNow = simplify(now.first);

            if (simplifiedFigureInitial == simplifiedFigureNow) {
                cout << deg;
                return;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}