#include <bits/stdc++.h>
#define int long long
#define ld long double
#define endl '\n'
const int INF = (int)1e9+1;

using namespace std;

const int kMaxn = 1e5 + 5;

vector<int> g[kMaxn];

void clear() {
    for (int i = 0; i < kMaxn; i++) {
        g[i].clear();
    }
}

vector<int> top_sort;
vector<bool> used(kMaxn);

vector<int> order(kMaxn);
void dfs(int v) {
    used[v] = true;

    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }

    top_sort.push_back(v);
    order[v] = top_sort.size() - 1;
}
bool check_asyclic() {
    top_sort.clear();



    for (int i = 0; i < kMaxn; i++) {
        used[i] = false;
    }
    for (int i = 0; i < kMaxn; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(top_sort.begin(), top_sort.end());
    for (int v = 0; v < kMaxn; v++) {
        for (auto u : g[v]) {
            if (order[u] > order[v]) {
                return false;
            }
        }
    }

    return true;
}

int bananza[kMaxn];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> pos_st, pos_sf, pos_ut, pos_uf;
    for (int i = 0; i < n; i++) {
        string type;
        string ans;
        cin >> type >> ans;

        if (type == "set") {
            if (ans == "true") {
                pos_sf.push_back(i);
            } else {
                pos_st.push_back(i);
            }
        } else {
            if (ans == "true") {
                pos_ut.push_back(i);
            } else {
                pos_uf.push_back(i);
            }
        }
    }
    int m;
    cin >> m;
    vector<pair<int, int>> edges;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        edges.emplace_back(a, b);
    }

    if (pos_sf.size() == 0) {
        if (pos_ut.size() || pos_st.size()) {
            cout << -1;
            return 0;
        }

        for (auto [p, q] : edges) {
            g[p].push_back(q);
        }

        if (check_asyclic()) {
            for (auto v : top_sort) {
                if (v >= n) {
                    continue;
                }
                cout << v + 1 << " ";
            }
            return 0;
        } else {
            cout << -1;
            return 0;
        }
    }
    if (pos_sf.size() == 1) {
        if (pos_ut.size() > 1) {
            cout << -1;
            return 0;
        }

        if (pos_ut.size() == 0) {
            for (auto ind : pos_uf) {
                g[ind].push_back(pos_sf[0]);
            }
            for (auto ind : pos_st) {
                g[pos_sf[0]].push_back(ind);
            }

            for (auto [p, q] : edges) {
                g[p].push_back(q);
            }

            if (check_asyclic()) {
                for (auto v : top_sort) {
                    if (v >= n) {
                        continue;
                    }
                    cout << v + 1 << " ";
                }
                return 0;
            } else {
                cout << -1;
                return 0;
            }
        } else {
            int l = pos_sf[0];
            int r = pos_ut[0];

            g[l].push_back(r);

            vector<int> is_st(kMaxn);
            for (auto val : pos_st) {
                g[l].push_back(val);
                g[val].push_back(r);
                is_st[val] = true;
            }

            for (auto [p, q] : edges) {
                if (is_st[p] && !is_st[q]) {
                    g[r].push_back(q);
                    //cout << r << " : " << q << endl;
                    continue;
                }
                if (!is_st[p] && is_st[q]) {
                    g[p].push_back(l);
                    //cout << p << " : " << l << endl;
                    continue;
                }
                g[p].push_back(q);

                //cout << p << " : " << q << endl;
            }

            if (check_asyclic()) {
                //cout << "I am here";
                vector<int> arr1, arr2, arr3;
                bool was_l = false;
                for (auto v : top_sort) {
                    if (v >= n) {
                        continue;
                    }
                    //cout << v + 1 << " ";
                    if (v == l) {
                        was_l = true;
                    }

                    if (v == l || v == r) {
                        continue;
                    }

                    if (is_st[v]) {
                        arr2.push_back(v);
                    } else {
                        if (!was_l) {
                            arr1.push_back(v);
                        } else {
                            arr3.push_back(v);
                        }
                    }
                }
                for (auto val : arr1) {
                    cout << val + 1 << " ";
                }
                cout << l + 1 << " ";
                for (auto val : arr2) {
                    cout << val + 1 << " ";
                }
                cout << r + 1 << " ";
                for (auto val : arr3) {
                    cout << val + 1 << " ";
                }
                return 0;
            } else {
                cout << -1;
                return 0;
            }

        }
    }
    cout << -1;
    return 0;
}
