
#include <iostream>
#include <vector>
#include <set>
#include <numeric>
#include <algorithm>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>


#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

using ll = long long;
using ld = long double;

using namespace std;


void solve() {
	int n;
	cin >> n;
	n *= 2;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	vector<vector<pair<int, int>>> g(n);
	vector<int> cnt(n);
	for (int i = 0; i < n - 1; ++i) {
		int from, to;
		cin >> from >> to;
		--from; --to;
		g[from].push_back({ a[to], to });
		g[to].push_back({ a[from], from });
		cnt[from] += 1;
		cnt[to] += 1;
	}
	for (int i = 0; i < n; ++i) {
		sort(g[i].begin(), g[i].end());
	}
	vector<pair<int, int>> whereis(n / 2, make_pair(-1, -1));
	for (int i = 0; i < n; ++i) {
		if (whereis[a[i]].first == -1) {
			whereis[a[i]].first = i;
		}
		else {
			whereis[a[i]].second = i;
		}
	}
	queue<int> q;
	for (int i = 0; i < n; ++i) {
		if (cnt[i] == 1) {
			q.push(i);
		}
	}

	vector<int> par(n);
	auto dfs = [&](int v, int p, auto &&self) -> void {
		par[v] = p;
		for (const auto& pr : g[v]) {
			const auto& u = pr.second;
			if (u == p) continue;
			self(u, v, self);
		}
	};
	int pick = 0;
	int ttt = cnt[0];
	for (int i = 0; i < n; ++i) {
		if (cnt[i] > 1) {
		//if (cnt[i] > ttt){
			pick = i; 
			//ttt = cnt[i];
			break;
		}
	}

	auto getv = [&](int v, int find_mask, int notu) {
		auto it = lower_bound(g[v].begin(), g[v].end(), make_pair(find_mask, 0));
		if (it == g[v].end()) return -1;
		if (it->first == find_mask && it->second != notu) return it->second;
		++it;
		if (it == g[v].end()) return -1;
		if (it->first == find_mask && it->second != notu) return it->second;
		return -1;
	};
	//cout << "HDHZ " << pick;
	dfs(pick, pick, dfs);
	vector<pair<int, int>> ans;
	vector<int> used_mask(n / 2);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		int u = par[v];
		if (!used_mask[a[v]]) {
			if (a[v] != a[u]) {

				int z = whereis[a[v]].first == v ?
					whereis[a[v]].second :
					whereis[a[v]].first;

				int intersection = getv(z, a[u], u);

				if (intersection != -1) {
					used_mask[a[v]] = true;
					used_mask[a[u]] = true;
					ans.push_back({ u, z });
				}
			}
			else {
				used_mask[a[v]] = true;
			}
		}

		cnt[u] -= 1;
		if (cnt[u] == 1) {
			q.push(u);
		}
	}


	for (int i = 0; i < n / 2; ++i) {
		if (used_mask[i]) continue;
		int v = whereis[i].first;
		int u = whereis[i].second;

		int first = -1, second = -1;
		for (const auto& p : g[v]) {
			const auto& z = p.second;
			if (!used_mask[a[z]]) {
				first = z;
				break;
			}
		}
		for (const auto& p : g[u]) {
			const auto& z = p.second;
			if (!used_mask[a[z]]) {
				second = z;
				break;
			}
		}

		if (first != -1) {
			used_mask[a[v]] = true;
			ans.push_back({first, u});
		}
		else if (second != -1) {
			used_mask[a[v]] = true;
			ans.push_back({ second, v });
		}
	}
	int cnt1 = count(used_mask.begin(), used_mask.end(), true);
#ifdef _DEBUG
	cout << "LOL: " << cnt1 << endl;
#endif
	cout << ans.size() << '\n';
	for (auto& x : ans) {
		cout << x.first + 1 << ' ' << x.second + 1 << '\n';
	}
#ifdef _DEBUG
	cout << "end" << endl;
#endif

}


int main()
{
	cin.tie(0)->sync_with_stdio(0);

	int t = 1;
	cin >> t;
	forn(tt, t) {

		solve();
	}
}