#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <bitset>
#include <deque>
#include <string>
#include <numeric>
#include <cstring>
#include <functional>
#include <fstream>
#include <random>


using namespace std;
//#define LOCAL
#define int long long

using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using ii = pair<int, int>;
using pii = pair<int, int>;
using vii = vector<pair<int, int>>;

#define fore(i, b, e) for (int i = (b); i < (e); ++i)
#define foree(i, b, e) for (int i = (b); i <= (e); ++i)
#define ford(i, b, e) for (int i = (e) - 1; i >= (b); --i)
#define fordd(i, b, e) for (int i = (e); i >= (b); --i)
#define pb push_back
#define ff first
#define ss second

#define all(x) (x).begin(), (x).end()



using namespace std;

void precalc();
void solve();
void generate_test();
// #define MULTITEST
#define GENERATE_TEST
#define CHECK_ANSWER


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
#ifdef MULTITEST
	cin >> t;
#endif
	precalc();
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", 'w', stdout);
#ifdef GENERATE_TEST
	generate_test();
#endif
#endif

	while (t--) {
		solve();
	}

}

void precalc() {

}

int N;

#define SF 0
#define ST 1
#define UF 2
#define UT 3

void exit() {
	cout << -1 << '\n';
	exit(0);
}

void generate_test() {
	ofstream ofs("input.txt");
	mt19937_64 rng{ random_device{}() };
	ll tests = 100;
	ofs << tests << '\n';
	foree(tt, 0, tests) {
		uniform_int_distribution n_gen(1, 5);
		ll n = n_gen(rng);
		uniform_int_distribution<ll> pos_gen(0, n - 1);

		vi perm(n);
		iota(all(perm), 0);

		shuffle()
	}
}

void solve() {
	string s;
	getline(cin, s);
	ll n = stoll(s);
	vector<string> vs(n + 1);
	foree(i, 1, n) getline(cin, vs[i]);
	vi l(n + 1);
	vi cl(n + 1);
	foree(i, 1, n) {
		if (vs[i] == "set true") {
			l[i] = ST;
			cl[i] = 2;
		}
		if (vs[i] == "set false") {
			l[i] = SF;
			cl[i] = 3;
		}
		if (vs[i] == "unset true") {
			l[i] = UT;
			cl[i] = 4;
		}
		if (vs[i] == "unset false") l[i] = UF;
	}

	getline(cin, s);
	ll m = stoll(s);
	vii e(m);
	vvi g(n + 1);
	fore(i, 0, m) {
		ll u, v; cin >> u >> v;
		e[i].ff = u;
		e[i].ss = v;
		g[u].pb(v);
	}


	for (const auto& [u, v] : e) {
		if (l[u] == UT && l[v] == UF) cl[v] = 5;
		if (l[u] == UF && l[v] == UT) cl[u] = 1;
		if (l[u] == UF && l[v] == ST) cl[u] = 1;
		if (l[u] == ST && l[v] == UF) cl[v] = 5;
		if (l[u] == UF && l[v] == SF) cl[u] = 1;
		if (l[u] == SF && l[v] == UF) cl[v] = 5;
		if (l[u] == SF && l[v] == ST) {
			cout << -1 << '\n';
			return;
		}
		if (l[u] == UT && l[v] == SF) {
			cout << -1 << '\n';
			return;
		}
		if (l[u] == UT && l[v] == ST) {
			cout << -1 << '\n';
			return;
		}
	}

	foree(u, 1, n)
		sort(all(g[u]), [&](ll a, ll b) {return cl[a] < cl[b]; });

	bool have[6]{};
	foree(i, 1, 5) have[i] = (find(all(cl), i) != cl.end());
	if (!have[2] && have[3]) exit();
	if (!have[2] && have[4]) exit();
	if (!have[2] && have[5]) exit();
	if (!have[4] && have[5]) exit();

	vi topsort;
	vector<char> was(n + 1);
	function<void(ll)> dfs = [&](ll u) {
		was[u] = 1;
		for (ll v : g[u]) {
			if (was[v]) continue;
			dfs(v);
		}
		topsort.pb(u);
	};
	foree(i, 1, n) {
		if (!was[i]) dfs(i);
	}
	reverse(all(topsort));

	for (ll u : topsort) {
		for (ll v : g[u]) {
			if (cl[u] == 0 && cl[v] == 0) continue;
			else if (cl[u] == 0 && cl[v] != 0);
			else if (cl[u] != 0 && cl[v] == 0);
			else if (cl[u] > cl[v]) {
				cout << -1 << '\n';
				return;
			}
		}
	}

	for (ll u : topsort) {
		for (ll v : g[u]) {
			if (cl[u] == 0) cl[u] = 1;
			if (cl[v] == 0) cl[v] = 5;
		}
	}

	stable_sort(all(topsort), [&](ll x, ll y) {
		return cl[x] < cl[y];
	});
	fore(i, 0, n) cout << topsort[i] << ' ';
	cout << '\n';

}