#include <bits/stdc++.h>

using namespace std;

string add(const string& a, const string& b) {
    string result;
    for (size_t i = 0, carry = 0; i < a.size() || i < b.size() || carry; ++i) {
        int digit = carry;
        if (i < a.size()) {
            digit += a[i] - '0';
        }
        if (i < b.size()) {
            digit += b[i] - '0';
        }
        if (digit >= 10) {
            carry = 1;
            digit -= 10;
        } else {
            carry = 0;
        }
        result.push_back(digit + '0');
    }
    return result;
}

string sub(const string& a, const string& b) {
    string result;
    int carry = 0;
    for (size_t i = 0; i < a.size() || i < b.size(); ++i) {
        int digit = carry;
        if (i < a.size()) {
            digit += a[i] - '0';
        }
        if (i < b.size()) {
            digit -= b[i] - '0';
        }
        if (digit < 0) {
            carry = -1;
            digit += 10;
        } else {
            carry = 0;
        }
        result.push_back(digit + '0');
    }
    if (carry < 0) {
        return "x";
    }
    return result;
}

bool check(const string& input) {
    vector<string> numbers;
    vector<bool> signs;
    bool past_eq = false;
    string cur_num;
    bool good = true;
    auto flush = [&]() {
        if (cur_num.size() > 10) {
            good = false;
            return;
        }
        if (cur_num.empty()) {
            good = false;
            return;
        }
        if (cur_num.at(0) == '0' && cur_num.size() > 1) {
            good = false;
        }
        reverse(cur_num.begin(), cur_num.end());
        numbers.push_back(cur_num);
        cur_num.clear();
    };
    for (auto ch : input) {
        if (isdigit(ch)) {
            cur_num.push_back(ch);
        } else {
            flush();
            if (ch == '=') {
                past_eq = true;
                signs.push_back(false);  // false is -
            } else if (ch == '-') {
                signs.push_back(past_eq);
            } else if (ch == '+') {
                signs.push_back(!past_eq);
            } else {
                assert(false);
            }
        }
    }
    flush();
    if (!good) {
        return false;
    }
    string cur = numbers.at(0);
    for (size_t i = 0; i < signs.size(); ++i) {
        if (signs[i]) {
            cur = add(cur, numbers.at(i + 1));
        }
    }
    for (size_t i = 0; i < signs.size(); ++i) {
        if (!signs[i]) {
            cur = sub(cur, numbers.at(i + 1));
            if (cur == "x") {
                return false;
            }
        }
    }
    for (auto ch : cur) {
        if (ch != '0') {
            return false;
        }
    }
    return true;
}

void solve() {
    int x;
    cin >> x;
    vector<int> zeros;
    vector<int> ones;
    vector<int> mem(1u << 12);
    for (int j = 0; j < 16; ++j) {
        if (x & (1u << j)) {
            ones.push_back(j);
        } else {
            zeros.push_back(j);
        }
    }
    mem[2] = 1u << 10;
    int a = 0;
    auto disp = 1u << 10;
    for (a = 0; a < zeros.size(); ++a) {
        mem[disp + a * 3] = (1u << 16) - 16 + zeros[a];
        mem[disp + a * 3 + 1] = (1u << 14) + 41 + a * 48;
        mem[disp + a * 3 + 2] = disp + a * 3 + 3;
    }
    mem[disp + a * 3 + 2] = (1u << 11) + disp;
    disp += 1u << 11;
    for (a = 0; a < ones.size(); ++a) {
        mem[disp + a * 3] = (1u << 16) - 16 + ones[a];
        mem[disp + a * 3 + 1] = (1u << 15) + (1u << 14) + 42 + a * 48;
        mem[disp + a * 3 + 2] = disp + a * 3 + 3;
    }
    mem[disp + a * 3] = (1u << 16) - 16;
    mem[disp + a * 3 + 1] = 48;
    mem[disp + a * 3 + 1] = (1u << 16) - 1;
    for (int a = 0; a < 100; ++a) {
        auto disp = (1u << 10) + (1u << 9);
        mem[disp + a * 3] = (1u << 16) - 16;
        mem[disp + a * 3 + 2] = (1u << 16) - 1;
        disp = (1u << 11);
        mem[disp + a * 3] = (1u << 16) - 16;
        mem[disp + a * 3 + 2] = (1u << 16) - 1;
    }
    for (int idx = 0; idx + 1 < 1u << 12; ++idx) {
        string num;
        auto val = mem[idx];
        for (int j = 0; j < 4; ++j) {
            auto dig = val % 16;
            val /= 16;
            if (dig >= 10) {
                num.push_back(dig - 10 + 'a');
            } else {
                num.push_back(dig + '0');
            }
        }
        reverse(num.begin(), num.end());
        cout << num << ' ';
    }
}

signed main() {
    int t = 1;
#ifdef KEK
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    // cin >> t;
#else
    cin.tie(0); cout.tie(0); std::ios::sync_with_stdio(false);
//    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
}