
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;
vector<vector<int>> g;
vector<vector<int>> check;
vector<int>ts;
vector<int>used;

void dfs(int v) {
	if (used[v])
		return;
	used[v] = 1;
	for (const auto& to : g[v]) {
		dfs(to);
	}

	ts.push_back(v);
}

void solve() {
	int n;
	cin >> n;
	g.resize(n + 1);
	check.resize(n + 1);
	used.resize(n + 1);
	vector<int> sett(2);
	vector<int> unsett(2);
	vector<pair<char, bool>> status(n + 1);
	for (int i = 1; i < n + 1; i++)
	{
		string s1, s2;
		cin >> s1 >> s2;
		if (s1 == "set") {
			sett[s2 == "true"]++;
		}
		else
			unsett[s2 == "true"]++;
		status[i] = { s1[0], s2 == "true" };
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		g[b].push_back(a);
		check[a].push_back(b);
	}

	if (!(sett[1] == 1 || unsett[0] == n)) {
		cout << "-1\n";
		return;
	}

	for (int i = 1; i < n + 1; i++)
	{
		if (!used[i])
			dfs(i);
	}

	reverse(ts.begin(), ts.end());
	vector<int>ans;
	vector<int>has(n + 1);
	vector<int>before(n + 1);
	vector<int>after(n + 1);

	for (const auto& v : ts) {
		if (status[v] == make_pair('u', false)) {
			before[v]++;
		}
	}
	for (const auto& v : ts) {
		if (status[v] == make_pair('s', true)) {
			for (const auto& to : check[v]) {
				if (before[to]) {
					before[to] = 0;
					after[to] = 1;
				}
				if (has[to]) {
					cout << "-1\n";
					return;
				}
			}
			ans.push_back(v);
			has[v]++;
		}
	}

	for (const auto& v : ts) {
		if (status[v] == make_pair('s', false)) {
			for (const auto& to : check[v]) {
				if (before[to]) {
					before[to] = 0;
					after[to] = 1;
				}
				if (has[to]) {
					cout << "-1\n";
					return;
				}
			}
			ans.push_back(v);
			has[v]++;
		}
	}
	for (const auto& v : ts) {
		if (status[v] == make_pair('u', true)) {
			for (const auto& to : check[v]) {
				if (before[to]) {
					before[to] = 0;
					after[to] = 1;
				}
				if (has[to]) {
					cout << "-1\n";
					return;
				}
			}
			ans.push_back(v);
			has[v]++;
		}
	}
	bool has_after = false;
	for (int i = 1; i < n+1; i++)
	{
		has_after |= after[i]!=0;
	}
	if (has_after && !unsett[1]) {
		cout << "-1";
		return;
	}
	vector<int>bans;
	for (const auto& v : ts) {
		if (before[v]) {
			bans.push_back(v);
			has[v]++;
		}
	}

	for (const auto& v : ts) {
		if (after[v]) {
			for (const auto& to : check[v]) {
				if (has[to]) {
					cout << "-1\n";
					return;
				}
			}
			ans.push_back(v);
			has[v]++;
		}
	}
	for (int i = 0; i < bans.size(); i++)
	{
		cout << bans[i] << " ";
	}
	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i] << " ";
	}
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
#ifdef _MY
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
