
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;
bool is_dig(char c) {
	assert((c >= '0' && c <= '9') || c == '=' || c == '+' || c == '-');
	return c >= '0' && c <= '9';
}
bool is_valid(const string& s) {
	for (int i = 0; i < s.size(); ++i) {
		if (i + 1 < s.size() && !is_dig(s[i]) && !is_dig(s[i + 1])) {
			return false;
		}
		if (i + 1 == s.size() && !is_dig(s[i])) {
			return false;
		}
		if (i == 0 && !is_dig(s[i])) {
			return false;
		}
	}
	ll s1 = 0, s2 = 0;
	char lasst = '+';
	int i;
	for (i = 0; s[i] != '=';) {
		if (!is_dig(s[i])) {
			lasst = s[i];
			++i;
		}
		int j = i;
		while (j < s.size() && is_dig(s[j]))
			++j;
		int len = j - i;
		if (len == 0 || len > 10) {
			return false;
		}
		if (len > 1 && s[i] == '0') {
			return false;
		}
		ll tmp = 0;
		for (int k = i; k < j; ++k) {
			tmp = tmp * 10 + s[k] - '0';
		}
		if (lasst == '+') {
			s1 += tmp;
		}
		else {
			s1 -= tmp;
		}
		i = j;
	}

	lasst = '+';
	for (i = i + 1; i < s.size();) {
		if (!is_dig(s[i])) {
			lasst = s[i];
			++i;
		}
		int j = i;
		while (j < s.size() && is_dig(s[j]))
			++j;
		int len = j - i;
		if (len == 0 || len > 10) {
			return false;
		}
		if (len > 1 && s[i] == '0') {
			return false;
		}
		ll tmp = 0;
		for (int k = i; k < j; ++k) {
			tmp = tmp * 10 + s[k] - '0';
		}
		if (lasst == '+') {
			s2 += tmp;
		}
		else {
			s2 -= tmp;
		}
		i = j;
	}
	return s1 == s2;
}
void solve() {
	string s;
	cin >> s;
	if (is_valid(s)) {
		cout << "Correct\n";
		return;
	}
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] >= '0' && s[i] <= '9') {
			auto s1 = s.substr(0, i) + s.substr(i + 1);
			for (int j = 0; j <= s1.size(); ++j) {
				string s2;
				if (j == s1.size()) {
					s2 = s1 + s[i];
				}
				else {
					s2 = s1.substr(0, j) + s[i] + s1.substr(j);
				}
				if (is_valid(s2)) {
					cout << s2 << endl;
					return;
				}
			}
		}
	}
	cout << "Impossible\n";
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
#ifdef _MY
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
