
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;
void panic() {
	cout << "-1\n";
	exit(0);
}

vector<int>a;
vector<vector<int>>g;
vector<pair<int, int>>ans;
vector<pair<int, int>>edges;
void dfs(int v, vector<vector<int>>& dp, int p = -1) {
	bool mt = false;
	for (auto x : g[v]) {
		if (x == p) {
			continue;
		}
		dfs(x, dp, v);
		dp[0][v] += max(dp[1][x], dp[0][x]);
		mt |= dp[1][x] == dp[0][x];
	}
	dp[1][v] = dp[0][v] + mt;
}

void dfs1(int v, const vector<vector<int>>& dp, int st, int p = -1) {
	for (auto x : g[v]) {
		if (x == p)
			continue;

		bool one_gd = dp[1][x] > dp[0][x];
		if (!one_gd && st == 1) {
			st = 0;
			edges.push_back({ v,x });
		}
		dfs1(x, dp, int(one_gd), v);
	}
}
void solve() {
	int n;
	cin >> n;
	a.assign(2 * n, 0);
	g.assign(2 * n, vector<int>());
	ans.clear();
	edges.clear();
	for (auto& x : a) {
		cin >> x;
		--x;
	}
	for (int i = 0; i < 2 * n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector<vector<int>>dp(2, vector<int>(2 * n));
	dfs(0, dp);
	int st = 0;
	if (dp[1][0] > dp[0][0])
		st = 1;
	dfs1(0, dp, st);
	assert(max(dp[0][0], dp[1][0]) == edges.size());
	vector<vector<int>>col_to_pr(n);
	vector<vector<int>>col_to_pr1(n);
	vector<int>used(edges.size());
	for (int i = 0; i < a.size(); ++i) {
		col_to_pr1[a[i]].push_back(i);
	}
	for (int i = 0; i < edges.size(); ++i) {
		auto x = edges[i];
		if (a[x.first] == a[x.second]) {
			used[i] = 1;
			continue;
		}
		col_to_pr[a[x.first]].push_back(i);
		col_to_pr[a[x.second]].push_back(i);
	}
	for (int i = 0; i < edges.size(); ++i) {
		if (used[i]) {
			continue;
		}
		auto x = edges[i];
		if (col_to_pr[a[x.first]].size() == 2 && col_to_pr[a[x.second]].size() == 2) {
			continue;
		}
		if (col_to_pr[a[x.first]].size() == 1 && col_to_pr[a[x.second]].size() == 1) {
			int v1 = x.first;
			int v2 = col_to_pr1[a[x.first]][0];
			if (v2 == v1) {
				v2 = col_to_pr1[a[x.first]][1];
			}
			ans.push_back({ v2, x.second });
			used[i] = 1;
			continue;
		}
	}
	vector<vector<pair<int, int>>>g1(edges.size());
	for (int i = 0; i < col_to_pr.size(); ++i) {
		auto x = col_to_pr[i];
		if (col_to_pr[i].size() == 2) {
			g1[x[0]].push_back({ x[1], i });
			g1[x[1]].push_back({ x[0], i });
		}
	}

	vector<int>used_col(n);
	vector<vector<int>>edges1(edges.size());
	for (int i = 0; i < edges.size(); ++i) {
		edges1[i].push_back(edges[i].first);
		edges1[i].push_back(edges[i].second);
	}
	for (int i = 0; i < edges.size(); ++i) {
		if (used[i]) {
			continue;
		}
		if (g1[i].size() != 1) {
			continue;
		}
		//auto x = edges[i];
		vector<int>dd;
		int vert = i;
		dd.push_back(vert);
		while (!used[vert]) {
			used[vert] = 1;
			bool mt = false;
			for (auto x : g1[vert]) {
				if (used[x.first]) {
					continue;
				}
				mt = true;
				vert = x.first;
				break;
			}
			if(mt)
			dd.push_back(vert);
		}
		int l = 0, r = dd.size() - 1;
		//int last = -1;
		{
			bool mt = false;
			for (int j1 = 0; j1 < 2; ++j1) {
				for (int j2 = 0; j2 < 2 && !mt; ++j2) {
					int& v1 = edges1[dd[l]][j1];
					int& v2 = edges1[dd[r]][j2];
					int& swp_v = edges1[dd[r]][j2 ^ 1];
					if (col_to_pr[a[v1]].size() == 1
						&& col_to_pr[a[v2]].size() == 1) {
						mt = true;
						ans.push_back({ v1,swp_v });
						swap(a[v1], a[swp_v]);
						int nxt = v1;
						swap(v1, swp_v);

						{
							int v1 = nxt;
							int v2 = col_to_pr1[a[v1]][0];
							if (v2 == v1) {
								v2 = col_to_pr1[a[v1]][1];
							}
							ans.push_back({ v2, v1 });
							//used[i] = 1;
							continue;
						}

						--r;
						break;
					}
				}
			}
		}
		for (int j = 0;; ++j) {
			if (l == r)
				break;
			int tol = 0;
			int tor = 0;
			for (int j1 = 0; j1 < 2; ++j1) {
				for (int j2 = 0; j2 < 2; ++j2) {
					if (a[edges1[dd[l]][j1]] == a[edges1[dd[r]][j2]]
						&& (used_col[a[edges1[dd[l]][j1]]])) {
						tol = j1;
						tor = j2;
					}
				}
			}
			used_col[a[edges1[dd[l]][tol]]] = 1;
			//	if (j == 0) {
				//	used_col[a[edges1[l][tol ^ 1]]] = 1;
				//}

			if (j % 2 == 1) {
				int l1 = edges1[dd[l]][tol ^ 1];
				int r1 = edges1[dd[r]][tor];

				ans.push_back({ l1,r1 });
				swap(a[l1], a[r1]);
				swap(edges1[dd[l]][tol ^ 1], edges1[dd[r]][tor]);
				used_col[a[edges1[dd[l]][tol ^ 1]]] = 1;
				++l;
			}
			else {
				int l1 = edges1[dd[l]][tol];
				int r1 = edges1[dd[r]][tor ^ 1];

				ans.push_back({ l1,r1 });
				swap(a[l1], a[r1]);
				swap(edges1[dd[l]][tol], edges1[dd[r]][tor ^ 1]);
				used_col[a[edges1[dd[r]][tor ^ 1]]] = 1;
				--r;
			}
		}
	}

	for (int i = 0; i < edges.size(); ++i) {
		if (used[i]) {
			continue;
		}
		//auto x = edges[i];
		vector<int>dd;
		int vert = i;
		dd.push_back(vert);
		while (!used[vert]) {
			used[vert] = 1;
			bool mt = false;
			for (auto x : g1[vert]) {
				if (used[x.first]) {
					continue;
				}
				mt = true;
				vert = x.first;
				break;
			}
			if (mt)
				dd.push_back(vert);
		}
		int l = 0, r = dd.size() - 1;
		//int last = -1;
		for (int j = 0;; ++j) {
			if (l == r)
				break;
			int tol = 0;
			int tor = 0;
			for (int j1 = 0; j1 < 2; ++j1) {
				for (int j2 = 0; j2 < 2; ++j2) {
					if (a[edges1[dd[l]][j1]] == a[edges1[dd[r]][j2]]
						&& (used_col[a[edges1[dd[l]][j1]]] || j == 0)) {
						tol = j1;
						tor = j2;
					}
				}
			}
			used_col[a[edges1[dd[l]][tol]]] = 1;
		//	if (j == 0) {
			//	used_col[a[edges1[l][tol ^ 1]]] = 1;
			//}

			if (j % 2 == 0) {
				int l1 = edges1[dd[l]][tol ^ 1];
				int r1 = edges1[dd[r]][tor];

				ans.push_back({ l1,r1 });
				swap(a[l1], a[r1]);
				swap(edges1[dd[l]][tol ^ 1], edges1[dd[r]][tor]);
				used_col[a[edges1[dd[l]][tol ^ 1]]] = 1;
				++l;
			}
			else {
				int l1 = edges1[dd[l]][tol];
				int r1 = edges1[dd[r]][tor ^ 1];

				ans.push_back({ l1,r1 });
				swap(a[l1], a[r1]);
				swap(edges1[dd[l]][tol], edges1[dd[r]][tor ^ 1]);
				used_col[a[edges1[dd[r]][tor ^ 1]]] = 1;
				--r;
			}
		}
	}
	cout << ans.size() << "\n";
	for (auto x : ans) {
		cout << x.first + 1 << " " << x.second + 1 << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
#ifdef _MY
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}
