#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define int ll

void solve() {
    int n;
    cin >> n;

    vector<int> a(2 * n);
    for(int i = 0; i < 2 * n; i++)
        cin >> a[i];

    vector adj(2 * n, vector<int>());
    for(int i = 1; i < 2 * n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    vector dp(2 * n, vector(2, pair<int, int>({-1, -1}))); // 1 - with, 0 - without
    function<void(int, int)> dfs = [&](int u, int p) {
        int sum = 0;
        for(int v : adj[u]) {
            if (v == p) continue;
            dfs(v, u);
            sum += max(dp[v][0].first, dp[v][1].first);
        }
        dp[u][0].first = sum;
        for(int v : adj[u]) {
            if (v == p) continue;
            int cur = 1 + sum - max(dp[v][0].first, dp[v][1].first) + dp[v][0].first;
            if (cur > dp[u][1].first) {
                dp[u][1] = {cur, v};
            }
        }
    };
    dfs(0, -1);

    vector<pair<int, int>> pars;
    function<void(int, int, bool)> get = [&](int u, int p, bool took) {
        if(!took) {
            if (dp[u][0].first >= dp[u][1].first) {
                for (int v: adj[u]) {
                    if (v == p) continue;
                    get(v, u, false);
                }
            } else {
                pars.emplace_back(u, dp[u][1].second);
                for (int v: adj[u]) {
                    if (v == p) continue;
                    get(v, u, (v == dp[u][1].second));
                }
            }
        } else {
            for (int v: adj[u]) {
                if (v == p) continue;
                get(v, u, false);
            }
        }
    };
    get(0, -1, false);

    for(auto [u, v] : pars) {
        if(u == -1 || v == -1) {
            cout << "Ploho\n";
            return;
        }
    }

//    cout << "Matching:\n";
//    for(auto [u, v] : pars)
//        cout << u + 1 << " " << v + 1 << '\n';
//    cout << "----\n";

    vector<bool> used(2 * n, false);
    for(auto [u, v] : pars) {
        if(u >= 2 * n) {
            cout << "Ploho\n";
            return;
        }
        used[u] = true;
        used[v] = true;
    }

    vector<set<int>> have(n + 1);
    for(int i = 0; i < 2 * n; i++)
        if(!used[i]) have[a[i]].insert(i);

    set<pair<int, int>> sp(all(pars));
    vector<pair<int, int>> ans;
    for(auto [u, v] : pars) {
        auto [au, av] = make_pair(a[u], a[v]);
        if(au == av) sp.erase({u, v});
        else {
            if(!have[au].empty()) {
                int nv = *have[au].begin();
                ans.emplace_back(v, nv);
                have[au].erase(nv);
                sp.erase({u, v});
            } else if(!have[av].empty()) {
                int nv = *have[av].begin();
                ans.emplace_back(u, nv);
                have[av].erase(nv);
                sp.erase({u, v});
            }
        }
    }

    pars.clear();
    for(auto [u, v] : sp)
        pars.emplace_back(u, v);

    vector<vector<int>> ps(n + 1);
    for(int i = 0; i < (int) pars.size(); i++) {
        auto [u, v] = pars[i];
        ps[a[u]].push_back(i);
        ps[a[v]].push_back(i);
    }

    int sz = (int) pars.size();
    vector<vector<int>> cycles;
    vector<bool> vis(sz, false);
    for(int i = 0; i < sz; i++) {
        if(vis[i]) continue;
        int ci = i;
        int j = a[pars[i].first];
        int oj = a[pars[i].second];
        if (ps[j].size() < 2 || ps[oj].size() < 2) continue;
        vector<int> cycle;
        while(!vis[ci]) {
            vis[ci] = true;
            j = (a[pars[ci].first] ^ a[pars[ci].second] ^ j);
            int ni = (ps[j][0] ^ ps[j][1] ^ ci);
            cycle.push_back(ci);
            ci = ni;
        }
        cycles.push_back(cycle);
    }

//    cout << "Before cycles\n";
//    for(auto [u, v] : ans) {
//        cout << u << " " << v << '\n';
//    }
//    cout << "----\n";

    for(auto vec : cycles) {
        int csz = (int) vec.size();
//        cout << "Cycle\n";
//        for(int j : vec)
//            cout << j << " ";
//        cout << '\n';
//        cout << "-----\n";
        if(csz == 2) {
            int i = vec[0];
            int j = vec[1];
            if(a[pars[i].first] == a[pars[j].first])
                ans.emplace_back(pars[i].first, pars[j].second);
            else
                ans.emplace_back(pars[i].first, pars[j].first);
            continue;
        }
        for(int _ = 0; _ + 1 < csz; _ += 2) {
            int i = vec[_];
            int j = vec[_ + 1];
            bool did = false;
            for(int u : {pars[i].first, pars[i].second}) {
                for(int v : {pars[j].first, pars[j].second}) {
                    if(a[u] == a[v]) {
                        ans.emplace_back(u, (v == pars[j].first ? pars[j].second : pars[j].first));
                        did = true;
                        break;
                    }
                }
                if(did) break;
            }
        }
        if(csz & 1) {
            int i = vec[0];
            int j = vec[csz - 1];
            bool did = false;
            for(int u : {pars[i].first, pars[i].second}) {
                for(int v : {pars[j].first, pars[j].second}) {
                    if(a[u] == a[v]) {
                        ans.emplace_back(u, (v == pars[j].first ? pars[j].second : pars[j].first));
                        did = true;
                        break;
                    }
                }
                if(did) break;
            }
        }
    }

    cout << (int) ans.size() << '\n';
    for(auto [u, v] : ans)
        cout << u + 1 << " " << v + 1 << '\n';
}


signed main() {
    int t = 1;
     cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}