#include <vector>
#include <iostream>

void calculate_neighbours(std::vector<std::vector<int>>& floor)
{
	for (int i = 0; i < 2; i++)
	{
		for (int j = 0; j < floor[i].size(); j++)
		{
			if (floor[i][j] == 0)
			{
				if (i - 1 >= 0)
				{
					if (floor[i - 1][j] != -1) floor[i][j]++;
				}
				if (i + 1 < 2)
				{
					if (floor[i + 1][j] != -1) floor[i][j]++;
				}
				if (j - 1 >= 0)
				{
					if (floor[i][j - 1] != -1) floor[i][j]++;
				}
				if (j + 1 < floor[i].size())
				{
					if (floor[i][j + 1] != -1) floor[i][j]++;
				}
			}
		}
	}
}

std::pair<int, int> find_neighbour(int i, int j, const std::vector<std::vector<int>>& floor)
{
	if (i - 1 >= 0)
	{
		if (floor[i - 1][j] != -1) return { i - 1, j };
	}
	if (i + 1 < 2)
	{
		if (floor[i + 1][j] != -1) return { i + 1, j };
	}
	if (j - 1 >= 0)
	{
		if (floor[i][j - 1] != -1) return { i, j - 1 };
	}
	if (j + 1 < floor[i].size())
	{
		if (floor[i][j + 1] != -1) return { i, j + 1 };
	}
}

void decrease_neigbours(int i, int j, std::vector<std::vector<int>>& floor)
{
	if (i - 1 >= 0)
	{
		if (floor[i - 1][j] != -1) floor[i - 1][j]--;
	}
	if (i + 1 < 2)
	{
		if (floor[i + 1][j] != -1) floor[i + 1][j]--;
	}
	if (j - 1 >= 0)
	{
		if (floor[i][j - 1] != -1) floor[i][j - 1]--;
	}
	if (j + 1 < floor[i].size())
	{
		if (floor[i][j + 1] != -1) floor[i][j + 1]--;
	}
}

void print_floor(const std::vector<std::vector<int>>& floor)
{
	for (int i = 0; i < 2; i++)
	{
		for (int j = 0; j < floor[i].size(); j++)
		{
			std::cout << floor[i][j] << ' ';
		}
		std::cout << '\n';
	}
}

int main()
{
	int T;
	std::cin >> T;
	
	while(T--)
	{
		int n;
		std::cin >> n;

		std::vector<std::vector<int>> floor(2, std::vector<int>(n));

		int free_places_counter = 0;

		for (int i = 0; i < 2; i++)
		{
			for (int j = 0; j < n; j++)
			{
				char ch;
				std::cin >> ch;
				
				if (ch == '#') floor[i][j] = -1;
				else
				{
					floor[i][j] = 0;
					free_places_counter++;
				}
			}
		}

		if (free_places_counter % 2)
		{
			std::cout << "None\n";
			continue;
		}
	
		calculate_neighbours(floor);

		bool flag = false;
		do
		{
			flag = false;

			for (int i = 0; i < 2; i++)
			{
				for (int j = 0; j < n; j++)
				{
					if (floor[i][j] == 1)
					{
						flag = true;

						floor[i][j] = -1;
						auto neigh = find_neighbour(i, j, floor);
						floor[neigh.first][neigh.second] = -1;
						decrease_neigbours(neigh.first, neigh.second, floor);
					}
				}
			}

		} while (flag);
		
		flag = false;
		for (int i = 0; i < 2; i++)
		{
			for (int j = 0; j < n; j++)
			{
				if (floor[i][j] == 0)
				{
					std::cout << "None\n";
					flag = true;
					break;
				}
				else if (floor[i][j] != -1)
				{
					std::cout << "Multiple\n";
					flag = true;
					break;
				}
			}

			if (flag) break;
		}

		if (!flag) std::cout << "Unique\n";
	}
	
	return 0;
}

/*
4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###
*/