#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> build(const vector<string> &a, int n) {
    vector<vector<int>> g(2 * n);

    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == '#') continue;

            if (i == 0) {
                if (a[i+1][j] == '.') g[i * n + j].push_back((i + 1) * n + j);
            } else {
                if (a[i-1][j] == '.') g[i * n + j].push_back((i - 1) * n + j);
            }

            if (j > 0 && a[i][j-1] == '.') g[i * n + j].push_back(i * n + j - 1);
            if (j + 1 < n && a[i][j+1] == '.') g[i * n + j].push_back(i * n + j + 1);
        }
    }

    return g;
}

int dfs(const vector<vector<int>> &g, int v, vector<bool> &used) {
    if (used[v]) return 0;
    used[v] = true;
    int ans = 1;
    for (int to : g[v]) {
        if (!used[to]) ans += dfs(g, to, used);
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;

    vector<string> a(2);
    cin >> a[0] >> a[1];

    int tot = 0;
    vector<vector<int>> g = build(a, n);
    vector<int> d(2 * n, 0);
    vector<bool> used(2 * n, false);
    queue<int> s;

    vector<bool> used_cc(2 * n, false);
    
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            int cur = i * n + j;

            if (a[i][j] == '#') continue;
            tot++;

            d[cur] = g[cur].size();

            if (d[cur] == 1) {
                s.push(cur);
            }

            if (dfs(g, cur, used_cc) % 2 == 1) {
                cout << "None\n";
                return;
            }
        }
    }

    n *= 2;

    while (!s.empty()) {
        int v = s.front();
        s.pop();

        if (used[v]) continue;

        int cnt = 0;

        used[v] = true;
        for (int to : g[v]) {
            if (used[to]) continue;

            used[to] = true;
            cnt++;
            for (int u : g[to]) {
                if (used[u]) continue;
                
                d[u]--;

                if (d[u] == 1) s.push(u);
            }
        }

        if (cnt != 1) {
            cout << "None\n";
            return;
        }
    }

    int cnt = 0;
    for (int i = 0 ; i < n; i++) {
        if (used[i]) cnt++;
    }

    if (cnt == tot) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--) solve();
    return 0;
}