#include <bits/stdc++.h>
#define int long long

using namespace std;

const double eps = 1e-8;

struct vec {
    double x, y;

    vec (double a = 0, double b = 0) {
        x = a;
        y = b;
    }

    vec operator+(vec a) {
        return vec(x + a.x, y + a.y);
    }

    vec operator-(vec a) {
        return vec(x - a.x, y - a.y);
    }

    vec operator*(double k) {
        return vec(x * k, y * k);
    }

    double operator*(vec a) {
        return x * a.x + y * a.y;
    }

    double operator^(vec a) {
        return x * a.y - a.x * y;
    }

    double sz() {
        return sqrt(x * x + y * y);
    }

    vec norm() {
        return vec(-y, x);
    }

    vec norma() {
        return vec(x / sz(), y / sz());
    }

    vec deg45() {
        vec v(x, y);
        v = v + (v.norm());
        return (v * (1 / sqrt(2)));
    }

    void print() {
        cout << setprecision(10) << fixed << x << " " << y << '\n';
    }
};

bool operator<(vec a, vec b) {
    if (abs(a.x - b.x) < eps) return a.y < b.y;
    return a.x < b.x;
}

bool operator<(pair<vec, vec> a, pair<vec ,vec> b) {
    if ((a.first - b.first).sz() < eps) {
        return a.second < b.second;
    }
    return a.first < b.first;
}

bool check(vector<pair<vec, vec>> a, vector<pair<vec, vec>> b) {
    if (a.size() != b.size()) return 0;
    vec mi = a[0].first;
    for (int i = 0; i < a.size(); i++) {
        if (a[i].second < a[i].first) {
            swap(a[i].first, a[i].second);
        }
        if (a[i].first < mi) {
            mi = a[i].first;
        }
    }
    //cout << "START\n";
   // mi.print();
    for (int i = 0; i < a.size(); i++) {
        a[i].first = a[i].first - mi;
        a[i].second = a[i].second - mi;
    }
    sort(a.begin(), a.end());
    /*for (int i = 0; i < a.size(); i++) {
        a[i].first.print();
        a[i].second.print();
        b[i].first.print();
        b[i].second.print();
        cout << "HUI\n";
    }*/
    for (int i = 0; i < a.size(); i++) {
        if (abs((a[i].first - b[i].first).sz()) > eps || abs((a[i].second - b[i].second).sz()) > eps) {
            return 0;
        }
    }
    return 1;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<char, int>> a(n);
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        int k;
        cin >> k;
        a[i] = {t[0], k};
    }
    vector<set<pair<vec, vec>>> ass(4);
    vec v(1, 0);
    int t = 0;
    vec p(0, 0);
    for (int i = 0; i < n; i++) {
        if (a[i].first == 'r') {
            for (int j = 0; j < a[i].second / 45; j++) {
                t++;
                v = v.deg45();
            }
        } else if (a[i].first == 'm') {
            p = p + (v * a[i].second);
        } else {
            vec np = p + (v * a[i].second);
            ass[t % 4].insert({min(p, np), (p + np) - min(p, np)});
            p = np;
        }
    }
    vector<pair<vec, vec>> b;
    for (int i = 0; i < 4; i++) {
        for (auto j : ass[i]) {
            bool f = 1;
            for (int o = 0; o < b.size(); o++) {
                if ((b[o].second - j.first).sz() < eps && abs((j.second - j.first) ^ (b[o].second - b[o].first)) < eps) {
                    b[o].second = j.second;
                    f = 0;
                    break;
                }
            }
            if (f) {
                b.push_back(j);
            }
        }
    }
    vec mi = b[0].first;
    vector<pair<vec, vec>> c(b.size());
    for (int i = 0; i < b.size(); i++) {
        c[i] = b[i];
        if (b[i].first < mi) {
            mi = b[i].first;
        }
    }
    for (int i = 0; i < b.size(); i++) {
        b[i].first = b[i].first - mi;
        b[i].second = b[i].second - mi;
    }
    sort(b.begin(), b.end());
    /*for (int i = 0; i  <b.size(); i++) {
        b[i].first.print();
        b[i].second.print();
        cout << "HUIn\n";
    }*/
    for (int i = 1; i < 10; i++) {
        for (int j = 0; j < c.size(); j++) {
            c[j].first = c[j].first.deg45();
            c[j].second = c[j].second.deg45();
        }
        if (check(c, b)) {
            cout << 45 * i;
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t --> 0) {
        solve();
    }
    return 0;
}
