#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<pair<int, int>> answer;

void cycle(int v, int u, vector<int> &a, vector<pair<int, int>> &b, vector<bool> &used, map<int, int> &matching) {
    if (a[v] == a[u]) {
        return;
    }
    used[a[v]] = 1;
    used[a[u]] = 1;
    int v1 = b[a[v]].first;
    int v2 = b[a[v]].second;

    int vother = v1;
    if (v1 == v)
        vother = v2;
    answer.push_back({u, vother});
    swap(a[u], a[vother]);

    if (b[a[u]].first == u) {
        b[a[u]].first = vother;
    } else {
        b[a[u]].second = vother;
    }

    int nm = matching[vother];

    cycle(vother, nm, a, b, used, matching);
}

void dfs(int v, vector<vector<int>> &g, vector<bool> &used, vector<pair<int, int>> &ans, vector<bool> &term) {
    used[v] = 1;

    for (auto now: g[v]) {
        if (used[now]) continue;

        dfs(now, g, used, ans, term);

        if (!term[v] && !term[now]) {
            term[v] = 1;
            term[now] = 1;
            ans.push_back({v, now});
        }
    }
}


void solve() {
    int n;
    answer.clear();
    cin >> n;
    vector<int> a(2 * n);
    vector<vector<int>> g(n + 5);

    for (int i = 0; i < 2 * n; ++i) {
        cin >> a[i];
        a[i]--;
    }

    for (int i = 0; i < 2 * n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<pair<int, int>> ans;
    vector<bool> used(2 * n + 5, false);
    vector<bool> term(2 * n + 5, false);

    dfs(0, g, used, ans, term);

    vector<pair<int, int>> b(n, {-1, -1});

    vector<vector<int>> graph(n + 5);
    map<int, int> matching;
    for (auto now: ans) {
        matching[now.first] = now.second;
        matching[now.second] = now.first;

        if (b[a[now.first]].first == -1) {
            b[a[now.first]].first = now.first;
        } else {
            b[a[now.first]].second = now.first;
        }
        if (b[a[now.second]].first == -1) {
            b[a[now.second]].first = now.second;
        } else {
            b[a[now.second]].second = now.second;
        }

        graph[now.first].push_back(now.second);
        graph[now.second].push_back(now.first);
    }

    for (int i = 0; i < n; ++i) {
        if (b[i].first != -1 && b[i].second != -1) {
            graph[b[i].first].push_back(b[i].second);
            graph[b[i].second].push_back(b[i].first);
        }
    }

    for (int i = 0; i < 2 * n; ++i) {
        if (b[a[i]].first == -1) {
            b[a[i]].first = i;
        } else if (b[a[i]].second == -1 && b[a[i]].first != i) {
            b[a[i]].second = i;
        }
    }


    used.assign(2 * n + 5, 0);

    for (int i = 0; i < 2 * n; ++i) {
        if (used[i]) continue;

        if (graph[i].size() == 1) {
            int goo = graph[i][0];
            int last = i;
            used[i] = 1;
            used[goo] = 1;

            while (graph[goo].size() == 2) {
                if (graph[goo][0] == last) {
                    swap(graph[goo][0], graph[goo][1]);
                }

                int temp = goo;
                goo = graph[goo][0];
                last = temp;
            }

            if (b[a[i]].first == i) {
                answer.push_back({b[a[i]].second, goo});
                swap(a[b[a[i]].second], a[goo]);
            } else {
                answer.push_back({b[a[i]].first, goo});
                swap(a[b[a[i]].first], a[goo]);
            }

            cycle(i, matching[i], a, b, used, matching);
        }
    }
    //used.assign(2 * n + 5, 0);

    for (int i = 0; i < 2 * n; ++i) {
        if (used[i]) continue;
        if (matching.count(i) == 0) continue;

        cycle(i, matching[i], a, b, used, matching);
    }

    cout << answer.size() << '\n';
    for (auto now: answer) {
        cout << now.first + 1 << ' ' << now.second + 1 << '\n';
    }
}

/*
 3
 2
 1 2 2 1
 1 2
 2 3
 3 4
 4
 4 3 1 3 2 4 1 2
 1 2
 3 1
 3 4
 5 1
 5 6
 2 7
 2 8
 3
 1 1 2 2 3 3
 1 2
 1 3
 1 4
 1 5
 1 6
 */

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;

    while (t-- > 0) {
        solve();
    }
    return 0;
}
