#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define F first
#define S second
#define ll long long

string s;

pair<ll, pair<int, bool>> number(const string &s, int from) {
    ll ans = 0;
    int len = 0;
    for (; from < s.size() && s[from] >= '0' && s[from] <= '9'; ++from) {
        if (ans == 0 && s[from] == '0') {
            return {0, {0, 0}};
        }
        ans = ans * 10 + (s[from] - '0');
        if (++len > 10) return {0, {0, 0}};
    }
    if (!len) return {0, {0, 0}};
    return {ans, {from, 1}};
}

pair<ll, pair<int, bool>> expression(const string &s, int from = 0) {
    auto t = number(s, from);
    ll ans = t.F;
    from = t.S.F;
    if (!t.S.S) {
        return {0, {0, 0}};
    }
    while (from < s.size() && s[from] != '=') {
        t = number(s, from+1);
        if (!t.S.S) {
            return {0, {0, 0}};
        }
        switch (s[from]) {
        case '+':
            ans += t.F;
            break;
        case '-':
            ans -= t.F;
            break;
        }
        from = t.S.F;
    }
    return {ans, {from, 1}};
}

pair<bool, bool> evaluate(const string &s) {
//    cerr << s << endl;
    auto expr1 = expression(s);
    if (!expr1.S.S) return {0, 0};
    auto expr2 = expression(s, expr1.S.F + 1);
    if (!expr2.S.S) return {0, 0};
//    cerr << s << ' ' << expr1.F << ' ' << expr2.F << endl;
    return {expr1.F == expr2.F, 1};
}

void addSubstr(string &to, int from, int toExclusive) {
    for (int i = from; i < toExclusive; ++i)
        to += s[i];
}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
    #endif // LOCAL
    cin >> s;
    if (evaluate(s).F) {
        cout << "Correct" << endl;
        return 0;
    }
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        if (s[i] < '0' || s[i] > '9') continue;
        for (int j = 0; j < i; ++j) {
            string nw;
            addSubstr(nw, 0, j);
            nw += s[i];
            addSubstr(nw, j, i);
            addSubstr(nw, i+1, n);
            auto t = evaluate(nw);
            if (!t.S) continue;
            if (t.F) {
                cout << nw << endl;
                return 0;
            }
        }
        for (int j = i+1; j <= n; ++j) {
            string nw;
            addSubstr(nw, 0, i);
            addSubstr(nw, i+1, j);
            nw += s[i];
            addSubstr(nw, j, n);
            auto t = evaluate(nw);
            if (!t.S) continue;
            if (t.F) {
                cout << nw << endl;
                return 0;
            }
        }
    }
    cout << "Impossible" << endl;
}
