#include <bits/stdc++.h>

#define i4 int32_t
#define u4 uint32_t
#define i8 int64_t
#define u8 int64_t

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front

using namespace std;

template<class T>
using Vec = vector<T>;

template<class T, class V>
using Pair = pair<T, V>;

void Dfs(const Vec<Vec<i4> > & g, i4 v, Vec<i4>& pl) {
    for (auto to : g[v]) {
        pl[to] = 1;
        Dfs(g, to, pl);
    }
}

void Sort(const Vec<Vec<i4> > & g, i4 v, Vec<bool>& used, Vec<i4>& p) {
    used[v] = true;
    for (auto to : g[v]) {
        if (used[to]) {
            continue;
        }
        Sort(g, to, used, p);
    }

    p.pb(v);
}

Vec<i4> TopSort(const Vec<Vec<i4>>& g) {
    i4 n = g.size();
    Vec<i4> in(n);

    for (i4 i = 0; i < g.size(); ++i) {
        for (auto to : g[i]) {
            in[to]++;
        }
    }

    Vec<i4> res;

    Vec<bool> used(g.size());

    for (i4 i = 0; i < n; ++i) {
        if (in[i] == 0) {
            Sort(g, i, used, res);
        }
    }

    return res;
}

bool CycleCheck(Vec<Vec<i4> >& g, Vec<i4>& used, i4 v) {
    used[v] = 1;

    bool res = true;
    for (auto to : g[v]) {
        if (used[to] == 2) {
            continue;
        }
        if (used[to] == 1) {
            return false;
        }

        res &= CycleCheck(g, used, to);
    }

    used[v] = 2;
    return true;
}

Vec<i4> Arange(const Vec<Pair<i4, i4> >& op, const Vec<Pair<i4, i4>>& e) {
    i4 n = op.size();
    i4 m = e.size();

//    for (auto [x, y] : op) {
//        cerr << x << ' ' << y << '\n';
//    }
//    cerr << '\n';

    Vec<i4> b(n, -1);

    i4 tr01 = -1;
    i4 tr10 = -1;

    for (i4 i = 0; i < n; ++i) {
        if (op[i] == make_pair(1, 1)) {
            b[i] = 1;
        }

        if (op[i] == make_pair(0, 1)) {
            tr01 = i;
        }

        if (op[i] == make_pair(1, 0)) {
            tr10 = i;
        }
    }

    Vec<Vec<i4> > g(n);
    Vec<Vec<i4> > rg(n);

    for (i4 i = 0; i < m; ++i) {
        g[e[i].first].pb(e[i].second);
        rg[e[i].second].pb(e[i].first);
    }


    Vec<i4> pl01(n);
    Vec<i4> pl10(n);

    if (tr01 != -1) {
        Dfs(g, tr01, pl01);
    }

    for (i4 i = 0; i < n; ++i) {
        if (b[i] == 1) {
            if (pl01[1]) {
                return {};
            }
            continue;
        }

        if (pl01[i] == 1) {
            b[i] = 2;
        }
    }

    fill(pl01.begin(), pl01.end(), 0);

    if (tr01 != -1) {
        Dfs(rg, tr01, pl01);
    }

    for (i4 i = 0; i < n; ++i) {
        if (b[i] == 1) {
            if (pl01[1]) {
                return {};
            }
            continue;
        }

        if (pl01[i] == 1) {
            b[i] = 0;
        }
    }

    if (pl01[tr10] == 1) {
        return {};
    }

    if (tr10 != -1) {
        Dfs(g, tr10, pl10);
    }

    for (i4 i = 0; i < n; ++i) {
        if (b[i] == 1) {
            if (pl10[i] == 1) {
                return {};
            }
            continue;
        }

        if (pl10[i] == 1) {
            if (b[i] == 0) {
                return {};
            }
            b[i] = 2;
        }
    }

    fill(pl10.begin(), pl10.end(), 0);

    if (tr10 != -1) {
        Dfs(rg, tr10, pl10);
    }

    for (i4 i = 0; i < n; ++i) {
        if (b[i] == 1) {
            if (pl10[i] == 1) {
                return {};
            }
            continue;
        }

        if (pl10[i] == 1) {
            if (b[i] == 2) {
                return {};
            }
            b[i] = 0;
        }
    }

    for (i4 i = 0; i < n; ++i) {
        if(i == tr01) {
            continue;
        }

        if(i == tr10) {
            continue;
        }

        if (b[i] == -1) {
            b[i] = 0;
        }
    }

    Vec<Vec<i4>> gb[3];

    gb[0].resize(n);
    gb[1].resize(n);
    gb[2].resize(n);

    b[tr01] = -1;
    b[tr10] = -1;

    for (auto [u, v] : e) {
        if (u == tr01 || v == tr01) {
            continue;
        }

        if (u == tr10 || v == tr10) {
            continue;
        }

        if (b[u] != b[v]) {
            continue;
        }

        gb[b[u]][u].pb(v);
    }

    auto b1 = TopSort(gb[0]);
    auto b2 = TopSort(gb[1]);
    auto b3 = TopSort(gb[2]);

    Vec<i4> res;

    for (auto to : b2) {
        if (b[to] != 0) {
            continue;
        }
        res.pb(to);
    }


    if (tr01 != -1) {
        res.pb(tr01);

        for (auto to : b2) {
            if (b[to] != 1) {
                continue;
            }
            res.pb(to);
        }

        if (tr10 != -1) {
            res.pb(tr10);

            for (auto to : b3) {
                if (b[to] != 2) {
                    continue;
                }
                res.pb(to);
            }
        }
    }

    if (res.size() != n) {
        return {};
    }

    Vec<i4> pos(n);

    i4 it = 0;
    for (auto to : res) {
        pos[to] = it++;
    }

    for (auto [u, v] : e) {
        if (pos[u] > pos[v]) {
            return {};
        }
    }

    return res;
}

void Solve() {
    int n;
    cin >> n;
    vector <pair<int, int>> op;
    for(int i = 0;i < n;i++){
        string s, t;
        cin >> s >> t;
        int ff, ss;
        if(t == "true"){
            if(s == "set") ss = 1, ff = 0;
            else ss = 0, ff = 1;
        }
        else{
            if(s == "set") ss = 1, ff = 1;
            else ss = 0, ff = 0;
        }
        op.push_back({ff, ss});
//        cerr << ff << ' ' << ss << '\n';
    }
    int m;
    cin >> m;
//    cerr << '\n';
    vector <pair<int, int>> edges(m);

    Vec<Vec<i4> > cg(n);

    for(int i = 0;i < m;i++){
        cin >> edges[i].first >> edges[i].second;
        edges[i].first--;
        edges[i].second--;


        cg[edges[i].first].pb(edges[i].second);
    }


    Vec<i4> used(n);


    for (i4 i = 0; i < n; ++i) {
        if (used[i] != 0) {
            continue;
        }

        if (!CycleCheck(cg, used, i)) {
            cout << -1 << '\n';
            return;
        }
    }



    Vec<i4> res1 = Arange(op, edges);
//    Vec<i4> res1 = {};

    for (i4 i = 0; i < n; ++i) {
        op[i].first ^= 1;
        op[i].second ^= 1;
    }

    auto res2 = Arange(op, edges);
//    auto res2 = res1;


    if (res1.empty() && res2.empty()) {
        cout << -1 << '\n';
        return;
    }

    if (res1.empty()) {
        res1 = res2;
    }

    for (auto to : res1) {
        cout << to + 1 << ' ';
    }
    cout << '\n';

}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    i4 t = 1;
//    cin >> t;

    for (i4 iter = 0; iter < t; ++iter) {
        Solve();
    }
}


