#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <cstdint>
#include <string>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i,n) for(int i = 0; i < int(n); i++)
#define fore(i,l,n) for(int i = l; i < int(n); i++)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define endl '\n'

int n; 
vector<pair<string, string>> a;
vector<set<int>> g, gt;
set<int> deleted;
vector<int> ans, b;

void valid()
{
	forn(v, n)
	{
		vector<int> ford;
		for (auto u : g[v])
			if (deleted.count(u))
				ford.pb(u);
		forn(i, ford.size())
			g[v].erase(ford[i]);
		ford = {};
		for (auto u : gt[v])
			if (deleted.count(u))
				ford.pb(u);
		forn(i, ford.size())
			gt[v].erase(ford[i]);

		if (deleted.count(v))
		{
			g[v].clear();
			gt[v].clear();
		}
	}
}

vector<int> func(string type, int root)
{
	vector<int> res;
	set<pair<int, int>> q;
	forn(i, n) b[i] = g[i].size();
	forn(i, n)
		if (!deleted.count(i))
			q.insert({ b[i], i });

	while (q.size())
	{
		auto pr = *q.begin();
		q.erase(q.begin());
		if (pr.first > 0) break;
		int v = pr.second;
		if (a[v].first != type) continue;
		res.pb(v);
		if (v == root) continue;
		for (auto u : gt[v])
		{
			q.erase({ b[u], u });
			b[u]--;
			q.insert({ b[u], u });
		}
	}
	return res;
}


void solve()
{
	cin >> n;
	a.resize(n);
	g.resize(n);
	gt.resize(n);
	b.assign(n, 0);

	forn(i, n) cin >> a[i].first >> a[i].second;
	int m; cin >> m;
	forn(i, m)
	{
		int u, v; cin >> u >> v;
		u--; v--;
		g[u].insert(v);
		gt[v].insert(u);
	}
	
	int l = -1, r = -1;
	forn(i, n)
	{
		if (a[i].second == "true")
		{
			if (l == -1)
				l = i;
			else
				r = i;
		}
	}

	// cerr << l << ' ' << r << endl;

	if (l == -1)
	{
		// no true
		forn(i, n)
			if (a[i].first == "set")
			{
				cout << -1 << endl;
				return;
			}


		vector<int> have = func("unset", -1);
		valid();
		if (have.size() != n)
		{
			cout << -1 << endl;
			return;
		}
		ans = have;
	}
	else if (r == -1)
	{
		// 1 true
		if (a[l].first == "unset")
		{
			cout << -1 << endl;
			return;
		}
		

		vector<int> have = func("set", l);
		int ind = -1;
		forn(i, have.size())
			if (have[i] == l)
				ind = i;
		if (ind == -1)
		{
			cout << -1 << endl;
			return;
		}
		have.erase(have.begin() + ind);
		have.pb(l);

		forn(i, have.size())
		{
			deleted.insert(have[i]);
			ans.pb(have[i]);
		}
		valid();

		have = func("unset", -1);

		if (have.size() + ans.size() != n)
		{
			cout << -1 << endl;
			return;
		}

		forn(i, have.size())
			ans.pb(have[i]);
	}
	else
	{
		// 2 true
		if (!(a[l].first == "set" && a[r].first == "unset" || a[l].first == "unset" && a[r].first == "set"))
		{
			cout << -1 << endl;
			return;
		}

		if (a[l].first == "unset")
			swap(l, r);

		vector<int> have = func("unset", r);
		int ind = -1;
		forn(i, have.size())
			if (have[i] == r)
				ind = i;
		if (ind == -1)
		{
			cout << -1 << endl;
			return;
		}
		have.erase(have.begin() + ind);
		have.pb(r);

		forn(i, have.size())
		{
			deleted.insert(have[i]);
			ans.pb(have[i]);
		}
		valid();

		have = func("set", l);

		ind = -1;
		forn(i, have.size())
			if (have[i] == l)
				ind = i;
		if (ind == -1)
		{
			cout << -1 << endl;
			return;
		}
		have.erase(have.begin() + ind);
		have.pb(l);

		forn(i, have.size())
		{
			deleted.insert(have[i]);
			ans.pb(have[i]);
		}
		valid();

		have = func("unset", -1);

		if (have.size() + ans.size() != n)
		{
			cout << -1 << endl;
			return;
		}

		forn(i, have.size())
			ans.pb(have[i]);
	}
	reverse(all(ans));
	forn(i, ans.size()) cout << ans[i]  + 1 << ' ';
	cout << endl;
}
bool multitest = 0;


int32_t main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	
	int tests = 1;
	if (multitest)
		cin >> tests;

	while (tests--)
		solve();
}