#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <cstdint>
#include <string>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i,n) for(int i = 0; i < int(n); i++)
#define fore(i,l,n) for(int i = l; i < int(n); i++)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define endl '\n'


ll comp(string s)
{
	if (!s.size()) return false;
	ll res = 0;
	string t = "";
	int flag = 1;
	forn(i, s.size())
	{
		if (s[i] == '+')
		{
			res += flag * stoll(t);
			flag = 1;
			t = "";
		}
		else if (s[i] == '-')
		{
			res += flag * stoll(t);
			flag = -1;
			t = "";
		}
		else
			t += s[i];
	}
	res += flag * stoll(t);
	return res;
}


bool check(string s)
{
	vector<string> a;
	string t = "";
	forn(i, s.size())
	{
		if (s[i] == '-' || s[i] == '+' || s[i] == '=')
		{
			a.pb(t);
			t = "";
		}
		else
			t += s[i];
	}
	a.pb(t);

	forn(i, a.size())
	{
		string str = a[i];
		if (str.size() == 0) return false;
		if (str.size() > 10) return false;
		if (str.size() != 1 && str[0] == '0') return false;
	}
	return true;
}

bool iseq(string s)
{
	if (!check(s)) return false;
	string l, r;
	int ind = -1;
	forn(i, s.size())
	{
		if (s[i] == '=')
		{
			ind = i;
			break;
		}
		l += s[i];
	}
	if (ind == -1) return false;
	for (int i = ind + 1; i < s.size(); i++)
		r += s[i];

	return comp(l) == comp(r);
}

void solve()
{
	string s; cin >> s;

	if (iseq(s))
	{
		cout << "Correct" << endl;
		return;
	}

	forn(i, s.size())
	{
		string t = s;
		char x = t[i];
		t.erase(t.begin() + i);
		forn(j, s.size())
		{
			string u = t;
			u.insert(u.begin() + j, x);
			if (iseq(u))
			{
				cout << u << endl;
				return;
			}
		}
	}
	cout << "Impossible" << endl;
}
bool multitest = 0;


int32_t main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	
	int tests = 1;
	if (multitest)
		cin >> tests;

	while (tests--)
		solve();
}