#include <bits/stdc++.h>

using namespace std;

int n;

int getN(int x, int y) {
    return (x - 1) * n + y;
}

pair <int, int> getP(int num) {
    int x, y;
    if (num <= n) x = 1, y = num;
    else x = 2, y = num - n;
    return {x, y};
}

void solve() {
    cin >> n;

    char c[3][n + 1];
    for (int i = 1; i <= 2; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> c[i][j];
        }
    }

    int X[] = {1, -1, 0, 0};
    int Y[] = {0, 0, 1, -1};

    vector <int> deg(2 * n + 1);
    vector <int> g[2 * n + 1];
    for (int i = 1; i <= 2; i++) {
        for (int j = 1; j <= n; j++) {
            if (c[i][j] == '.') {
                for (int d = 0; d < 4; d++) {
                    int toX = i + X[d];
                    int toY = j + Y[d];
                    if (toX < 1 || toX > 2 || toY < 1 || toY > n) continue;
                    if (c[toX][toY] == '.') {
                        g[getN(i, j)].push_back(getN(toX, toY));
                        deg[getN(i, j)]++;
                    }
                }
            }
        }
    }

    queue <int> q;
    for (int i = 1; i <= 2 * n; i++) {
        if (deg[i] == 1) {
            q.push(i);
        }
    }

    while (!q.empty()) {
        int v = q.front();
        int vx = getP(v).first, vy = getP(v).second;
        q.pop();
        if (c[vx][vy] == '#') continue;
        for (int u : g[v]) {
            int ux = getP(u).first, uy = getP(u).second;
            if (c[ux][uy] == '#') continue;
            deg[u]--;
            c[vx][vy] = '#';
            c[ux][uy] = '#';
            for (int u2 : g[u]) {
                int u2x = getP(u2).first;
                int u2y = getP(u2).second;
                if (c[u2x][u2y] == '#') continue;
                deg[u2]--;
                if (deg[u2]) {
                    q.push(u2);
                }
            }
            continue;
        }
    }

    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        if (c[1][i] != c[2][i]) {
            cout << "None\n";
            return;
        }
        if (c[1][i] == '.') cnt++;
    }

    if (cnt == 0) {
        cout << "Unique" << endl;
    } else {
        cout << "Multiple" << endl;
    }
}

int main() {
    int tt;
    cin >> tt;
    while (tt--) solve();
}
