#include <iostream>
#include <vector>
#include <string>
#include <stdint.h>

using namespace std;
vector<uint16_t> get(uint16_t x) {

	vector<uint16_t> all(300);
	int pos = 16;
	// 00 
	all[0] = 0xFFF0;
	all[1] = 0x0122;
	all[2] = 16;
	all[3] = 0b10; // 0030=false, 0031=true
	for (int i = 0; i < 16; ++i) {
		bool right_bit = x & 1;
		x >>= 1;
		// do nothing
		all[pos] = 0;
		all[pos + 1] = 0;
		all[pos + 2] = pos + 8;

		//
		all[pos + 8] = 0xFFF1 + i;
		all[pos + 9] = (pos + 16) * 16 + 0x22;
		all[pos + 10] = pos + 16;

		all[pos + 12] = 0xFFF1 + i;
		all[pos + 13] = (pos + 16) * 16 + 0x22;
		all[pos + 14] = pos + 16;

		all[pos + 8 + 4 * (!right_bit)] = 0x0030;
		all[pos + 9 + 4 * (!right_bit)] = 0xFFF0;
		all[pos + 10 + 4 * (!right_bit)] = 0xFFFF;
		if (i == 15) {
			all[pos + 8 + 4 * (right_bit)] = 0x0031;
			all[pos + 9 + 4 * (right_bit)] = 0xFFF0;
			all[pos + 10 + 4 * (right_bit)] = 0xFFFF;
		}
		pos += 16;
	}
	return all;
}

bool execute(uint16_t x, uint16_t io, vector<uint16_t> bb) {
	vector<char> bits(65536);
	auto cp = io;
	bool expected = x == io;
	for (int j = bits.size() - 16; j < bits.size(); ++j) {
		bits[j] = cp & 1;
		cp >>= 1;
	}
	for (int j = 0; j < bb.size(); ++j) {
		int k = j * 16;
		for (int w = 0; w < 16; ++w, ++k) {
			bits[k] = bb[j] & 1;
			bb[j] >>= 1;
		}
	}
	auto get_wrd = [&](int pos) {
		pos *= 16;
		pos += 15;
		uint16_t c = 0;
		for (int w = 0; w < 16; ++w, --pos) {
			c = (c << 1) | bits[pos];
		}
		return c;
	};
	int ip = 0;
	while (ip < 4096 - 2) {
		auto a = get_wrd(ip);
		auto b = get_wrd(ip + 1);
		auto c = get_wrd(ip + 2);
		bits[b] = bits[a];
		ip = c;
	}
	return bits[bits.size() - 16] == expected;
}

int main() {
	/*
	for (int x = 0; x < 1000; ++x) {
		auto r = get(x);
		for (int k = 0; k < 1000; ++k) {
			if (!execute(x, k, r)) {
				return -1;
			}
		}
		cerr << ".";
	}
	return 0;*/
	int x;
	cin >> x;
	char tab[128];
	for (char c = '0'; c <= '9'; ++c) tab[c - '0'] = c;
	for (char c = 'a'; c <= 'f'; ++c) tab[c + 10 - 'a'] = c;
	for (auto& e : get(x)) {
		for (int j = 3; j > -1; --j) {
			cout << tab[(e >> (j * 4)) & 0xF];
		}
		cout << " ";
	}

}