#include <iostream>
#include <utility>
#include <vector>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
#define d_c(type, name) type name; cin >> name
#define d_cl(name) d_c(ll, name)
#define d_cs(name) d_c(string, name)

int rec(vector<string> data, int i) {
    int sum = 0;
    if (i >= data[0].length()) {
        if (data[0].find('.') == string::npos && data[1].find('.') == string::npos)
            return 1;
        return 0;
    }
    if (data[0][i] == '.') {
        if ((i + 1 < data[0].length()) && (data[0][i + 1] == '.')) {
            data[0][i] = '#';
            data[0][i + 1] = '#';
            sum += rec(data, i + 1);
            if((i + 1 < data[1].length()) &&data[1][i+1] == '.' && data[1][i]=='.')
            {
                data[1][i] = '#';
                data[1][i + 1] = '#';
                sum += rec(data, i + 1);
                data[1][i] = '.';
                data[1][i + 1] = '.';
            }
            data[0][i] = '.';
            data[0][i + 1] = '.';
        }
        if (data[1][i] == '.') {
            data[0][i] = '#';
            data[1][i] = '#';
            sum += rec(data, i + 1);
            data[0][i] = '.';
            data[1][i] = '.';
        }
    } else {
        if ((i + 1 < data[1].length()) && (data[1][i] == '.' && data[1][i + 1] == '.')) {
            data[1][i] = '#';
            data[1][i + 1] = '#';
            sum += rec(data, i + 1);
            data[1][i] = '.';
            data[1][i + 1] = '.';
        }
        if (data[1][i] == '#')
            sum += rec(data, i + 1);
    }
    return sum;
}

struct Block {
    vector<string> data;
    bool is_mult;

    explicit Block(vector<string> data, bool is_mult = false) : data(std::move(data)), is_mult(is_mult) {}

    bool match(const Block &rhs) {
        for (int i = 0; i < data.size(); i++) {
            for (int j = 0; j < data[i].size(); j++) {
                if (data[i][j] == 'X' || rhs.data[i][j] == 'X') {
                    continue;
                }
                if (data[i][j] != rhs.data[i][j]) {
                    return false;
                }
            }
        }
        return true;
    }

    Block replace(const Block &rhs) {
        Block res = *this;
        for (int i = 0; i < data.size(); i++) {
            for (int j = 0; j < data[i].size(); j++) {
                if (rhs.data[i][j] == 'X') {
                    continue;
                }
                res.data[i][j] = rhs.data[i][j];
            }
        }
        return res;
    }
};

string stupid(vector<string> data) {
    int recSum = rec(data, 0);
    if (recSum == 0) {
        return "None";
    }
    if (recSum == 1) {
        return "Unique";
    }
    return "Multiple";
}
vector<pair<Block, Block>> patterns{
        {Block({"#..", "X#X"}), Block({"###", "X#X"})},
        {Block({"X#X", "#.."}), Block({"X#X", "###"})},
        {Block({"..#", "X#X"}), Block({"###", "X#X"})},
        {Block({"X#X", "..#"}), Block({"X#X", "###"})},
        {Block({"X#X", "#.#"}), Block({"X#X", "#@#"})},
        {Block({"#.#", "X#X"}), Block({"#@#", "X#X"})},
        {Block({"#.#", "X.X"}), Block({"###", "X#X"})},
        {Block({"X.X", "#.#"}), Block({"X#X", "###"})},
        {Block({"#..", "#.."}), Block({"###", "###"}, true)},
        {Block({"..#", "..#"}), Block({"###", "###"}, true)},
};
string smart(vector<string> a) {
    auto n = a[0].size();
    n += 2;
    a[0] = "#" + a[0] + "#";
    a[1] = "#" + a[1] + "#";
    auto get_block = [&](int i) {
        return Block({a[0].substr(i, 3), a[1].substr(i, 3)});
    };
    bool is_mult = false;
    auto replace_block = [&](int i, Block rep) {
        is_mult |= rep.is_mult;
        auto orig = get_block(i).replace(rep);
        a[0].replace(i, 3, orig.data[0]);
        a[1].replace(i, 3, orig.data[1]);
    };
    bool was_changed = true;
    while (was_changed) {
        was_changed = false;
        for (int i = 0; i < n - 2; i++) {
            for (auto &[from, to]: patterns) {
                auto block = get_block(i);
                if (block.match(from)) {
                    replace_block(i, to);
                    was_changed = true;
                }
            }
        }
        for (int i = n - 3; i >= 0; i--) {
            for (auto &[from, to]: patterns) {
                auto block = get_block(i);
                if (block.match(from)) {
                    replace_block(i, to);
                    was_changed = true;
                }
            }
        }
    }
    auto is_none = a[0].find('@') != string::npos || a[1].find('@') != string::npos;
    if (is_none) {
        return "None";
    }
    if (is_mult) {
        return "Multiple";
    }
    return "Unique";
}

string toStr(int num) {
    string res;
    for(int i = 0; i < 10; i++) {
        if(num&1) {
            res += '.';
        }
        else {
            res += '#';
        }
        num >>= 1;
    }
    return res;
}

void compare() {
    for(int i = 0; i < 1<<20; i++) {
        vector<string> data{toStr(i), toStr(i >> 10)};
        auto st_ans = stupid(data);
        auto sm_ans = smart(data);
        if(st_ans != sm_ans) {
            cout << "ERROR"  << endl;
            cout << "st_ans " << st_ans  << endl;
            cout << "sm_ans " << sm_ans  << endl;
            cout << data[0] << endl << data[1] << endl;
        }
    }
}

int main() {
//    compare();
//    return 0;
    d_cl(t);
    while (t--) {
        d_cl(n);
        vector<string> a(2);
        cin >> a[0] >> a[1];
        auto res = smart(a);
//        auto res = stupid(a);
        cout << res << endl;
    }
    return 0;
}
