#include <bits/stdc++.h>

#define ll long long
#define pl pair<ll,ll>
#define vl vector<ll>
#define all(a) a.begin(), a.end()

using namespace std;

const ll N = 100500;
vl G[N], G2[N];
ll TYPE[N];
ll USED[N];
ll ORD[N];
// 0 - Set False
// 1 - Set True
// 2 - Unset False
// 3 - Unset True


vl tsort;
void topsort(ll v) {
    USED[v] = 1;
    for (ll to : G[v]) if (!USED[to]) {
        topsort(to);
    }
    tsort.push_back(v);
}

void solve() {
    ll n; cin >> n;
    ll true_cnt = 0;
    for (ll i = 1; i <= n; i++) {
        string s, t;
        cin >> s >> t;
        if (s == "unset") TYPE[i] += 2;
        if (t == "true") TYPE[i] += 1, true_cnt++;
    }

    ll m; cin >> m;
    for (ll i = 0; i < m; i++) {
        ll u; cin >> u;
        ll v; cin >> v;
        G[u].push_back(v);
        // cerr << u << ' ' << v << endl;
    }

    if (true_cnt == 0) {
        for (ll i = 1; i <= n; i++) if (TYPE[i] != 2) {
            cout << "-1\n";
            return;
        }

        for (ll i = 1; i <= n; i++) if (!USED[i]) topsort(i);
        reverse(all(tsort));

        for (ll i = 0; i < n; i++) ORD[tsort[i]] = i;
        for (ll i = 1; i <= n; i++) {
            for (ll to : G[i]) {
                if (ORD[i] > ORD[to]) {
                    cout << "-1\n";
                    return;
                }
            }
        }

        for (auto i : tsort) cout << i << ' ';
        return;
    }

    if (true_cnt == 1) {
        for (ll i = 1; i <= n; i++) if (TYPE[i] == 3) {
            cout << "-1\n";
            return;
        }

        ll pivot = 1;
        while (TYPE[pivot] != 1) pivot++;

        for (ll i = 1; i <= n; i++) if (i != pivot) {
            if (TYPE[i] == 0) G[pivot].push_back(i);
            if (TYPE[i] == 2) G[i].push_back(pivot);
        }

        for (ll i = 1; i <= n; i++) if (!USED[i]) topsort(i);
        reverse(all(tsort));

        for (ll i = 0; i < n; i++) ORD[tsort[i]] = i;
        for (ll i = 1; i <= n; i++) {
            for (ll to : G[i]) {
                if (ORD[i] > ORD[to]) {
                    cout << "-1\n";
                    return;
                }
            }
        }

        for (auto i : tsort) cout << i << ' ';
        return;
    }


    // Case true_cnt == 2

    ll pivot_set = 1;
    ll pivot_unset = 1;
    while (TYPE[pivot_set] != 1 && pivot_set <= n) pivot_set++;
    while (TYPE[pivot_unset] != 3 && pivot_unset <= n) pivot_unset++;

    if (pivot_set == n+1 || pivot_unset == n+1) {
        cout << "-1\n";
        return;
    }

    // TopSort between pivots
    for (ll i = 1; i <= n; i++) if (i != pivot_set && i != pivot_unset) {
        if (TYPE[i] != 0) {
            USED[i] = 2;
            continue;
        }

        // cerr << pivot_set << ' ' << i << ' ' << pivot_unset << endl;
        G[pivot_set].push_back(i);
        G[i].push_back(pivot_unset);
    }

    
    for (ll i = 1; i <= n; i++) if (!USED[i]) topsort(i);
    reverse(all(tsort));

    for (ll i = 0; i < tsort.size(); i++) ORD[tsort[i]] = i;
    for (ll i = 1; i <= n; i++) if (USED[i] == 1) {
        for (ll to : G[i]) if (USED[to] == 1) {
            if (ORD[i] > ORD[to]) {
                cout << "-1\n";
                return;
            }
        }
    }

    // Middle permutation
    auto perm_middle = tsort;


    // Join middle points
    for (ll i = 1; i <= n; i++) {
        for (ll to : G[i]) {
            // cerr << "OK1" << endl;
            ll u = (USED[i] == 1 ? n+1 : i);
            // cerr << "OK2 " << to << endl;
            ll v = (USED[to] == 1 ? n+1 : to);
            if (u != n+1 || v != n+1) {
                // cerr << u << ' ' << v << '\n';
                G2[u].push_back(v);
            }
        }
    }

    swap(G, G2);

    for (ll i = 1; i <= n; i++) {
        if (USED[i] == 1) USED[i] = 5;
        if (USED[i] == 2) USED[i] = 0;
    }

    // + TopSort
    // Unset <-> Middle <-> Unset

    tsort.clear();
    for (ll i = 1; i <= n+1; i++) if (!USED[i]) topsort(i);
    reverse(all(tsort));

    for (ll i = 0; i < tsort.size(); i++) ORD[tsort[i]] = i;
    for (ll i = 1; i <= n; i++) if (USED[i] == 1) {
        for (ll to : G[i]) if (USED[to] == 1) {
            if (ORD[i] > ORD[to]) {
                cout << "-1\n";
                return;
            }
        }
    }
    // - TopSOrt

    vl ans;
    for (ll i : tsort) {
        if (i == n+1) {
            for (auto i : perm_middle) ans.push_back(i);
        }
        else {
            ans.push_back(i);
        }
    }

    swap(G, G2);
    

    for (ll i = 0; i < ans.size(); i++) ORD[ans[i]] = i;
    for (ll i = 1; i <= n; i++) {
        for (ll to : G[i]) {
            if (ORD[i] > ORD[to]) {
                cout << "-1\n";
                return;
            }
        }
    }

    for (auto i : ans) cout << i << ' ';
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) solve();
}