#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;
#define long long long

int main()
{
	long n;
	cin >> n;

	vector<string> t1(n + 1), t2(n + 1);

	long cntSetTrue = 0, cntUnsetTrue = 0;

	long indSet = -1, indUnset = -1;

	for (int i = 1; i <= n; i++)
	{
		cin >> t1[i] >> t2[i];

		if (t1[i] == "set" && t2[i] == "true")
		{
			cntSetTrue++;
			indSet = i;
		}

		if (t1[i] == "unset" && t2[i] == "true")
		{
			indUnset = i;
			cntUnsetTrue++;
		}
	}

	vector<vector<long>> g(n + 1);

	long m;
	cin >> m;

	for (int i = 1; i <= m; i++)
	{
		long u, v;
		cin >> u >> v;

		g[u].push_back(v);
	}

	vector<long> ord;
	vector<bool> was(n + 1);

	auto dfs = [&](long curV, auto&& dfs) -> void
	{
		if (was[curV])
			return;

		was[curV] = true;

		for (auto& next : g[curV])
		{
			dfs(next, dfs);
		}

		ord.push_back(curV);
	};

	for (int i = 1; i <= n; i++)
	{
		dfs(i, dfs);
	}

	reverse(ord.begin(), ord.end());

	if (cntSetTrue == 2 || cntUnsetTrue == 2 || cntUnsetTrue == 1 && cntSetTrue == 0)
	{
		cout << "-1";
		return 0;
	}

	if (cntSetTrue == 0 && cntUnsetTrue == 0)
	{
		for (auto& ind : ord)
		{
			if (t1[ind] == "set")
			{
				cout << "-1";
				return 0;
			}
		}

		for (auto& ind : ord)
		{
			cout << ind << ' ';
		}
	}
	else if (cntSetTrue == 1 && cntUnsetTrue == 0)
	{
		vector<long> ans;

		vector<long> posAns(n + 1);

		for (auto& ind : ord)
		{
			if (t1[ind] == "unset")
			{
				ans.push_back(ind);
			}
		}

		ans.push_back(indSet);

		for (auto& ind : ord)
		{
			if (t1[ind] == "set" && t2[ind] == "false")
			{
				ans.push_back(ind);
			}
		}

		for (int i = 1; i <= n; i++)
		{
			posAns[ans[i - 1]] = i;
		}

		for (int i = 1; i <= n; i++)
		{
			for (auto& next : g[i])
			{
				if (posAns[next] < posAns[i])
				{
					cout << "-1";
					return 0;
				}
			}
		}

		for (auto& el : ans)
		{
			cout << el << ' ';
		}
	}
	else
	{
		vector<long> ans;

		vector<long> posAns(n + 1);

		vector<bool> check(n + 1);

		reverse(ord.begin(), ord.end());

		for (auto& ind : ord)
		{
			bool can = false;

			for (auto& next : g[ind])
			{
				if (next == indSet || next == indUnset)
					can = true;
			}

			check[ind] = can;

			for (auto& next : g[ind])
			{
				if (check[next])
					check[ind] = true;
			}
		}

		reverse(ord.begin(), ord.end());

		for (auto& ind : ord)
		{
			if (t1[ind] == "unset" && t2[ind] == "false" && check[ind])
			{
				ans.push_back(ind);
			}
		}

		ans.push_back(indSet);

		for (auto& ind : ord)
		{
			if (t1[ind] == "set" && t2[ind] == "false")
			{
				ans.push_back(ind);
			}
		}

		ans.push_back(indUnset);

		for (auto& ind : ord)
		{
			if (t1[ind] == "unset" && t2[ind] == "false" && !check[ind])
			{
				ans.push_back(ind);
			}
		}

		for (int i = 1; i <= n; i++)
		{
			posAns[ans[i - 1]] = i;
		}

		for (int i = 1; i <= n; i++)
		{
			for (auto& next : g[i])
			{
				if (posAns[next] < posAns[i])
				{
					cout << "-1";
					return 0;
				}
			}
		}

		for (auto& el : ans)
		{
			cout << el << ' ';
		}
	}
}
