#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = long long;

bool is_norm (int x, int y, int n, int m) {
    return x > -1 and x < n and y > -1 and y < m;
}

int calc_nei(int x, int y, int n, const vector<string> & a) {
    int cnt_used = 0;
    if (x == 0 or x == n - 1) {
        ++cnt_used;
    }
    vector<int> dx = {1, -1, 0, 0};
    vector<int> dy = {0, 0, 1, -1};
    for (int k = 0; k < dx.size(); ++k) {
        int ni = x + dx[k];
        int nj = y + dy[k];
        if (is_norm(ni, nj, n, 2) and a[nj][ni] == '#') {
            ++cnt_used;
        }
    }
    return cnt_used;
}

void solve() {
    int n;
    cin >> n;
    vector<string> a(2);
    cin >> a[0];
    cin >> a[1];
    map<int, pair<int, int> > colors;
    int color = 0;
    vector<vector<int> > c (2, vector<int> (n, -1));
    int cnt0 = 0, cnt1 = 0;
    if (a[0][0] == '.') {
        ++cnt0;
        c[0][0] = 0;
    }
    if (a[1][0] == '.') {
        ++cnt1;
        c[1][0] = 0;
    }
    for (int i = 1; i < n; ++i) {
        int pref_col = max(c[0][i - 1], c[1][i - 1]);
        if ((a[0][i] == a[0][i - 1] and a[0][i] == '.') or (a[1][i] == a[1][i - 1] and a[1][i] == '.')) {
            if (a[0][i] == '.') {
                c[0][i] = pref_col;
                cnt0 += i % 2 == 0;
                cnt1 += i % 2 == 1;
            }
            if (a[1][i] == '.') {
                c[1][i] = pref_col;
                cnt0 += (i + 1) % 2 == 0;
                cnt1 += (i + 1) % 2 == 1;
            }
        }
        else {
            if (pref_col != -1) {
                colors[pref_col] = {cnt0, cnt1};
                cnt0 = 0;
                cnt1 = 0;
            }
            ++color;
            if (a[0][i] == '.') {
                c[0][i] = color;
                cnt0 += i % 2 == 0;
                cnt1 += i % 2 == 1;
            }
            if (a[1][i] == '.') {
                c[1][i] = color;
                cnt0 += (i + 1) % 2 == 0;
                cnt1 += (i + 1) % 2 == 1;
            }
        }
    }
    colors[color] = {cnt0, cnt1};
    for (auto [k, v] : colors) {
        if (v.first != v.second) {
            cout << "None" << endl;
            return;
        }
    }
    int l = 0, r = 0;
    while (l < n) {
        r = l;
        int now_color = -2;
        if (c[0][l] != -1)
            now_color = c[0][l];
        if (c[1][l] != -1)
            now_color = c[1][l];
        vector<pair<int, int> > pr;
        int cnt0_ = 0, cnt1_ = 0;
        if (a[0][l] == '.') {
            cnt0_ += l % 2 == 0;
            cnt1_ += l % 2 == 1;
        }
        if (a[1][l] == '.') {
            cnt0_ += (l + 1) % 2 == 0;
            cnt1_ += (l + 1) % 2 == 1;
        }
        pr.push_back({cnt0_, cnt1_});
        while (r + 1 < n and (c[0][r + 1] == now_color or c[1][r + 1] == now_color)) {
            if (a[0][r + 1] == '.') {
                cnt0_ += (r + 1) % 2 == 0;
                cnt1_ += (r + 1) % 2 == 1;
            }
            if (a[1][r + 1] == '.') {
                cnt0_ += (r + 2) % 2 == 0;
                cnt1_ += (r + 2) % 2 == 1;
            }
            pr.push_back({cnt0_, cnt1_});
            ++r;
        }

        for (int i = l; i < r; ++i) {
            int cnt_dot = 0;
            cnt_dot += a[0][i] == '.';
            cnt_dot += a[1][i] == '.';
            cnt_dot += a[0][i + 1] == '.';
            cnt_dot += a[1][i + 1] == '.';
            if (cnt_dot != 4)
                continue;
            bool fl1 = false;
            bool fl2 = false;
            if (i == l or pr[i - l - 1].first == pr[i - l - 1].second)
                fl1 = true;
            int dif1 = pr.back().first - pr[i + 1 - l].first;
            int dif2 = pr.back().second - pr[i + 1 - l].second;
            if (dif1 == dif2)
                fl2 = true;

            if (fl1 and fl2) {
                cout << "Multiple" << endl;
                return;
            }
        }

        l = r + 1;
    }
    cout << "Unique" << endl;
}

void solve_A(){

}

int32_t main() {
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
/*
4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###



8
8
........
###..###
5
...#.
.#...
7
.....#.
...#...
3
...
.#.
7
.#.....
...#...
8
.......#
.##..#..
4
..#.
.#..
4
...#
#...
 */
