#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const N = 1e5 + 4;
int const inf = 1e9 + 7;
int const mod = 998244353;
ll const INF = 1e18; 

int tp[N], was[N];
vi gr[N];

vi order;
bool was_cycle;

void dfs(int v) {
	was[v] = 1;	
	for (int to : gr[v]) {
		was_cycle |= (was[to] == 1);
		if (!was[to]) dfs(to);		
	}
	order.push_back(v);
	was[v] = 2;
}

void topsort(int l, int r, bool start_from2 = false) {
	fill(was, was + N, 0);
	was_cycle = false;
	order.clear();
	for (int v = l; v <= r; ++v) {
		if (start_from2 && tp[v] != 2) continue;
		if (!was[v]) {
			dfs(v);	
		}
	}
	reverse(all(order));
}

void fail() {
	cout << "-1\n";
}

void solve() {
	int pos[2] = {};
	int cnt = 0; 
	int n;
	cin >> n;
	string sa, sb;
	for (int i = 1; i <= n; ++i) {
		cin >> sa >> sb;
		tp[i] = ((sa[0] == 'u') << 1) | (sb[0] == 't');
		if (tp[i] & 1) {
			pos[cnt++] = i;
		}
	}
	int m;
	cin >> m;
	for (int e = 0; e < m; ++e) {
		int a, b;
		cin >> a >> b;
		gr[a].push_back(b);
	}
	if (cnt == 0) {
		for (int i = 1; i <= n; ++i) {
			if (tp[i] != 2) return fail();	
		}	
		topsort(1, n);
		for (int v : order) cout << v << ' ';
		cout << '\n';
		return;
	}
	if (cnt == 1) {
		int s = pos[0];
		if (tp[s] == 3) return fail();
		for (int i = 1; i <= n; ++i) {
			if (tp[i] == 0) gr[s].push_back(i);
			if (tp[i] == 2) gr[i].push_back(s);
		}
		topsort(1, n);
		if (was_cycle) return fail();
		for (int v : order) {
			cout << v << ' ';
		}
		cout << '\n';
		return;
	}
	int s = pos[0], t = pos[1];
	if (tp[s] == tp[t]) return fail();
	if (tp[s] == 3) swap(s, t);
	gr[s].push_back(t);
	for (int v = 1; v <= n; ++v) {
		if (tp[v] == 0) {
		 	gr[s].push_back(v);
		 	gr[v].push_back(t);
		}
	}
	topsort(1, n);
	//cerr << was_cycle << '\n';
	if (was_cycle) return fail();
	vi order_103;
	for (int v : order) {
		if (tp[v] != 2) {
			order_103.push_back(v);			
		}
	}
	tp[0] = 2;
	for (int v = 1; v <= n; ++v) {
		if (tp[v] == 2) {
			vi ngr;
			for (int to : gr[v]) {
				ngr.push_back(tp[to] == 2 ? to : 0);
			}	
			gr[v] = ngr;
		} else {
			for (int to : gr[v]) {
				if (tp[to] == 2) {
				 	gr[0].push_back(to);
				}
			}
		}
	}
	topsort(0, n, true);
	if (was_cycle) return fail();
	for (int v : order) {
		if (v) {
			cout << v << ' ';
		} else {
			for (int u : order_103) {
				cout << u << ' ';
			}
		}
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}