#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pr;

#define all(v) v.begin(), v.end()

mt19937_64 rnd(228);

vector<vector<string>> getComp(const vector<string> &a) {
    vector<vector<string>> ans;
    vector<string> cur(2);
    const int n = a[0].size();
    for (int i = 0; i < n; ++i) {
        if (a[0][i] == '#' && a[1][i] == '#') {
            if (cur[0] != "") {
                ans.push_back(cur);
                cur.assign(2, "");
            }
            continue;
        }
        cur[0].push_back(a[0][i]);
        cur[1].push_back(a[1][i]);

        if (i + 1 < n) {
            if ((a[0][i] == '#' && a[1][i + 1] == '#') || (a[0][i + 1] == '#' && a[1][i] == '#')) {
                if (cur[0] != "") {
                    ans.push_back(cur);
                    cur.assign(2, "");
                }
                continue;
            }
        }
    }
    if (!cur.empty()) {
        ans.push_back(cur);
        cur = {};
    }
    return ans;
}

bool isPossible(const vector<string> &v, int l, int r) { // [l,r]
    int w = 0, b = 0;
    for (int i = l; i <= r; ++i) {
        if (v[0][i] == '.') {
            if (i % 2 == 0) {
                ++w;
            } else {
                ++b;
            }
        }
        if (v[1][i] == '.') {
            if ((i + 1) % 2 == 0) {
                ++w;
            } else {
                ++b;
            }
        }
    }
}

string solve() {
    int n;
    cin >> n;
    vector<string> inp(2);
    for (int i = 0; i < 2; ++i) {
        cin >> inp[i];
    }
    vector<vector<string>> comps = getComp(inp);

    for (const vector<string> &a: comps) {
        n = a[0].size();
        vector<int> pW(n + 1, 0);
        vector<int> pB(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            pW[i + 1] = pW[i];
            pB[i + 1] = pB[i];
            if (a[0][i] == '.') {
                if (i % 2 == 0) {
                    ++pW[i + 1];
                } else {
                    ++pB[i + 1];
                }
            }
            if (a[1][i] == '.') {
                if ((i + 1) % 2 == 0) {
                    ++pW[i + 1];
                } else {
                    ++pB[i + 1];
                }
            }
        }

        if (pW[n] != pB[n]) {
            return "None";
        }

        for (int i = 1; i < n; ++i) {
            if (a[0][i - 1] == '.' && a[0][i] == '.' && a[1][i - 1] == '.' && a[1][i] == '.') {
                int fw = pW[i - 1], fb = pB[i - 1];
                int lw = pW[n] - pW[i + 1], lb = pB[n] - pB[i + 1];
                if (fw == fb && lw == lb) {
                    return "Multiple";
                }
            }
        }
    }
    return "Unique";
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int TESTS;
    cin >> TESTS;
    while (TESTS--) {
        cout << solve() << endl;
    }
    return 0;
}