#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pr;

#define all(v) v.begin(), v.end()

mt19937_64 rnd(228);
const ll maxn = 2e5;


vector<vector<ll>> graph(maxn);
vector<bool> used(maxn);
vector<ll> order;

struct homework {
    int l;
    int r;

    homework() : l(-1), r(-1) {}

    homework(int l_, int r_) : l(l_), r(r_) {}

    bool operator<(const homework &other) const {
        if (other.r != r) {
            return r < other.r;
        }
        return l < other.l;
    }

    bool operator==(const homework &other) const {
        return r == other.r && l == other.l;
    }

    int len() const {
        return r - l;
    }
};

int solveForT(int t, const vector<homework> &a, const vector<int> &ser) {
    int ts = 0;
    int i = 0;
    while (i < a.size()) {
        if (a[i].r <= t) {
            ts += a[i].len();
        } else {
            break;
        }
        ++i;
    }
    if (i < a.size()) {
        t = min(t, a[i].l);
    }

    // [ts, t)
    int time = t - ts;
    int l = 0, r = ser.size();
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (ser[m] <= time) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<homework> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].r;
        a[i].l = a[i].r - a[i].l;
    }
    sort(a.begin(), a.end());
    for (int i = 0; i + 1 < n; ++i) {
        if (a[i + 1].l <= a[i].r) {
            int leng = a[i].len() + a[i + 1].len();
            a[i].r = a[i + 1].r;
            a[i].l = a[i].r - leng;
            a[i + 1] = homework(-1, -1);
        }
    }

    vector<homework> hw;
    for (int i = 0; i < n; ++i) {
        if (a[i].r != -1) {
            hw.push_back(a[i]);
            cerr << a[i].l << ' ' << a[i].r << endl;
        }
    }
    cerr << endl;
    sort(hw.begin(), hw.end());

    vector<int> ser(m + 1);
    for (int i = 0; i < m; ++i) {
        cin >> ser[i + 1];
        ser[i + 1] += ser[i];
    }

    while (q--) {
        int t;
        cin >> t;
        cout << solveForT(t, hw, ser) << ' ';
    }
    cout << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int TESTS;
    cin >> TESTS;
    while (TESTS--) {
        solve();
    }
}