#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <algorithm>
#include <queue>
#include <stack>

#pragma warning(disable:4996)


#define  vec vector
#define  vll vec<ll>
#define  pll pair<ll, ll>
#define  vpl vec<pll>
#define  all(t)  t.begin(), t.end()
#define  ainb(a ,b )  (b.find(a)  != b.end())

#define  ll long long
#define  ld long double

using namespace std;

struct Op
{
	bool is_set;
	bool res;
	
	ll part = 1;
};

void detectPart3(long long n, std::vector<Op>& operations, std::vector<std::vector<long long>>& dag)
{
	queue<ll> bfs;
	vec<bool> vis(n);
	for (int i = 0; i < n; i++)
	{
		if (operations[i].part == 2)
		{
			bfs.push(i);
		}
	}

	while (!bfs.empty())
	{
		ll curr = bfs.front();
		bfs.pop();

		if (vis[curr])
		{
			continue;
		}
		vis[curr] = true;

		if (operations[curr].part != 2)
		{
			operations[curr].part = 3;
		}

		for (ll to : dag[curr])
		{
			if (!vis[to])
			{
				bfs.push(to);
			}
		}
	}
}

void bfsPart(ll curr_part, long long n, std::vector<Op>& operations, std::vector<std::vector<long long>>& dag, std::vector<long long>& ans)
{
	vec<bool> vis(n);
	stack<ll> res;
	for (ll i = 0; i < n; i++)
	{
		if (!vis[i] && operations[i].part == curr_part)
		{
			queue<ll> bfs;
			bfs.push(i);

			while (!bfs.empty())
			{
				ll curr = bfs.front();
				bfs.pop();

				if (vis[curr])
				{
					continue;
				}
				vis[curr] = true;
				res.push(curr);

				for (ll to : dag[curr])
				{
					if (vis[to] || operations[to].part != curr_part)
					{
						continue;
					}

					bfs.push(to);
				}
			}
		}
	}

	while (!res.empty())
	{
		ans.push_back(res.top());
		res.pop();
	}
}

void slove() {
	ll n;
	cin >> n;
	vec<Op> operations(n);
	for (ll i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		operations[i].is_set = s[0] == 's';
		
		cin >> s;
		operations[i].res = s[0] == 't';
	}

	ll m;
	cin >> m;

	vec<vll> dag(n);
	for (int i = 0; i < m; i++)
	{
		ll u, v;
		cin >> u >> v;
		dag[u - 1].push_back(v - 1);
	}

	for (int i = 0; i < n; i++)
	{
		if (operations[i].is_set && !operations[i].res) // set false
		{
			operations[i].part = 2;
		}
		if (operations[i].res)
		{
			operations[i].part = 2;
		}
	}

	detectPart3(n, operations, dag);

	{
		ll mxm_part = 0;
		ll total_parts = 1;
		for (int i = 0; i < n; i++)
		{
			if (operations[i].res)
			{
				total_parts++;
				operations[i].part = -1;
			}
			mxm_part = max(mxm_part, operations[i].part);
		}

		if (mxm_part > total_parts)
		{
			cout << -1;
			return;
		}
	}
	
	vll ans;

	bfsPart(1, n, operations, dag, ans);

	for (int i = 0; i < n; i++)
	{
		if (operations[i].is_set && operations[i].res)
		{
			ans.push_back(i);
		}
	}

	bfsPart(2, n, operations, dag, ans);

	for (int i = 0; i < n; i++)
	{
		if (!operations[i].is_set && operations[i].res)
		{
			ans.push_back(i);
		}
	}

	bfsPart(3, n, operations, dag, ans);

	for (int i = 0; i < n; i++)
	{
		cout << ans[i] + 1 << " ";
	}
}


int main()
{

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll  t = 1; 
	//cin >> t; 
	while (t--) {
		slove();
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging men