#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <set>
#include <string>
#include <map>

using namespace std;

#define int long long
#define all(a) begin(a), end(a)
#define vi vector<int>
#define ve vector
#define pii pair<int,int>
#define rep(i, n) for(int i = 0; i < (n); i++)

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << fixed; cout.precision(10);
}

constexpr int inf = 1e18;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    ve<pii> a(n);
    vi l(m), v(q);
    rep(i, n) {
        cin >> a[i].first;
    }
    rep(i, n) {
        cin >> a[i].second;
    }
    vi pl(m);
    rep(i, m) {
        cin >> l[i];
        if (i) pl[i] = pl[i - 1];
        pl[i] += l[i]; 
    }
    auto comp = [&](const pii& a, const pii& b){
        if (a.second != b.second) return a.second < b.second;
        return a.first < b.first;
    };
    sort(all(a), comp);
    vi p(n), need(n);
    vi sf(n + 1);
    sf[n] = inf;
    rep(i, n) {
        if (i) p[i] = p[i - 1];
        p[i] += a[i].first;
        need[i] = a[i].second - p[i];
    }
    for (int i = n - 1; i >= 0; i--) {
        sf[i] = sf[i + 1];
        sf[i] = min(sf[i], need[i]);
    }
    rep(i, q) {
        int t;
        cin >> t;
        pii search = {-inf, t};
        auto pos = lower_bound(all(a), search, comp) - a.begin();
        int mn = inf;
        if (pos < sf.size()) mn = sf[pos];
        int ll = 0, rr = m - 1;
        int ans = 0;
        while (ll <= rr) {
            int mid = (ll + rr) / 2;
            int sum_all = 0;
            if (pos > 0) sum_all = p[pos - 1];
            int sl = pl[mid];
            sum_all += sl;
            if (sum_all <= t && sl <= mn) {
                ans = mid + 1;
                ll = mid + 1;
            } else {
                rr = mid - 1;
            }
        }
        cout << ans << " ";
    }
    cout << "\n";
}

signed main() {
    fast();
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}