#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int N = 1e5 + 7;

#define int long long
const int INF = 1e18;
const int M = 360;

struct Node {
    int x = 0, y = 0, cr_x = 0, cr_y = 0;

    Node(int a = 0, int b = 0, int c = 0, int d = 0) : x(a), y(b), cr_x(c), cr_y(d) {
    }
};

int f(int x, int cr) { // 0 - >0 1 - ==0 2 < 0
    if (x > 0 and cr > 0) return 0;
    if (x == 0 and cr > 0) return 0;
    if (x > 0 and cr == 0) return 0;
    if (x == 0 and cr == 0) return 1;
    if (x < 0 and cr < 0) return 2;
    if (x == 0 and cr < 0) return 2;
    if (x < 0 and cr == 0) return 2;
    if (x > 0 and cr < 0) {
        if (2 * (__int128) x * x < cr) {
            return 2;
        }
        if (2 * (__int128) x * x == cr) return 1;
        return 0;
    }
    if (x < 0 and cr > 0) {
        if (2 * (__int128) x * x < cr) {
            return 0;
        }
        if (2 * (__int128) x * x == cr) return 1;
        return 2;
    }
}


bool operator<(const Node &a, const Node &b) {
    int del = f(b.x - a.x, b.cr_x - a.cr_x);
    if (del == 0) return 1;
    if (del == 2) return 0;
    del = f(b.y - a.y, b.cr_y - a.cr_y);
    return del == 0;
}

bool operator==(const Node &a, const Node &b) {
    return !(a < b) and !(b < a);
}

vector<pair<string, int>> vec;

Node add(Node now, int deg, int cnt) {
    if (deg == 0) {
        now.x += cnt;
    } else if (deg == 45) {
        now.cr_x += cnt;
        now.cr_y -= cnt;
    } else if (deg == 90) {
        now.y -= cnt;
    } else if (deg == 135) {
        now.cr_x -= cnt;
        now.cr_y -= cnt;
    } else if (deg == 180) {
        now.x -= cnt;
    } else if (deg == 225) {
        now.cr_x -= cnt;
        now.cr_y += cnt;
    } else if (deg == 270) {
        now.y += cnt;
    } else if (deg == 315) {
        now.cr_x += cnt;
        now.cr_y += cnt;
    }
    return now;
}

vector<pair<Node, Node>> do_all_oper(int deg) {
    vector<pair<Node, Node>> res;
    Node now;
    bool fl = false;
    for (auto c: vec) {
        Node new_now = add(now, deg, c.second);
        if (c.first == "draw") {
            if (fl) {
                res.back().second = new_now;
            } else {
                res.push_back({now, new_now});
            }
            fl = true;
            now = new_now;
        } else if (c.first == "move") {
            now = new_now;
            fl = false;
        } else {
            fl = false;
            deg += c.second;
            deg %= M;
        }
    }
    return res;
}

pair<int, int> mul(int ax, int acr, int bx, int bcr) {
    return {ax * bx + acr * bcr / 2, ax * bcr + acr * bx};
}

pair<int, int> cross_pr(Node a, Node b) {
    pair<int, int> now = mul(a.x, a.cr_x, b.y, b.cr_y);
    pair<int, int> now2 = mul(a.y, a.cr_y, b.x, b.cr_x);
    return {now.first - now2.first, now.second - now2.second};
}

pair<int, int> dot_pr(Node a, Node b) {
    pair<int, int> now = mul(a.x, a.cr_x, b.x, b.cr_x);
    pair<int, int> now2 = mul(a.y, a.cr_y, b.y, b.cr_y);
    return {now.first + now2.first, now.second + now2.second};
}


bool point_on_segm(pair<Node, Node> a, Node p) {
    a.first.x *= 2;
    a.first.y *= 2;
    a.first.cr_x *= 2;
    a.first.cr_y *= 2;
    a.second.x *= 2;
    a.second.y *= 2;
    a.second.cr_x *= 2;
    a.second.cr_y *= 2;
    p.x *= 2;
    p.y *= 2;
    p.cr_x *= 2;
    p.cr_y *= 2;

    Node pa = {a.first.x - p.x, a.first.y - p.y, a.first.cr_x - p.cr_x, a.first.cr_y - p.cr_y};
    Node pb = {a.second.x - p.x, a.second.y - p.y, a.second.cr_x - p.cr_x, a.second.cr_y - p.cr_y};
    pair<int, int> cross_prr = cross_pr(pa, pb);
    pair<int, int> dot_prr = dot_pr(pa, pb);
    if (f(cross_prr.first, cross_prr.second) != 1) return false;
    if (f(dot_prr.first, dot_prr.second) == 0) return false;
    return true;
}

bool check_segm(vector<pair<Node, Node>> a, vector<pair<Node, Node>> b) {
    for (auto c: a) {
        bool fl1 = true, fl2 = true;
        for (auto c2: b) {
            if (point_on_segm(c2, c.first)) {
                fl1 = false;
            }
            if (point_on_segm(c2, c.second)) {
                fl2 = false;
            }
        }
        if (fl1 or fl2) return false;
    }
    return true;
}

bool simpl(vector<pair<Node, Node>> a, vector<pair<Node, Node>> b) {
    for (auto &c: a) {
        if (c.second < c.first) {
            swap(c.first, c.second);
        }
    }
    for (auto &c: b) {
        if (c.second < c.first) {
            swap(c.first, c.second);
        }
    }
    Node min_1 = a[0].first, min_2 = b[0].first;
    for (auto c: a) {
        min_1 = min(min_1, c.first);
        min_1 = min(min_1, c.second);
    }
    for (auto c: b) {
        min_2 = min(min_2, c.first);
        min_2 = min(min_2, c.second);
    }
    for (auto &c: b) {
        c.first.cr_x += min_1.cr_x - min_2.cr_x;
        c.first.cr_y += min_1.cr_y - min_2.cr_y;
        c.first.x += min_1.x - min_2.x;
        c.first.y += min_1.y - min_2.y;

        c.second.cr_x += min_1.cr_x - min_2.cr_x;
        c.second.cr_y += min_1.cr_y - min_2.cr_y;
        c.second.x += min_1.x - min_2.x;
        c.second.y += min_1.y - min_2.y;
    }
    for (auto &c: b) {
        if (c.second < c.first) {
            swap(c.first, c.second);
        }
    }


    return check_segm(a, b) and check_segm(b, a);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string s;
        int a;
        cin >> s >> a;
        vec.emplace_back(s, a % M);
    }
    vector<pair<Node, Node>> vec1 = do_all_oper(0);
    for (int i = 45; i <= 360; i += 45) {
        vector<pair<Node, Node>> vec2 = do_all_oper(i % M);
        if (simpl(vec1, vec2)) {
            cout << i << endl;
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}


/*6
draw 1
move 1
draw 2
rotate 180
move 2
draw 1*/
