#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <string>

#define ll long long;
#define nl "\n";

using namespace std;

vector<int> solve(vector<int> expected, vector<int> actual) {
	vector<int> status(expected.size() + 1);

	int cur = 0;
	int unknown_cnt = 0;
	bool is_bad = false;
	for (int i = 0; i < actual.size(); i++) {
		if (is_bad) {
			break;
		}

		if (actual[i] == -1) {
			unknown_cnt++;
			continue;
		}

		if (unknown_cnt) {
			int from = cur + unknown_cnt;

			while (actual[i] != expected[cur] || cur < from) {
				status[expected[cur]] = max(1, status[expected[cur]]);

				cur++;

				if (cur >= expected.size()) {
					is_bad = true;
					break;
				}
			}

			unknown_cnt = 0;
		}
		else if (actual[i] != expected[cur]) {
			if (i == 0) {
				while (actual[i] != expected[cur]) {
					cur++;

					if (cur >= expected.size()) {
						is_bad = true;
						break;
					}
				}
			}
			else {
				is_bad = true;
				break;
			}
		}

		status[actual[i]] = 2;
		cur++;
	}

	if (unknown_cnt) {
		if (cur == expected.size()) {
			is_bad = true;
		}
		else {
			while (cur < expected.size()) {
				status[expected[cur]] = max(1, status[expected[cur]]);

				cur++;
			}
		}
	}

	if (is_bad) {
		status[0] = 999;
	}

	return status;
}

signed main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int test_cnt;
	cin >> test_cnt;

	for (int test = 0; test < test_cnt; test++) {
		int n;
		cin >> n;

		vector<int> expected_first(n);
		for (int i = 0; i < n; i++) {
			cin >> expected_first[i];
		}
		vector<int> expected_second(n);
		for (int i = 0; i < n; i++) {
			cin >> expected_second[i];
		}

		int k;
		cin >> k;

		vector<int> actual_first(k);
		for (int i = 0; i < k; i++) {
			cin >> actual_first[i];
		}
		vector<int> actual_second(k);
		for (int i = 0; i < k; i++) {
			cin >> actual_second[i];
		}

		auto status_first = solve(expected_first, actual_first);
		if (status_first[0] == 999) {
			cout << "Inconsistent\n";
			break;
		}

		auto status_second = solve(expected_second, actual_second);
		if (status_second[0] == 999) {
			cout << "Inconsistent\n";
			break;
		}

		vector<int> merged(status_first.size() - 1);
		int yes = 0;
		int no = 0;
		for (int i = 1; i < status_first.size(); i++) {
			int x;
			if (status_first[i] == 2 || status_second[i] == 2) {
				x = 2;
				yes++;
			}
			else if (status_first[i] == 0 || status_second[i] == 0) {
				x = 0;
				no++;
			}
			else {
				x = 1;
			}

			merged[i - 1] = x;
		}

		bool is_all_known = (yes + no) >= n - 1;
		bool is_all_present = is_all_known && (yes == k);

		for (auto x : merged) {
			if (x == 0 || (x == 1 && is_all_present)) {
				cout << "N";
			}
			else if (x == 2 || (x == 1 && !is_all_present && is_all_known) || k == n) {
				cout << "Y";
			}
			else {
				cout << "?";
			}
		}

		cout << '\n';
	}

	return 0;
}