#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr int MAXN = 200010;

vector<int> a(MAXN);
vector<int> g[MAXN];
vector<int> by_num[MAXN];
vector<int> fwd(MAXN), bwd(MAXN);
vector<int> used(MAXN);

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < 2 * n; i++) {
        fwd[i] = -1;
        bwd[i] = -1;
        used[i] = 0;
        g[i].clear();
        by_num[i].clear();
    }

    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i];
        by_num[a[i]].push_back(i);
    }

    for (int i = 1; i < 2 * n; i++) {
        int u, v;
        cin >> u >> v;

        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    int curr = 1;
    auto dfs = [&curr](const auto& rec, int v) -> bool {
        if (used[v] == curr) {
            return false;
        }

        used[v] = curr;
        for (auto to : g[v]) {
            if (bwd[to] == -1 || rec(rec, bwd[to])) {
                bwd[to] = v;
                fwd[v] = to;
                fwd[to] = v;
                bwd[v] = to;
                return true;
            }
        }

        return false;
    };

    for (bool run = true; run;) {
        run = false;
        curr++;
        for (int i = 0; i < 2 * n; i++) {
            if (fwd[i] == -1 && dfs(dfs, i)) {
                run = true;
            }
        }
    }

    set<int> in_pairs;
    set<pair<int, int>> pairs;
    for (int i = 0; i < 2 * n; i++) {
        if (fwd[i] != -1) {
            pairs.insert({min(i, fwd[i]), max(i, fwd[i])});
            in_pairs.insert(i);
        }
    }

    vector<pair<int, int>> ans;
    auto swap_dfs = [&curr, &ans, &in_pairs](const auto& rec, int v) {
        if (used[v] == curr) {
            return;
        }

        used[v] = curr;

        int u = fwd[v];
        if (a[v] == a[u]) {
            return;
        }

        int oth = by_num[a[v]][0];
        if (oth == v) {
            oth = by_num[a[v]][1];
        }


        if (by_num[a[u]][0] == u) {
            by_num[a[u]][0] = oth;
        } else {
            by_num[a[u]][1] = oth;
        }
        if (by_num[a[oth]][0] == oth) {
            by_num[a[oth]][0] = u;
        } else {
            by_num[a[oth]][1] = u;
        }
        swap(a[u], a[oth]);
        ans.emplace_back(u, oth);

        if (in_pairs.count(oth) != 0) {
            rec(rec, oth);
            return;
        }

        int oth2 = by_num[a[oth]][0];
        if (oth2 == oth) {
            oth2 = by_num[a[oth]][1];
        }

        if (in_pairs.count(oth2) == 0) {
            return;
        }

        int nxt = fwd[oth2];
        rec(rec, nxt);
        return;
    };


    curr++;
    for (int v : in_pairs) {
        swap_dfs(swap_dfs, v);
    }

    cout << ans.size() << "\n";
    for (const auto& [x, y] : ans) {
        cout << (x + 1) << " " << (y + 1) << "\n";
    }
}

int32_t main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }



    return 0;
}
