#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

#define int long long
// #define double long double

using namespace std;

bool IsNum(char c) {
	return c >= '0' && c <= '9';
}

int Valid(string s) {
	int left = 0;
	int right = 0;
	bool started = false;
	bool swapped = false;
	bool firsted = false;
	int symbol = 0;
	int curres = 0, curnum = 0;
	for (int i = 0; i < s.size(); ++i) {
		if (started) {
			if (IsNum(s[i])) {
				if (symbol) {
					firsted = true;
					curnum = (s[i] - '0') * symbol;
					symbol = 0;
				} else {
					if (firsted && curnum == 0) {
						return 2;
					}
					curnum = curnum * 10;
					curnum = curnum > 0 ? curnum + (s[i] - '0') : curnum - (s[i] - '0');
					if (curnum >= 10000000000 || curnum <= -10000000000) {
						return 2;
					}
				}
			} else {
				if (symbol) {
					return 2;
				}
				firsted = false;
				curres += curnum;
				if (s[i] == '-') {
					symbol = -1;
				} else if (s[i] == '+') {
					symbol = 1;
				} else if (s[i] == '=') {
					if (swapped) {
						return 2;
					}
					swapped = true;
					left = curres;
					curres = 0;
					started = false;
				}
			}
		} else {
			if (IsNum(s[i])) {
				firsted = true;
				started = true;
				curnum = s[i] - '0';
			} else {
				return 2;
			}
		}
	}
	if (symbol) {
		return 2;
	}
	if (!started) {
		return 2;
	}
	curres += curnum;
	right = curres;
	if (right == left) {
		return 0;
	}
	return 1;
}

bool Try(string s, int i) {
	for (size_t j = 0; j < i; ++j) {
		if (j == 0) {
			string s1 = s.substr(0, i);
			string s2 = s.substr(i + 1, string::npos);
			string eval = s[i] + s1 + s2;
			int vv = Valid(eval);
			if (vv == 0) {
				cout << eval;
				return true;
			}
		} else {
			string s1 = s.substr(0, j);
			string s2 = s.substr(j, i - j);
			string s3 = s.substr(i + 1, string::npos);
			string eval = s1 + s[i] + s2 + s3;
			int vv = Valid(eval);
			if (vv == 0) {
				cout << eval;
				return true;
			}
		}
	}
	for (size_t j = i + 1; j < s.size() + 1; ++j) {
		string s1 = s.substr(0, i);
		string s2 = s.substr(i + 1, j - i - 1);
		string s3 = s.substr(j, string::npos);
		string eval = s1 + s2 + s[i] + s3;
		int vv = Valid(eval);
		if (vv == 0) {
			cout << eval;
			return true;
		}
	}
	return false;
}

void solve() {
	string inp;
	cin >> inp;
	if (Valid(inp) == 0) {
		cout << "Correct";
		return;
	}
	for (size_t i = 0; i < inp.size(); ++i) {
		if (IsNum(inp[i]) && Try(inp, i)) {
			return;
		}
	}
	cout << "Impossible";
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}