#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

#define int long long
// #define double long double

using namespace std;

void dfs(vector<vector<int>>& g, vector<vector<int>>& dp, vector<int>& pr, int v, int p) {
	int s = 0;
	for (int to : g[v]) {
		if (to == p) {
			continue;
		}
		dfs(g, dp, pr, to, v);
		s += max(dp[to][0], dp[to][1]);
	}
	dp[v][0] = s;
	for (int to : g[v]) {
		if (to == p) {
			continue;
		}
		int y = s - max(dp[to][0], dp[to][1]) + dp[to][0] + 1;
		if (y > dp[v][1]) {
			dp[v][1] = y;
			pr[v] = to;
		}
	}
}

void dfs2(vector<vector<int>>& g, vector<vector<int>>& dp, vector<int>& pr,
	vector<pair<int, int>>& ans, int v, int p, bool ok = true) {
	if (ok && dp[v][1] > dp[v][0]) {
		ans.push_back({ v, pr[v] });
		for (int to : g[v]) {
			if (to == p) {
				continue;
			}
			dfs2(g, dp, pr, ans, to, v, to != pr[v]);
		}
	}
	else {
		for (int to : g[v]) {
			if (to == p) {
				continue;
			}
			dfs2(g, dp, pr, ans, to, v, true);
		}
	}
}

void solve() {
	int n, m, q;
	cin >> n >> m >> q;

	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	vector<pair<int, int>> d(n);
	for (int i = 0; i < n; i++)
		cin >> d[i].first, d[i].second = i;

	sort(d.begin(), d.end());

	vector<int> l(m);
	for (int i = 0; i < m; i++)
		cin >> l[i];

	vector<pair<int, int>> t(q);
	for (int i = 0; i < q; i++)
		cin >> t[i].first, t[i].second = i;

	sort(t.begin(), t.end());

	vector<int> max_t(n);
	for (int i = n - 1; i >= 0; i--) {
		max_t[i] = d[i].first - a[d[i].second];
		if (i < n - 1) {
			max_t[i] = min(max_t[i], max_t[i + 1] - a[d[i].second]);
		}
	}

	int prev = 0;
	int ac_l = 0;
	int d_idx = 0;
	int hw_t = 0;
	vector<int> ans(q);
	for (int i = 0; i < q; i++) {
		int cur_t = t[i].first;
		while (d_idx < n && d[d_idx].first <= cur_t) {
			hw_t += a[d[d_idx].second];
			d_idx++;
		}

		int delta = cur_t - hw_t;
		if (d_idx != n) {
			delta = min(delta, max_t[d_idx] - hw_t);
		}

		for (; prev < m; prev++) {
			if (ac_l + l[prev] <= delta) {
				ac_l += l[prev];
			}
			else {
				break;
			}
		}

		ans[t[i].second] = prev;
	}

	for (int i = 0; i < q; i++) {
		cout << ans[i] << ' ';
	}

	cout << '\n';
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}