#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <iterator>
#include <set>
#include <map>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<pair<ll, ll>> mask = { {0, 1}, {1, 0}, {0, -1}, {-1, 0} };

ll run_stack(stack<pair<ll, ll>>& stak, vector<string>& vec) {
	ll cnt = 0, i, j;
	while (!stak.empty()) {
		i = stak.top().first;
		j = stak.top().second;
		stak.pop();
		if (vec[i][j] == '#') {
			continue;
		}
		cnt = 0;
		for (ll k = 0; k < mask.size(); k++)
		{
			if (vec[i + mask[k].first][j + mask[k].second] == '#') {
				cnt++;
			}
		}
		if (cnt == 4) {
			return -1;
		}
		if (cnt == 3) {
			for (ll k = 0, ki, kj; k < mask.size(); k++)
			{
				ki = i + mask[k].first;
				kj = j + mask[k].second;
				if (vec[ki][kj] == '.') {
					vec[i][j] = '#';
					vec[ki][kj] = '#';
					for (ll g = 0, gi, gj; g < mask.size(); g++)
					{
						gi = ki + mask[g].first;
						gj = kj + mask[g].second;
						if (vec[gi][gj] == '.') {
							stak.push({ gi, gj });
						}
					}
					break;
				}
			}
		}
	}
	return 1;
}

void solve() {
	ll n;
	cin >> n;
	n += 2;
	vector<string> vec(4);
	string s;
	cin >> s;
	vec[1] = "#" + s + "#";
	cin >> s;
	vec[2] = "#" + s + "#";
	stack<pair<ll, ll>> stak;
	s = "";
	s.resize(n, '#');
	vec[0] = s;
	vec[3] = s;
	ll lim = n - 1, cnt;
	for (ll i = 1; i < 3; i++)
	{
		for (ll j = 1; j < lim; j++)
		{
			if (vec[i][j] == '#') {
				continue;
			}
			stak.push({ i, j });
		}
	}
	if (run_stack(stak, vec) == -1) {
		cout << "None\n";
		return;
	}
	bool f = false;
	for (ll j = 1; j < lim; j++)
	{
		for (ll i = 1; i < 3; i++)
		{
			if (vec[i][j] == '#') {
				continue;
			}
			if (vec[i][j + 1] == '.' && vec[i + 1][j] == '.' && vec[i + 1][j + 1] == '.') {
				f = true;
				vec[i][j] = '#';
				vec[i + 1][j] = '#';
				vec[i][j + 1] = '#';
				vec[i + 1][j + 1] = '#';
				continue;
			}
			stak.push({ i, j });
			if (run_stack(stak, vec) == -1) {
				cout << "None\n";
				return;
			}
		}
	}
	for (ll i = 1; i < 3; i++)
	{
		for (ll j = 1; j < lim; j++)
		{
			if (vec[i][j] == '#') {
				continue;
			}
			stak.push({ i, j });
			if (run_stack(stak, vec) == -1) {
				cout << "None\n";
				return;
			}
		}
	}
	/*for (ll i = 1; i < 3; i++)
	{
		for (ll j = 1; j < lim; j++)
		{
			if (vec[i][j] == '#') {
				continue;
			}
			cnt = 0;
			for (ll k = 0; k < mask.size(); k++)
			{
				if (vec[i + mask[k].first][j + mask[k].second] == '#') {
					cnt++;
				}
			}
			if (cnt == 4) {
				cout << "None\n";
				return;
			}
		}
	}*/
	if (f) {
		cout << "Multiple\n";
	}
	else {
		cout << "Unique\n";
	}
}

void multitest() {
	ll t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

void fastIO();

void preCalc();

int main()
{
#ifdef _OVERMINDS
	freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
#endif // _OVERMINDS
	preCalc();
	multitest();
}

void preCalc() {

}

void fastIO() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}