#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <iterator>
#include <set>
#include <map>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<pair<ll, ll>> mask = { {0, 1}, {1, 0}, {0, -1}, {-1, 0} };

void solve() {
	ll n, m, q;
	cin >> n >> m >> q;
	vector<pair<ll, ll>> tasks(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> tasks[i].second;
	}
	for (ll i = 0; i < n; i++)
	{
		cin >> tasks[i].first;
	}
	vector<ll> movs(m);
	for (ll i = 0; i < m; i++)
	{
		cin >> movs[i];
	}
	vector<ll> calls(q);
	for (ll i = 0; i < q; i++)
	{
		cin >> calls[i];
	}
	sort(tasks.begin(), tasks.end());
	vector<pair<ll, ll>> seqs;
	for (int i = n - 1; i >= 0; --i) {
		ll deadline = tasks[i].first;
		ll delay = tasks[i].second;
		ll start = deadline - delay;
		if (!seqs.empty() && seqs.back().first <= start) {
			ll old_start = seqs[seqs.size() - 1].first;
			seqs[seqs.size() - 1].first = old_start - delay;
		}
		else {
			seqs.push_back({ start, deadline });
		}
	}
	reverse(seqs.begin(), seqs.end());
	seqs.push_back({ 1e18, 1e18 });
	ll cur_time = 0;
	ll cur_seq = 0;
	vector<ll> mov_ends(m);
	for (ll i = 0; i < m; i++)
	{
		while (cur_time + movs[i] > seqs[cur_seq].first) {
			cur_time = seqs[cur_seq].second - (seqs[cur_seq].first - cur_time);
			cur_seq++;
		}
		cur_time += movs[i];
		mov_ends[i] = cur_time;
	}
	mov_ends.push_back(1e18);
	for (int i = 0; i < q; ++i) {
		auto ans = lower_bound(mov_ends.begin(), mov_ends.end(), calls[i]);
		if (*ans != calls[i])
			cout << ans - mov_ends.begin() << " ";
		else
			cout << ans - mov_ends.begin() + 1 << " ";
	}
	cout << endl;
}

void multitest() {
	ll t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

void fastIO();

void preCalc();

int main()
{
#ifdef _OVERMINDS
	freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
#endif // _OVERMINDS
	preCalc();
	multitest();
}

void preCalc() {

}

void fastIO() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}