#include <iostream>
#include <vector>

using namespace std;

#define ll long long

pair<string, string> get_halves(string& s){
    auto it = s.find('=');
    string left = string(s.begin(), s.begin() + it);
    string right = string(s.begin() + it + 1, s.end());
    return make_pair(left, right);
}

struct token{
    int token_type;
    int number;
};

vector<token> get_tokens(string& s){
  string v;
  vector<token> tks;
  bool is_digit = false;
  for(auto& c : s){
      bool is_current_digit = c >= '0' && c <= '9';

      if(is_digit && !is_current_digit)
      {
          token tkn;
          tkn.token_type = 0;
          if(v[0] == '0' || v.size() > 10){
              tkn.token_type = -1;
          }
          tkn.number = stoll(v);
          tks.push_back(tkn);

          v = "";

          token tkn2;
          tkn2.token_type = c;
          tkn2.number = 0;
          tks.push_back(tkn2);
      }

      if(is_digit && is_current_digit){
          v.push_back(c);
      }

      if(!is_digit && is_current_digit){
          v.push_back(c);
      }

      if(!is_digit && !is_current_digit){
          token tkn;
          tkn.token_type = c;
          tkn.number = 0;
          tks.push_back(tkn);
      }

      is_digit = is_current_digit;
  }

  if(v != ""){
      token t;
      t.number = stoll(v);

      t.token_type = 0;
      if(v[0] == '0' || v.size() > 10){
          t.token_type = -1;
      }

      tks.push_back(t);
      v = "";
  }

  return tks;
}

vector<ll> get_vals(vector<token>& tokens){
    bool plus = true;
    vector<ll> res;
    for(int i = 0; i < tokens.size(); i++){
        auto token = tokens[i];
        if(token.token_type == '+'){
            plus = true;
        }else if(token.token_type == '-'){
            plus = false;
        }else{
            res.push_back((plus ? 1 : -1) * token.number);
        }
    }
    return res;
}

bool get_result(string& expr){
    auto p = get_halves(expr);
    auto left_tokens = get_tokens(p.first);
    auto right_tokens = get_tokens(p.second);
    for(auto tkn : left_tokens){
        if(tkn.token_type == -1){
            return false;
        }
    }

    for(auto tkn : right_tokens){
        if(tkn.token_type == -1){
            return false;
        }
    }

    auto left_vals = get_vals(left_tokens);
    auto right_vals = get_vals(right_tokens);

    ll left = 0;
    ll right = 0;
    for(auto l : left_vals){
        left += l;
    }

    for(auto r : right_vals){
        right += r;
    }

    return left == right;
}

int main() {
    string expr;
    cin >> expr;

    if(get_result(expr)){
        cout << "Correct" << endl;
        return 0;
    }

    for(int i = 0; i < expr.size(); i++){
        for(int j = 0; j < expr.size() - 1; j++){
            if(expr[i] < '0' || expr[i] > '9'){
                continue;
            }
            string tmp = string(expr.begin(), expr.end());
            auto t = tmp[i];
            tmp.erase(tmp.begin() + i);
            tmp.insert(tmp.begin() + j, t);

            if(get_result(tmp)){
                cout << tmp << endl;
                return 0;
            }
        }
    }

    cout << "Impossible" << endl;
    return 0;
}
