import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;

public class Main {

    public static BigInteger count(String s) {
        ArrayList<String> numbers = new ArrayList<>();
        ArrayList<String> zn = new ArrayList<>();
        String num = "";
        char[] b = s.toCharArray();
        for(int i = 0; i < b.length; ++i){
            if(b[i] >= '0' && b[i] <= '9'){
                num += b[i];
            }
            else{
                numbers.add(num);
                zn.add(b[i] + "");
                num = "";
            }
        }
        numbers.add(num);

        BigInteger result = new BigInteger(numbers.get(0));
        for(int i = 1; i < numbers.size(); ++i){
            if(zn.get(i - 1).equals("+")){
                result = result.add(new BigInteger(numbers.get(i)));
            }
            else{
                result = result.add(new BigInteger(numbers.get(i)).negate());
            }
        }
        return result;
    }

    public static boolean check(String s) {

        char[] b = s.toCharArray();
        for(int i = 0; i < b.length; ++i){
            if((b[i] == '+' || b[i] == '-' || b[i] == '=') && i + 1 < b.length &&  (b[i + 1] == '=' || b[i + 1] == '-' || b[i + 1] == '+')){
                return false;
            }
            if((b[i] == '+' || b[i] == '-' || b[i] == '=') && (i == 0 || i == b.length - 1)){
                return false;
            }
            if(b[i] == '0' && i + 1 < b.length && b[i + 1] >= '0' && b[i + 1] <= '9' && (i == 0 || i > 0 && !( b[i - 1] >= '0' && b[i - 1] <= '9')) ) {
                return false;
            }
        }

        String num = "";
        for(int i = 0; i < b.length; ++i){
            if(b[i] >= '0' && b[i] <= '9'){
                num += b[i];
                if(num.length() > 10){
                    return false;
                }
            }
            else{
                num = "";
            }
        }

        String[] equality = s.split("=");
        String left = equality[0];
        String right = equality[1];

        BigInteger l = count(left);
        BigInteger r = count(right);

        return l.equals(r);
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String s = reader.readLine();
        if(check(s)){
            System.out.println("Correct");
            return;
        }

        for(int i = 0; i < s.length(); ++i){
            if(s.charAt(i) == '-' || s.charAt(i) == '+' || s.charAt(i) == '='){
                continue;
            }
            for(int j = 0; j < s.length(); ++j){
                String newS = "";
                if(i == j){
                    newS = s;
                }
                else if(i < j){
                    newS = s.substring(0, i) + s.substring(i + 1, j) + s.charAt(i) + s.substring(j);
                }
                else {
                    if(i + 1 < s.length()) {
                        newS = s.substring(0, j) + s.charAt(i) + s.substring(j, i) + s.substring(i + 1);
                    }
                    else{
                        newS = s.substring(0, j) + s.charAt(i) + s.substring(j, i);
                    }
                }
                if(check(newS)){
                    System.out.println(newS);
                    return;
                }
            }
        }
        System.out.println("Impossible");
    }
}