#include <iomanip>
#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

void solve();

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}

void solve() {
	ll n, m, q;
	cin >> n >> m >> q;
	vector<pair<ll, ll>> task(n);
	vector<ll> ser(m);
	vector<ll> pref(m + 1);

	for (int i = 0; i < n; ++i) {
		cin >> task[i].first;
	}

	for (int i = 0; i < n; ++i) {
		cin >> task[i].second;
	}

	++n;
	task.push_back({ 0, 0 });

	for (int i = 0; i < m; ++i) {
		cin >> ser[i];
		pref[i + 1] = pref[i] + ser[i];
	}

	sort(task.begin(), task.end(), [](auto l, auto r) {
		return l.second < r.second;
		});

	vector<ll> st(n);
	vector<ll> need(n + 1);
	ll prev = 1e18;

	for (int i = n - 1; i >= 0; --i) {
		prev = min(prev - task[i].first, task[i].second - task[i].first);
		st[i] = prev;
	}

	for (int i = 0; i < n; ++i) {
		need[i + 1] = need[i] + task[i].first;
	}

	for (int i = 0; i < q; ++i) {
		ll t;
		cin >> t;

		auto res = upper_bound(st.begin(), st.end(), t) - st.begin();
		--res;

		ll waste = need[res] + min(task[res].first, t - st[res]);
		t -= waste;
		auto r = upper_bound(pref.begin(), pref.end(), t) - pref.begin();
		--r;
		cout << r << " ";
	}

	cout << "\n";
}