#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>
#include <stack>
#include <queue>
#include <cmath>


#define ll long long
#define forn(i,n) for(int i = 0; i < n; i++)
#define all(v) v.begin(), v.end()



using namespace std;

bool comp(pair<ll,ll> el1, pair<ll,ll> el2){
    return  el1.second > el2.second;
}

int main() {
    ll t;
    cin >> t;
    while(t--){
        ll n,m,q;
        cin >> n >> m >> q;
        vector<pair<ll,ll>> arr(n);
        forn(i,n){
            cin >> arr[i].first;
        }
        forn(i,n){
            cin >> arr[i].second;
        }

        vector<ll> series_duration(m);
        vector<ll> prefSummDuration(1);
        forn(i,m)
        {
            cin >> series_duration[i];
            prefSummDuration.push_back(prefSummDuration.back() + series_duration[i]);
        }

        sort(all(arr), comp);

        ll left = 1e16;
        vector<pair<ll, char>> line;
        forn(i, n){
            ll right = min(arr[i].second, left);
            left = right - arr[i].first;
            line.push_back({right,0}); // r = 0, q = 1, l = 2
            line.push_back({left,2});
        }

        map<ll, ll> qOrderSave;

        forn(i,q){
            ll q_current;
            cin >> q_current;
            qOrderSave[q_current] = i;
            line.push_back({q_current, 1});
        }

        sort(all(line));

        vector<ll> ans(q);

        ll completedTask = 0;
        ll currentLeft = -1;
        stack<ll> lefts;
        ll countWatched = 0;
        ll qCounter = 0;
        for (int i = 0; i < line.size(); i++){
            pair<ll,  char> currentPoint = line[i];
            if(currentPoint.second == 0){
                completedTask += currentPoint.first - lefts.top();
                lefts.pop();
            }
            else if(currentPoint.second == 2){
                lefts.push(currentPoint.first);
            } else{
                ll time = currentPoint.first;
                time -= completedTask;
                if(!lefts.empty()){
                    time -= currentPoint.first - lefts.top();
                }
                while (countWatched < m && time >= prefSummDuration[countWatched + 1])
                    countWatched++;

                ans[qOrderSave[currentPoint.first]] = countWatched;
            }
        }

        forn(i, q){
            cout << ans[i] << " ";
        }

        cout << endl;
    }
}
