#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <bits/stdc++.h>
#define int long long

#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()

using namespace std;

bool is_digit(char c) {
    return '0' <= c && c <= '9';
}

bool check(const string &s) {
    int in_row = 0;
    int n = len(s);
    for (int i = 0; i < n; i++) {
        if (s[i] == '+' || s[i] == '-') {
            in_row = 0;
            if (i == 0 || !is_digit(s[i - 1])) {
                return false;
            }
            if (i + 1 == n || !is_digit(s[i + 1])) {
                return false;
            }
        }
        if (is_digit(s[i])) {
            in_row++;
            if (i + 1 == n || !is_digit(s[i + 1])) {
                if (in_row > 10 || (in_row > 1 && s[i - in_row + 1] == '0')) {
                    return false;
                }
            }
        }
    }
    return true;
}

int evaluate(const string &s) {
    if (s.empty()) {
        return false;
    }
    int res = 0;
    int in_row = 0;
    int current = 0;
    int n = len(s);
    for (int i = 0; i < n; i++) {
        if (is_digit(s[i])) {
            current = current * 10 + (s[i] - '0');
            in_row++;
            if (i + 1 == n || !is_digit(s[i + 1])) {
                if (i == in_row - 1 || s[i - in_row] == '+') {
                    res += current;
                } else {
                    res -= current;
                }
            }
        } else {
            in_row = 0;
            current = 0;
        }
    }
    return res;
}

string to_string(char c) {
    return string(1, c);
}

bool check_eq(const string &s) {
    int equal_sign = s.find('=');
    string l = s.substr(0, equal_sign);
    string r = s.substr(equal_sign + 1);
    if (check(l) && check(r) && evaluate(l) == evaluate(r)) {
        return true;
    }
    return false;
}

int32_t main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    string s;
    cin >> s;
    if (check_eq(s)) {
        cout << "Correct";
        return 0;
    }
    int n = len(s);
    for (int i = 0; i < n; i++) {
        if (is_digit(s[i])) {
            char c = s[i];
            s.erase(s.begin() + i, s.begin() + i + 1);
            string t = to_string(c) + s;
            if (check_eq(t)) {
                cout << t;
                return 0;
            }
            for (int j = 0; j < n - 1; j++) {
                swap(t[j], t[j + 1]);
                if (check_eq(t)) {
                    cout << t;
                    return 0;
                }
            }
            s.insert(i, to_string(c));
        }
    }
    cout << "Impossible";
}
