#include <bits/stdc++.h>

using namespace std;
using ll = long long ;
using ull = unsigned long long;
using ld = long double;
struct triple{
    ll first, second, third;
    auto operator<=>(const triple&) const = default;
};

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

using pll = pair<ll,ll>;
using vll = vector<pll>;
using vvll = vector<vll>;

using vlll = vector<triple>;
using vvlll = vector<vlll>;

using vs = vector<string>;
using vld = vector<ld>;

#define fi first
#define se second
#define th third

#define X first
#define Y second
#define Z third

#define con continue
#define pb push_back
#define re return

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(x) (int)(x).size()

template <typename T>
inline void sort(T & v) {
    sort(all(v));
}

template <typename T>
inline void reverse(T & v) {
    reverse(all(v));
}

template <typename T>
inline void unique( T & v) {
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
}

template <typename T>
void smin(T& s, const T& ot) {
    s = min(s, ot);
}

template <typename T>
void smax(T& s, const T& ot) {
    s = max(s, ot);
}

template <typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.fi >> p.se; return in;
}

template <typename T>
istream& operator>>(istream &in, vector<T> &p) {
    for (auto &x : p) in >> x; return in;
}

template <typename T>
ostream& operator<<(ostream &ostr, const vector<T> &v) {
    for (const auto& el : v) cout << el << ' ';
    return ostr;
}

template <typename T1, typename T2>
ostream& operator<<(ostream &out, pair<T1, T2> &p) {
    out << p.fi << p.se; return out;
}

//template <typename T1, typename T2>
//ostream& operator<<(ostream &out, pair<T1, T2> &p) {
//    out << p.fi << p.se; return out;
//}
/*
void solve()
{
    ll ans = 0;
    cin >> n;
    vector<ll> v(n);
    cin >> v;
    for(int i  = 0; i < n; i++) {
        ll tmp = v[i] - 1;
        ans += tmp + (n - v[i]);
    }
    cout << ans;
}
*/

void solve() {
    ll n;
    cin >> n;

    vll ops(n);
    for (ll i = 0; i < n; i++) {
        string s1, s2;
        cin >> s1 >> s2;

        if (s1 == "set") {
            if (s2 == "true") ops[i] = {0, 1};
            else ops[i] = {1,1};
        }
        else {
            if (s2 == "true") ops[i] = {1,0};
            else ops[i] = {0,0};
        }
    }

    vl needs(n);
    vvl adj(n);
    ll m;
    cin >> m;

    for (ll i = 0; i < m;i++) {
        ll a, b;
        cin >> a >> b; a--;b--;
        needs[b]++;
        adj[a].push_back(b);
    }

    queue<ll> loops[2];
    queue<ll> trans[2];

    for (ll y = 0; y < n; y++) {
        if (needs[y] == 0) {
            auto oo = ops[y];
            if (oo.first == 0 && oo.second == 0) loops[0].push(y);
            else if (oo.first == 1 && oo.second == 1) loops[1].push(y);
            else if (oo.first == 0 && oo.second == 1) trans[0].push(y);
            else trans[1].push(y);
        }
    }


    vl ans;
    ll cur = 0;
    while (loops[cur].size() || trans[cur].size()) {
        ll op = 0;
        if (loops[cur].size()) {
            ll v = loops[cur].front();
            loops[cur].pop();
            ans.push_back(v + 1);
            op = v;
        }
        else {
            ll v = trans[cur].front();
            trans[cur].pop();
            ans.push_back(v + 1);
            op = v;
            cur = 1 - cur;
        }

        for (auto y : adj[op]) {
            needs[y]--;
            if (needs[y] == 0) {
                auto oo = ops[y];
                if (oo.first == 0 && oo.second == 0) loops[0].push(y);
                else if (oo.first == 1 && oo.second == 1) loops[1].push(y);
                else if (oo.first == 0 && oo.second == 1) trans[0].push(y);
                else trans[1].push(y);
            }
        }
    }

    if (ans.size() == n) cout << ans << endl;
    else cout << -1 << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    // cin >> t;
    while(t--)
        solve();

    return 0;
}
