#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define ll long long
#define all(a) a.begin(), a.end()

using namespace std;

struct task {
	ll time, deadline;
};

bool cmp(task a, task b) {
	return (a.deadline - a.time) < (b.deadline - b.time);
}

void solve() {

	///=================================================
	ll n, m, q;
	cin >> n >> m >> q;

	vector <task> tasks(n);
	
	for (ll i = 0, x; i < n; i++) {
		cin >> x;
		tasks[i].time = x;
	}

	for (ll i = 0, x; i < n; i++) {
		cin >> x;
		tasks[i].deadline = x;
	}

	vector <ll> l;
	for (ll i = 0, x; i < m; i++) {
		cin >> x;
		l.push_back(x);
	}

	vector <pair <ll, ll> > t;
	for (ll i = 0, x; i < q; i++) {
		cin >> x;
		t.push_back({ x, i});
	}
///=================================================

	sort(all(tasks), cmp);

	vector <pair <ll, ll> > v;
	v.push_back({ tasks[0].deadline - tasks[0].time, tasks[0].deadline });

	for (ll i = 1; i < n; i++) {
		ll l = tasks[i].deadline - tasks[i].time;
		ll r = tasks[i].deadline;

		bool kl = false;

		while (!v.empty()) {
			ll left = v.back().first;
			ll right = v.back().second;
			if (left <= l && right >= l) {
				ll dop = right - l;
				left -= dop;
				right = r;
				l = left;
				r = right;
				v.pop_back();
			}
			else {
				kl = true;
				v.push_back({ l, r });
				break;
			}
		}
		if (!kl) {
			v.push_back({ l, r });
		}
	}

	sort(all(t));
	ll j = 0;
	vector <ll> ans(q, 0);

	ll sum = 0;

	ll len = v.size();


	for (ll i = 0; i < q; i++) {
		ll x = t[i].first;
		if (j >= len) {
			ll res = x - sum;
			ans[t[i].second] = res;
			continue;
		}

		if (v[j].first <= x && v[j].second >= x) {
			ll res = x - sum - (x - v[j].first);
			ans[t[i].second] = res;
		}
		else if (v[j].second < x) {
			sum += (v[j].second - v[j].first);
			j++;
			i--;
		}
	}

	for (ll i = 1; i < m; i++) {
		l[i] += l[i - 1];
	}

	

	for (ll i = 0; i < q; i++) {
		if (l[m - 1] >= ans[i]) {
			ll x = (upper_bound(l.begin(), l.end(), ans[i]) - l.begin());
			x--;
			cout << x+1 << " ";
		}
		else cout << m << " ";
	}

	cout << "\n";

}

signed main() {
	ll q;
	cin >> q;
	
	while (q--) {
		solve();
	}
}