#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<int> get_dif(const vector<int> &v1,const vector<int> &v2){
    vector<int> dif(4);
    for(int i = 0; i < 4; i++){
        dif[i] = v1[i] - v2[i];
    }
    return dif;
}
bool cmp(const set<pair<vector<int>, vector<int>>>& set1,
         const set<pair<vector<int>, vector<int>>>& set2) {
    assert(set1.size() == set2.size());
    vector<int> dif = get_dif(set1.begin()->first, set2.begin()->first);
    auto it1 = set1.begin();
    auto it2 = set2.begin();
    int n = set1.size();
    for (int i = 0; i < n; ++i) {
        auto dif_f = get_dif(it1->first, it2->first);
        auto dif_s = get_dif(it1->second, it2->second);
        if (dif != dif_f){
            return false;
        }
        if (dif != dif_s) {
            return false;
        }
        it1 = next(it1); it2 = next(it2);
    }
    return true;
}
vector<int> get_change(int degree, int val){
    if (degree == 0){
        return {val, 0, 0, 0};
    } else if (degree == 45){
        return {0, 0, val, 0};
    } else if (degree == 90){
        return {0, val, 0, 0};
    } else if (degree == 135){
        return {0, 0, 0, val};
    } else if (degree == 180){
        return {-val, 0, 0, 0};
    } else if (degree == 225){
        return {0, 0, -val, 0};
    } else if (degree == 270){
        return {0, -val, 0, 0};
    } else if (degree == 315) {
        return {0, 0, 0, -val};
    }
    assert(false);
}

int get_dif_i(pair<vector<int>, vector<int>>& p){
    for (int i = 0; i < 4; i++){
        if (p.first[i] != p.second[i]){
            return i;
        }
    }
    return -1;
}

pair<bool, pair<vector<int>, vector<int>>> merge(pair<vector<int>, vector<int>> &p1,
                                                pair<vector<int>, vector<int>>& p2) {
    if (p1.second == p2.first){
        if (get_dif_i(p1) == get_dif_i(p2)){
            return {true, {p1.first, p2.second}};
        }
    }
    if (p1.first == p2.second){
        if (get_dif_i(p1) == get_dif_i(p2)){
            return {true, {p1.second, p2.first}};
        }
    }
    return {false, {}};
}
set<pair<vector<int>, vector<int>>> f(set<pair<vector<int>, vector<int>>>& p_){
    set<pair<vector<int>, vector<int>>> ret;
    vector<pair<vector<int>, vector<int>>> p;
    for (auto &x : p_){
        p.push_back(x);
    }
    int n = p.size();
    for (int i = 0; i < n; i++) {
        bool g = 0;
        for (int j = i+1; j < n; j++){
            auto [fl, val] = merge(p[i], p[j]);
            if (fl){
                p[j] = val;
                g = 1;
                break;
            }
        }
        if (!g){
            ret.insert(p[i]);
        }
    }
    return ret;
}
set<pair<vector<int>, vector<int>>> gen_paint(vector<pair<int, int>>& ops, int degree = 0){
    set<pair<vector<int>, vector<int>>> paint;
    vector<int> cur(4);
    if (degree >= 360){
        degree -= 360;
    }
    for (auto &[op, val] : ops){
        if (op == 0) {
            degree += val;
            if (degree >= 360){
                degree -= 360;
            }
        } else if (op == 1){
            auto change = get_change(degree, val);
            for (int i = 0; i < 4; i++){
                cur[i] += change[i];
            }
        } else {
            pair<vector<int>, vector<int>> p;
            p.first = cur;
            auto change = get_change(degree, val);
            for (int i = 0; i < 4; i++){
                cur[i] += change[i];
            }
            p.second = cur;
            if (p.first > p.second){
                swap(p.first, p.second);
            }
            paint.insert(p);
        }
    }

    return f(paint);
}
signed main() {
    set<pair<vector<int>, vector<int>>> main_paint;
    vector<pair<int, int>> op;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        string s;
        int num;
        cin >> s >> num;
        if (s == "draw") {
            op.emplace_back(2, num);
        } else if (s == "move") {
            op.emplace_back(1, num);
        } else {
            op.emplace_back(0, num);
        }
    }
    main_paint = gen_paint(op);
    for (int i = 1; i <= 8; i++){
        auto paint = gen_paint(op, 45*i);
        if (cmp(main_paint, paint)){
            cout << 45*i << '\n';
            return 0;
        }
    }
    assert(false);

}


