#define _GLIBCXX_DEBUG 1
#pragma gcc optimize ("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define rsort(a) sort(a, [&] (auto b, auto c) {return b > c;})
using ll = long long;
using ld = long double;
using ull = unsigned long long; 
const ll inf = 1e18;
const ll MOD = 998244353;

void dfs_ts(ll v, vector<ll>& used, vector<vector<ll>>&g, vector<ll>& ts, set<ll>& subset)
{
    used[v] =  1;
    for (ll u : g[v])
    {
        if (!used[u] && subset.count(u))
        {
            dfs_ts(u,used,g,ts, subset);
        }
    }
    ts.push_back(v);
}

void dfs_u(ll v, vector<ll>& used, vector<vector<ll>>&g)
{
    used[v] =  1;
    for (ll u : g[v])
    {
        if (!used[u])
        {
            dfs_u(u,used,g);
        }
    }
}

vector<ll> topsort(vector<vector<ll>>& g, set<ll>& subset)
{
    ll n = g.size();
    vector<ll> ts;
    vector<ll> used(n, 0);
    for (int i = 0; i < n; ++i)
    {
        if (!used[i] && subset.count(i))
        {
            dfs_ts(i,used,g,ts, subset);
        }
    }
    reverse(all(ts));
    return ts;
}

signed main(){
    ll n; cin >> n;
    set<ll> st, uf, ut, sf;
    for (int i  =0; i < n; ++i)
    {
        string op, res; cin >> op >> res;
        if (op == "set" && res == "true")
        {
            st.insert(i);
        }
        if (op == "set" && res == "false")
        {
            sf.insert(i);
        }
        if (op == "unset" && res == "true")
        {
            ut.insert(i);
        }
        if (op == "unset" && res == "false")
        {
            uf.insert(i);
        }
    }
    vector<vector<ll>> g(n);
    ll m; cin >> m;
    for (int i = 0; i < m;++i)
    {
        ll a, b; cin >> a >> b;
        --a;--b;
        g[a].push_back(b);
    }

    if (st.size() == 0 && ut.size() == 0)
    {
        if (sf.size() > 0)
        {
            cout << -1 << '\n';
        }
        else
        {
            vector<ll> ts = topsort(g, uf);
            for (auto mem : ts)
            {
                cout << mem + 1 << " ";
            }
            cout << '\n';
        }
    }
    else if (st.size() == 1 && ut.size() == 0)
    {
        vector<ll> used(n, 0);
        for (auto v : sf)
        {
            if (!used[v])
            {
                dfs_u(v,used,g);
            }
        }
        bool ok = true;
        for (auto v : uf)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        for (auto v : st)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        used.assign(n, 0);
        dfs_u(*st.begin(), used, g);
        for (auto v : uf)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        if (!ok)
        {
            cout << -1 << '\n';
            return 0;
        }

        auto ts1 = topsort(g, uf);
        auto ts2 = topsort(g, st);
        auto ts3 = topsort(g, sf);
        for (auto mem : ts1)
        {
            cout << mem + 1 << " ";
        }
        for (auto mem : ts2)
        {
            cout << mem + 1 << " ";
        }
        for (auto mem : ts3)
        {
            cout << mem + 1 << " ";
        }
        cout << '\n';

    }
    else if (st.size() == 1 && ut.size() == 1)
    {
        vector<ll> used(n, 0);
        set<ll> uf1, uf2;
        dfs_u(*ut.begin(), used, g);
        dfs_u(*st.begin(), used, g);
        for (auto v : sf)
        {
            if (!used[v])
            {
                dfs_u(v,used,g);
            }
        }

        for (auto v : uf)
        {
            if (used[v])
            {
                uf2.insert(v);
            }
            else
            {
                uf1.insert(v);
            }
        }
        
        used.assign(n, 0);
        for (auto v : uf2)
        {
            if (!used[v])
            {
                dfs_u(v,used,g);
            }
        }
        
        bool ok = true;
        for (auto v : ut)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        for (auto v : sf)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        for (auto v : st)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        for (auto v : uf1)
        {
            if (used[v])
            {
                ok = false;
            }
        }

        
        for (auto v : ut)
        {
            if (!used[v])
            {
                dfs_u(v,used,g);
            }
        }
        
        for (auto v : sf)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        for (auto v : st)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        for (auto v : uf1)
        {
            if (used[v])
            {
                ok = false;
            }
        }

        
        for (auto v : sf)
        {
            if (!used[v])
            {
                dfs_u(v,used,g);
            }
        }


        for (auto v : st)
        {
            if (used[v])
            {
                ok = false;
            }
        }
        for (auto v : uf1)
        {
            if (used[v])
            {
                ok = false;
            }
        }

        
        for (auto v : st)
        {
            if (!used[v])
            {
                dfs_u(v,used,g);
            }
        }
        for (auto v : uf1)
        {
            if (used[v])
            {
                ok = false;
            }
        }

        if (ok == false)
        {
            cout << -1 << '\n';
            return 0;
        }
        

        auto ts1 = topsort(g, uf1);
        auto ts2 = topsort(g, st);
        auto ts3 = topsort(g, sf);
        auto ts4 = topsort(g, ut);
        auto ts5 = topsort(g, uf2);
        for (auto mem : ts1)
        {
            cout << mem + 1 << " ";
        }
        for (auto mem : ts2)
        {
            cout << mem + 1 << " ";
        }
        for (auto mem : ts3)
        {
            cout << mem + 1 << " ";
        }
        for (auto mem : ts4)
        {
            cout << mem + 1 << " ";
        }
        for (auto mem : ts5)
        {
            cout << mem + 1 << " ";
        }
        cout << '\n';
    }
    else
    {
        cout << -1 << '\n';
    }

}