#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
mt19937 engine;

void solve();
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	engine.seed(time(nullptr));

	ll T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

pair<int, int> ops[100001];
vector<int> g[100001];

int chUn[100001];

set<int> s1;
set<int> s2;
set<int> s3;

void checkUn(int v) {
	if (ops[v].first) {
		chUn[v] = 1;
		return;
	}

	if (ops[v].second) {
		chUn[v] = 1;
		return;
	}

	chUn[v] = 2;

	for (int e : g[v]) {
		if (!chUn[e]) {
			checkUn(e);
		}

		chUn[v] = min(chUn[e], chUn[v]);
	}
}

vector<int> tin1;
vector<int> tin2;
vector<int> tin3;

bool used[100001];

void dfsTin(int v, set<int>& s, vector<int>& tin) {
	used[v] = true;

	tin.push_back(v);

	for (int e : g[v]) {
		if (used[e] || s.find(e) == s.end()) continue;

		dfsTin(e, s, tin);
	}
}

void solve() {
	int n;
	cin >> n;

	int cntUn = 0;
	int cntS = 0;

	for (int i = 1; i <= n; ++i) {
		string op, res;
		cin >> op >> res;

		ops[i] = { op == "set", res == "true" };

		if (ops[i].first == 0) cntUn += ops[i].second;
		if (ops[i].first == 1) cntS += ops[i].second;
	}

	if (cntUn == 2 || cntS == 2) {
		cout << -1;
		return;
	}

	int m;
	cin >> m;

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;

		g[a].push_back(b);
	}

	for (int i = 1; i <= n; ++i) {
		if (ops[i].first) {
			s2.insert(i);
			continue;
		}

		if (!chUn[i]) checkUn(i);

		if (chUn[i] == 1) s1.insert(i);
		else s3.insert(i);

		if (ops[i].second) {
			s1.erase(i);
			s3.insert(i);
		}
	}

	for (int e : s1) {
		if (used[e]) continue;
		dfsTin(e, s1, tin1);
	}

	reverse(tin1.begin(), tin1.end());

	int sT = 0;

	for (int e : s2) {
		if (ops[e].second) {
			sT = e;
			continue;
		}

		if (used[e]) continue;

		dfsTin(e, s2, tin2);
	}

	if (!sT && s2.size()) {
		cout << "-1";
		return;
	}

	if (sT && used[sT]) {
		cout << "-1";
		return;
	}

	dfsTin(sT, s2, tin2);

	reverse(tin2.begin(), tin2.end());


	sT = 0;

	for (int e : s3) {
		if (ops[e].second) {
			sT = e;
			continue;
		}

		if (used[e]) continue;

		dfsTin(e, s3, tin3);
	}

	if (!sT && s3.size()) {
		cout << "-1";
		return;
	}

	if (sT && used[sT]) {
		cout << "-1";
		return;
	}

	dfsTin(sT, s3, tin3);

	reverse(tin3.begin(), tin3.end());

	for (int e : tin1) cout << e << " ";
	for (int e : tin2) cout << e << " ";
	for (int e : tin3) cout << e << " ";
}