#include <bits/stdc++.h>

using namespace std;

std::vector<std::pair<int, int> > delta = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

void getCount(const std::vector<std::string> &sp, std::vector<std::vector<bool> > &used, int i, int j, int &c1, int &c2, int n) {
    used[i][j] = true;
    c1 += (i + j) % 2;
    c2 += (i + j + 1) % 2;
    if (i == 0 && !used[i + 1][j] && sp[i + 1][j] == '.') {
        getCount(sp, used, i + 1, j, c1, c2, n);
    }
    if (i == 1 && !used[i - 1][j] && sp[i - 1][j] == '.') {
        getCount(sp, used, i - 1, j, c1, c2, n);
    }
    if (j + 1 != n && !used[i][j + 1] && sp[i][j + 1] == '.') {
        getCount(sp, used, i, j + 1, c1, c2, n);
    }
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<std::string> sp(2);
    for (int i = 0; i < 2; ++i) {
        std::cin >> sp[i];
    }
    std::vector<std::vector<bool> > used(2, std::vector<bool>(n));
    for (int j = 0; j < n; ++j) {
        for (int i = 0; i < 2; ++i) {
            if (sp[i][j] == '.' && !used[i][j]) {
                int c1 = 0;
                int c2 = 0;
                getCount(sp, used, i, j, c1, c2, n);
                if (c1 != c2) {
                    std::cout << "None\n";
                    return;
                }
            }
        }
    }
    std::set<std::pair<int, int> > edges[2][n];
    std::set<std::pair<int, int> > cnt[4];
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (sp[i][j] == '#') {
                continue;
            }
            for (auto [di, dj] : delta) {
                int ci = i + di;
                int cj = j + dj;
                if (!(0 <= ci && ci <= 1 && 0 <= cj && cj < n)) {
                    continue;
                }
                if (sp[ci][cj] == '.') {
                    edges[i][j].insert({ci, cj});
                }
            }
            cnt[edges[i][j].size()].insert({i, j});
        }
    }
    while(cnt[1].size() != 0) {
        std::pair<int, int> cur = *cnt[1].begin();
        int i = cur.first;
        int j = cur.second;
        cnt[1].erase(cnt[1].begin());
        std::pair<int, int> edge = *edges[i][j].begin();
        int k = edge.first;
        int l = edge.second;
        for (auto [di, dj] : delta) {
            int ci = i + di;
            int cj = j + dj;
            if (!(0 <= ci && ci <= 1 && 0 <= cj && cj < n)) {
                continue;
            }
            if (sp[ci][cj] == '#') {
                continue;
            }
            cnt[edges[ci][cj].size()].erase({ci, cj});
            edges[ci][cj].erase({i, j});
            cnt[edges[ci][cj].size()].insert({ci, cj});

            cnt[edges[i][j].size()].erase({i, j});
            edges[i][j].erase({ci, cj});
            cnt[edges[i][j].size()].insert({i, j});
        }
        for (auto [dk, dl] : delta) {
            int ck = k + dk;
            int cl = l + dl;
            if (!(0 <= ck && ck <= 1 && 0 <= cl && cl < n)) {
                continue;
            }
            if (sp[ck][cl] == '#') {
                continue;
            }
            cnt[edges[ck][cl].size()].erase({ck, cl});
            edges[ck][cl].erase({k, l});
            cnt[edges[ck][cl].size()].insert({ck, cl});

            cnt[edges[k][l].size()].erase({k, l});
            edges[k][l].erase({ck, cl});
            cnt[edges[k][l].size()].insert({k, l});
        }
        sp[i][j] = '#';
        sp[k][l] = '#';
        cnt[0].erase({i, j});
        cnt[0].erase({k, l});
    }
    if (!cnt[0].empty()) {
        std::cout << "None\n";
        return;
    }
    if (!cnt[2].empty() || !cnt[3].empty()) {
        std::cout << "Multiple\n";
        return;
    }
    std::cout << "Unique\n";
    return;
}

void IOSync() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
}

int32_t main() {
    IOSync();
    int tests = 1;
    std::cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
