#include <iostream>
#include <vector>

using namespace std;

int add(int a, int b) {
    return (a + b >= 2 ? 2 : a + b);
}

int get_mask(char a) {
    return (a == '#' ? 1 : 0);
}

void solve() {
    int n; cin >> n;
    vector<int> masks(n);
    string s, t; cin >> s >> t;
    for (int i = 0; i < n; i++) {
        masks[i] = (get_mask(s[i]) << 1) ^ (get_mask(t[i]));
    }
    vector<vector<int>> dp(n + 1, vector<int>(4, 0));
    dp[0][3] = 1;
    for (int i = 0; i < n; i++) {
        int mask = masks[i];
        for (int placement = 0; placement < 4; placement++) {
            if ((placement & mask) != 0) continue;
            dp[i + 1][mask | placement] = add(dp[i + 1][mask | placement], dp[i][placement ^ 3]);
        }
        if (mask == 0) dp[i + 1][3] = add(dp[i + 1][3], dp[i][3]);
    }

    // for (int i = 1; i <= n; i++) {
    //     cerr << "BEGIN " << i << endl;
    //     cerr << masks[i - 1] << endl;
    //     for (int mask = 0; mask < 4; mask++) {
    //         cerr << mask << ' ' << dp[i][mask] << endl;
    //     }
    //     cerr << "END" << endl;
    // }

    if (dp[n][3] == 0) {
        cout << "None" << endl;
    } else if (dp[n][3] == 1) {
        cout << "Unique" << endl;
    } else if (dp[n][3] > 1) {
        cout << "Multiple" << endl;
    }
}

int main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}