#include <bits/stdc++.h>
#define size(a) (ll)(a).size()
#define int long long

using namespace std;
typedef long double ld;
typedef long long ll;

const int INF = INT_MAX;
const int INF_LL = LLONG_MAX;
const ld EPS = 1e-9;
const ll MOD = 1e9 + 7;

void addit(bool is_positive, bool is_left, int& cur_number,
           int& cur_left, int& cur_right) {
    if (!is_positive) {
        cur_number *= -1;
    }

    if (is_left) {
        cur_left += cur_number;
    } else {
        cur_right += cur_number;
    }
    cur_number = 0;
}

pair<int, int> eval_string(string s) {
    int cur_left = 0;
    int cur_right = 0;

    int cur_number = 0;
    bool is_positive = true;
    bool is_left = true;
    bool is_start = true;
    bool is_alert = false;
    int last_digit = -1;
    for (char c: s) {
        if (c == '-') {
            addit(is_positive, is_left, cur_number, cur_left, cur_right);
            is_positive = false;
            is_start = true;
            last_digit = -1;
            is_alert = false;
        } else if (c == '+') {
            addit(is_positive, is_left, cur_number, cur_left, cur_right);
            is_positive = true;
            is_start = true;
            last_digit = -1;
            is_alert = false;
        } else if (c == '=') {
            addit(is_positive, is_left, cur_number, cur_left, cur_right);
            is_positive = true;
            is_left = false;
            is_start = true;
            last_digit = -1;
            is_alert = false;
        } else {
            int num = (int)(c - '0');
            if (is_alert) {
                return {-1, 0};
            }

            if (is_start and num == 0) {
                is_alert = true;
            } else {
                is_alert = false;
            }

            cur_number *= 10;
            cur_number += num;
            last_digit = num;
            is_start = false;

            if (cur_number > 9'999'999'999) {
                return {-1, 0};
            }
        }
    }
    addit(is_positive, is_left, cur_number, cur_left, cur_right);
    return {cur_left, cur_right};
}

void solve() {
    string s;
    cin >> s;
    auto [left, right] = eval_string(s);
    if (left == right) {
        cout << "Correct\n";
        return;
    }

    for (int i = 0; i < size(s); ++i) {
        char cur = s[i];
        if (cur > '9' or cur < '0') {
            continue;
        }
        string s_cp = s;
        s_cp.erase(i + s_cp.begin());
        for (int j = 0; j < size(s); ++j) {
            string cur_s = "";
            for (int k = 0; k < size(s_cp); ++k) {
                if (k == j) {
                    cur_s.push_back(cur);
                }
                cur_s.push_back(s_cp[k]);
            }
            if (j == size(s) - 1) {
                cur_s.push_back(cur);
            }

            auto [cur_l, cur_r] = eval_string(cur_s);
//            cout << cur_s << ' ' << cur_l << ' ' << cur_r << "\n";
            if (cur_l == cur_r) {
                cout << cur_s << "\n";
                return;
            }
        }
    }

    cout << "Impossible\n";
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
